Scriptname _MWA_Api extends Quest  

_MWA_SanityChecker Property SanityChecker Auto
_MWA_CombatArmor Property CombatArmor Auto
_MWA_Utility Property Util Auto

Event OnInit()
	RegEvents()
EndEvent

Function PlayerLoadsGame()
	RegEvents()
EndFunction

Function RegEvents()
	RegisterForModEvent("_MWA_DamageArmorSlot", "On_MWA_DamageArmorSlot")
	RegisterForModEvent("_MWA_AddFittedObject", "On_MWA_AddFittedObject")
	;RegisterForModEvent("_MWA_DamageArmorSlotWithSound", "On_MWA_DamageArmorSlotWithSound")
EndFunction

;/
	int DamageArmorEvent = ModEvent.Create("_MWA_DamageArmorSlot")
	if (DamageArmorEvent)
		ModEvent.PushInt(DamageArmorEvent, ArmorSlot)
		ModEvent.PushInt(DamageArmorEvent, NumberOfStrikes)
		ModEvent.Send(DamageArmorEvent)
	endIf
/;

Event On_MWA_DamageArmorSlot(Int Slot, Int StrikeCount, Form Sender)
	ObjectReference ObjRef = SanityChecker.GetObjRefInSlot(Slot)
	If ObjRef != None
		CombatArmor.ApiDamageArmorSlot(ObjRef, StrikeCount, Sender)
	Else
		Debug.Trace("_MWA_: On_MWA_DamageArmorSlot: Warning: Requested armor hit on a None ObjRef")
	EndIf
EndEvent

Event On_MWA_AddFittedObject(Form akTarget, Form akBaseObject, Float DurMinMod, Float DurMaxMod, Bool Silent, Bool FitLoosely = false, Float CursedChance = 0.0) ; DurMin/DurMax: 0.0 - 1.0
	;Debug.Messagebox("recieve")
	; FitLoosely - Whether or not the item should exactly fit the target. True - exact match. False - Not exact but close enough to be within suitability tolerance so it can be equipped.
	
	Actor akActor = akTarget as Actor
	If akActor && akBaseObject
		DurMinMod = PapyrusUtil.ClampFloat(DurMinMod, 0.0, 1.0)
		DurMaxMod = PapyrusUtil.ClampFloat(DurMaxMod, 0.0, 1.0)
		ObjectReference ObjRef = akActor.PlaceAtMe(akBaseObject, aiCount = 1, abForcePersist = false, abInitiallyDisabled = true)
		Util.GetDurability(ObjRef, akBaseObject, ForceUpdate = true, IsWorn = false)
		Int DurMax = StorageUtil.GetIntValue(ObjRef, "_MWA_DurabilityMax")
		Int NewDur = Utility.RandomInt(Math.Floor(DurMax * DurMinMod), Math.Ceiling(DurMax * DurMaxMod))
		If NewDur < 1
			NewDur = 1
		EndIf
		StorageUtil.SetIntValue(ObjRef, "_MWA_Durability", NewDur)
		
		If  CursedChance > Utility.RandomFloat(0.0, 100.0)
			StorageUtil.SetIntValue(ObjRef, "_MWA_IsCursedObject", 1)
		Else
			StorageUtil.SetIntValue(ObjRef, "_MWA_IsCursedObject", 0)
		EndIf
		Util.FitToActor(ObjRef, akActor, akBaseObject, FitLoosely = FitLoosely)
		Util.DispItemDurability (ObjRef, akBaseObject, 0.0)
		
		ObjRef.Enable()
		akActor.AddItem(ObjRef, 1, Silent)
		
	Else
		Debug.Trace("_MWA_: On_MWA_AddFittedObject: Received invalid parameters")
	EndIf
EndEvent
