Scriptname _MWA_ArmorDestruction extends Quest  
 
; EVENTS ==============================================================================
Event OnInit()
	SearchBoxes = new ObjectReference[128]
	SearchBoxes[0] = _MWA_ObjectSearch001
	SearchBoxes[1] = _MWA_ObjectSearch002
	SearchBoxes[2] = _MWA_ObjectSearch003
	SearchBoxes[3] = _MWA_ObjectSearch004
	SearchBoxes[4] = _MWA_ObjectSearch005
	SearchBoxes[5] = _MWA_ObjectSearch006
	SearchBoxes[6] = _MWA_ObjectSearch007
	SearchBoxes[7] = _MWA_ObjectSearch008
	SearchBoxes[8] = _MWA_ObjectSearch009
	SearchBoxes[9] = _MWA_ObjectSearch010
	SearchBoxes[10] = _MWA_ObjectSearch011
	SearchBoxes[11] = _MWA_ObjectSearch012
	SearchBoxes[12] = _MWA_ObjectSearch013
	SearchBoxes[13] = _MWA_ObjectSearch014
	SearchBoxes[14] = _MWA_ObjectSearch015
	SearchBoxes[15] = _MWA_ObjectSearch016
	SearchBoxes[16] = _MWA_ObjectSearch017
	SearchBoxes[17] = _MWA_ObjectSearch018
	SearchBoxes[18] = _MWA_ObjectSearch019
	SearchBoxes[19] = _MWA_ObjectSearch020
	SearchBoxes[20] = _MWA_ObjectSearch021
	SearchBoxes[21] = _MWA_ObjectSearch022
	SearchBoxes[22] = _MWA_ObjectSearch023
	SearchBoxes[23] = _MWA_ObjectSearch024
	SearchBoxes[24] = _MWA_ObjectSearch025
	SearchBoxes[25] = _MWA_ObjectSearch026
	SearchBoxes[26] = _MWA_ObjectSearch027
	SearchBoxes[27] = _MWA_ObjectSearch028
	SearchBoxes[28] = _MWA_ObjectSearch029
	SearchBoxes[29] = _MWA_ObjectSearch030
	SearchBoxes[30] = _MWA_ObjectSearch031
	SearchBoxes[31] = _MWA_ObjectSearch032
	SearchBoxes[32] = _MWA_ObjectSearch033
	SearchBoxes[33] = _MWA_ObjectSearch034
	SearchBoxes[34] = _MWA_ObjectSearch035
	SearchBoxes[35] = _MWA_ObjectSearch036
	SearchBoxes[36] = _MWA_ObjectSearch037
	SearchBoxes[37] = _MWA_ObjectSearch038
	SearchBoxes[38] = _MWA_ObjectSearch039
	SearchBoxes[39] = _MWA_ObjectSearch040
EndEvent
; CUSTOM EVENTS =======================================================================

; FUNCTIONS ===========================================================================

Function DestroyObject(ObjectReference ObjRef, Form ObjectBase, Int HandSlot)
	Debug.Trace("_MWA_: DestroyObject: ObjRef: " + ObjRef + ". ObjectBase: " + ObjectBase + ". HandSlot: " + HandSlot)
	If ObjRef != None && !SanityChecker.WornListUpdateInProgress ; Check ObjRef is not bullshit
		If ObjectBase as Armor || ObjectBase as Weapon
			If SanityChecker.IsObjRefEquipped(ObjectBase, ObjRef)
				SanityChecker.WornListUpdateInProgress = true
				Int PlayerGender = PlayerRef.GetActorBase().GetSex()
				DoSounds(ObjectBase, PlayerGender)
				If PlayerRef.IsInCombat() && Menu.DestructStagger >= Utility.RandomFloat(0.0, 100.0)
					Debug.SendAnimationEvent(PlayerRef, "staggerStart")
				EndIf
				If Utility.RandomFloat(0.0, 100.0) > Menu.ObjectLossChance ; Damage object
					Form BrokenObject = GetBrokenDummy(ObjectBase)
					
					ObjectReference DummyObjRef
					SwapModel(BrokenObject, ObjectBase)
					DummyObjRef = PlayerRef.PlaceAtMe(BrokenObject, aiCount = 1, abForcePersist = true, abInitiallyDisabled = true)
					DummyObjRef.SetActorOwner(PlayerRef.GetActorBase())
					;PlayerRef.AddItem(BrokenObject, 1, true)
					;DummyObjRef = PlayerRef.DropObject(BrokenObject)
					
					DummyObjRef.SetDisplayName("Damaged " + StorageUtil.GetStringValue(ObjRef, "_MWA_ObjDisplayName"))

					Int SlotMask = 0
					If ObjectBase as Armor
						SlotMask = (ObjectBase as Armor).GetSlotMask()
					EndIf

					Float OrigChargeMax = WornObject.GetItemMaxCharge(PlayerRef, HandSlot, SlotMask)
					Enchantment e
					If ObjectBase as Armor
						e = (ObjectBase as Armor).GetEnchantment() ; Base enchantments, only really needed to calculate repair cost
					Else ; Weapon
						e = (ObjectBase as Weapon).GetEnchantment()
					EndIf
					If e == none
						If ObjectBase as Armor
							e = WornObject.GetEnchantment(PlayerRef, HandSlot, (ObjectBase as Armor).GetSlotMask()) ; Player-made enchantments. Hurray for Bethesda!
						Else
							e = WornObject.GetEnchantment(PlayerRef, HandSlot, 0)
						EndIf
					EndIf
					ObjRef.Disable()
					ObjRef.MoveTo(PlayerRef, afZOffset = -20.0) ; Can't be in a container to get item charge
					
					DummyObjRef.Enable()
					If Menu.DropType == 1
						
						DummyObjRef.MoveTo(PlayerRef, 10.0 * Math.Sin(PlayerRef.GetAngleZ()), 10.0 * Math.Cos(PlayerRef.GetAngleZ()), PlayerRef.GetHeight() + 5.0)
						Int SearchBoxSelect = MakePersistent(DummyObjRef)
						(SearchBoxes[SearchBoxSelect] as  _MWA_ObjectSearch).InitTrigger(DummyObjRef)
					Else
						PlayerRef.AddItem(DummyObjRef, abSilent = true)
					EndIf
					Debug.Notification(ObjectBase.GetName() + " was damaged beyond use")
					StorageUtil.SetFloatValue(DummyObjRef, "_MWA_OriginalCharge", ObjRef.GetItemCharge())
					StorageUtil.SetFormValue(DummyObjRef, "_MWA_OriginalArmor", ObjectBase)
					StorageUtil.SetIntValue(DummyObjRef, "_MWA_DurabilityMax", StorageUtil.GetIntValue(ObjRef, "_MWA_DurabilityMax"))
					StorageUtil.SetFormValue(DummyObjRef, "_MWA_OriginalEnchantment", e)
					StorageUtil.SetFloatValue(DummyObjRef, "_MWA_OriginalChargeMax", OrigChargeMax)
					StorageUtil.SetIntValue(DummyObjRef, "_MWA_OriginalValue", (ObjectBase.GetGoldValue()))
					StorageUtil.SetIntValue(DummyObjRef, "_MWA_OriginalValueEnchant", (Util.GetEnchantedGoldValue(e, ObjectBase, ObjRef, OrigChargeMax)))
					StorageUtil.SetStringValue(DummyObjRef, "_MWA_ObjDisplayName", StorageUtil.GetStringValue(ObjRef, "_MWA_ObjDisplayName"))
					
					
					;Debug.Trace("_MWA_: Value - Base: " + ObjectBase.GetGoldValue() + ". Enchant: " + Util.GetEnchantedGoldValue(e, ObjectBase, ObjRef, OrigChargeMax))
					
					;Debug.Trace("_MWA_: _MWA_OriginalArmor: " + StorageUtil.GetFormValue(DummyObjRef, "_MWA_OriginalArmor") \
					;				+ ". _MWA_OriginalEnchantment: " + StorageUtil.GetFormValue(DummyObjRef, "_MWA_OriginalEnchantment") \
					;				+ ". _MWA_OriginalCharge: " + StorageUtil.GetFloatValue(DummyObjRef, "_MWA_OriginalCharge") \
					;				+ ". _MWA_OriginalValue: " + StorageUtil.GetIntValue(DummyObjRef, "_MWA_OriginalValue") \
					;				+ ". _MWA_OriginalValueEnchant: " + StorageUtil.GetIntValue(DummyObjRef, "_MWA_OriginalValueEnchant"))
					
					
					;PlayerRef.AddItem(DummyObjRef, 1, true)
					;DummyObjRef = PlayerRef.DropObject(BrokenObject, 1) ; Dropping the object again seems to fuck with the object reference even though it's already been made persisent it later fails to retrieve an object ref in the OnItemAdded RepairContainer script. Ugh
				
					;Util.UnPersist(ObjRef, _MWA_ArmorTrack, "_MWA_ArmorTrackAliasList", Init.ArmorTrackAliasCount) ; New version should do this automatically
					_MWA_TempEquipBarrelRef.AddItem(ObjRef, 1, abSilent = true)
					_MWA_TempEquipBarrelRef.RemoveItem(ObjRef, 1, abSilent = true, akOtherContainer = None)
					
				Else ; destroy object
					Debug.Notification(ObjectBase.GetName() + " was destroyed utterly")
					;Util.UnPersist(ObjRef, _MWA_ArmorTrack, "_MWA_ArmorTrackAliasList", Init.ArmorTrackAliasCount) ; New version should do this automatically
					;PlayerRef.RemoveItem(ObjRef, 1, abSilent = true, akOtherContainer = None)
					ObjRef.Disable()
					ObjRef.MoveTo(PlayerRef, afZOffset = -20.0)
					ObjRef.Delete()
					
				EndIf
				
				If ObjectBase as Armor
					Utility.Wait(0.4)
					If Math.LogicalAnd((ObjectBase as Armor).GetSlotMask(), 4) == 4 ; Lost body armor
						If PlayerGender == 1
							Int Gasp = _MWA_FemaleGasp.Play(PlayerRef)
							DoCoverAnimation()
						EndIf
					EndIf
				EndIf
			
			Else
				Debug.Trace("_MWA_: DestroyObject received an object that is not equipped")
			EndIf
		
		Else
			Debug.Notification("_MWA_: DestroyObject received a non-armor/weapon - Running cleanup")
			;Util.CheckWornList()
		EndIf
	
	Else
		If ObjRef ; double checking but should never happen anyway ; NEEDS REVIEW
			Debug.Notification("_MWA_: DestroyObject received a None - Running cleanup")
			;Util.CheckWornList()
		EndIf
	EndIf
EndFunction

Form Function GetBrokenDummy(Form akBaseObject)
	Return GetBrokenList(akBaseObject).GetAt(GetBrokenIndex(akBaseObject))
EndFunction

Formlist Function GetBrokenList(Form akBaseObject)
	If akBaseObject as Armor
		Armor akArmorObject = akBaseObject as Armor
		If akArmorObject.GetWeightClass() == 2
			Return _MWA_BrokenClothingList
		ElseIf akArmorObject.GetWeightClass() == 1
			Return _MWA_BrokenHeavyList
		Else ; Don't use clothing last as there are no 'clothing' shields - fallback in case of missing keywords - mod armors
			Return _MWA_BrokenLightList
		EndIf
	Else
		Return _MWA_BrokenWeaponList
	EndIf
EndFunction

Int Function GetBrokenIndex(Form akBaseObject)
	If akBaseObject as Armor
		Armor akBaseArmor = akBaseObject as Armor
		If (akBaseObject.HasKeyword(ArmorCuirass) || akBaseObject.HasKeyword(ClothingBody)) && Math.LogicalAnd(akBaseArmor.GetSlotMask(), 4) == 4 ; Check if right slot too because I've seen many armor mods with keywords all mixed up. Use 'other' as a catchall
			Return 0
		ElseIf (akBaseObject.HasKeyword(ArmorBoots) || akBaseObject.HasKeyword(ClothingFeet)) && Math.LogicalAnd(akBaseArmor.GetSlotMask(), 128) == 128 ; Feet
			Return 1
		ElseIf (akBaseObject.HasKeyword(ArmorGauntlets) || akBaseObject.HasKeyword(ClothingHands)) && Math.LogicalAnd(akBaseArmor.GetSlotMask(), 8) == 8 ; Hands
			Return 2
		ElseIf (akBaseObject.HasKeyword(ArmorHelmet) || akBaseObject.HasKeyword(ClothingHead)) && Math.LogicalAnd(akBaseArmor.GetSlotMask(), 2) == 2 ; Head
			Return 3
		ElseIf akBaseObject.HasKeyword(ArmorShield) && Math.LogicalAnd(akBaseArmor.GetSlotMask(), 512) == 512 ; Shield
			Return 5
		Else
			Return 4
		EndIf
	Else
		Weapon akWeaponObject = akBaseObject as Weapon
		Int WeaponType = akWeaponObject.GetWeaponType()
		If WeaponType == 2 ; Dagger
			Return 0
		ElseIf WeaponType == 1 ; Sword
			Return 1
		ElseIf WeaponType == 3 ; War axe;
			Return 2
		ElseIf WeaponType == 4 ; Mace
			Return 3
		ElseIf WeaponType == 5 ; Greatsword
			Return 4
		ElseIf WeaponType == 6 ; BattleAxe & Warhammer
			If akWeaponObject.IsWarhammer() ; Relies on keyword check so not perfect
				Return 6
			Else ; catchall in case of keyword fail
				Return 5
			EndIf
		ElseIf WeaponType == 7 ; Bow
			Return 7
		ElseIf WeaponType == 9 ; Crossbow
			Return 8
		Else ; Catchall. Needs staff?
			Return 1
		EndIf
	EndIf
EndFunction

Int Function MakePersistent(ObjectReference ObjRef)
	ReferenceAlias AliasSelect 
	Int AliasIndex = Util.GetNextEmptyAliasIndex(_MWA_BrokenTrack)
	If AliasIndex == -1
		AliasIndex = Util.GetOldestAliasIndex(_MWA_BrokenTrack)
	EndIf
	AliasSelect = _MWA_BrokenTrack.GetNthAlias(AliasIndex) as ReferenceAlias
	AliasSelect.ForceRefTo(ObjRef)
	StorageUtil.FormListSet(none, "_MWA_BrokenTrackAliasList", AliasIndex, ObjRef)
	(AliasSelect as _MWA_ArmorAlias).LastUpdate = Utility.GetCurrentGameTime()
	(ObjRef as _MWA_BrokenItem).MyRef = AliasSelect
	Return AliasIndex
EndFunction

Function SwapModel(Form BrokenObject, Form OrigObject)
	If OrigObject as Armor
		Armor OrigArmor = OrigObject as Armor
		Armor BrokenArmor = BrokenObject as Armor
		BrokenArmor.SetModelPath(OrigArmor.GetModelPath(False), False)
		BrokenArmor.SetModelPath(OrigArmor.GetModelPath(True), True)
	;Else ; Broken weapons aren't actually weapons....
	;	Weapon OrigWeapon = OrigObject as Weapon
	;	Int WeaponType = OrigWeapon.GetWeaponType()
	;	If WeaponType == 7 || WeaponType == 9 ; Bow & Crossbow. There are broken models (well steel) for everything else
	;		Debug.Messagebox(BrokenObject as Weapon)
	;		(BrokenObject as Weapon).SetModelPath(OrigWeapon.GetModelPath())
	;	EndIf
	EndIf
EndFunction

Function DoSounds(Form akBaseObject, Int PlayerGender)
	Int BreakSound
	Int GruntSound
	
	Sound BreakSoundEffect
	Sound GruntSoundEffect = _MWA_FemaleGrunt ; Assume female
	If PlayerGender == 0 ; Check is male
		GruntSoundEffect = _MWA_MaleGrunt
	EndIf
	
	
	If akBaseObject as Armor
		Int ArmorClass = (akBaseObject as Armor).GetWeightClass() ; 2 = None, 0 = Light, 1 = Heavy
		If ArmorClass == 1 ; Heavy armor
			BreakSoundEffect = _MWA_ArmorBreakHeavy
		
		ElseIf ArmorClass == 0 ; Light armor
			BreakSoundEffect = _MWA_ArmorBreakLight
		
		Else ; Clothes
			If akBaseObject.HasKeyword(ArmorClothing) ; Is not jewelry etc - ripping would not sound ok.
				; Assume is female
				BreakSoundEffect = _MWA_ClothesRipAndGrunt
				GruntSoundEffect = None
				If PlayerGender == 0 ; Check is male
					GruntSoundEffect = _MWA_MaleGrunt
					BreakSoundEffect = _MWA_ArmorBreakLight
				EndIf
			Else
				BreakSoundEffect = _MWA_ArmorBreakLight
			EndIf
		EndIf
	
	Else
		BreakSoundEffect = _MWA_ArmorBreakHeavy
	EndIf
	
	BreakSound = BreakSoundEffect.Play(PlayerRef)
	Sound.SetInstanceVolume(BreakSound, Menu.BreakSoundVolume)
	If GruntSoundEffect != None
		GruntSound = GruntSoundEffect.Play(PlayerRef)
		Sound.SetInstanceVolume(GruntSound, Menu.BreakSoundVolume)
	EndIf
EndFunction

Function DoCoverAnimation()
	If Game.GetModByName("ZaZAnimationPack.esm") != 255
		Keyword zbfEffectKeepOffsetAnim = Game.GetFormFromFile(0x0184EA, "ZaZAnimationPack.esm") as Keyword
		Faction zbfFactionAnimating = Game.GetFormFromFile(0x00E2B7, "ZaZAnimationPack.esm") as Faction
		If Game.GetModByName("SexLab.esm") != 255
			;Faction SexlabAnimatingFaction = Game.GetFormFromFile(0x00E50F, "SexLab.esm") as Faction
			If !PlayerRef.IsOnMount() && !PlayerRef.IsDead() && !PlayerRef.WornHasKeyword(zbfEffectKeepOffsetAnim) && !PlayerRef.IsWeaponDrawn() && !PlayerRef.IsSwimming() && !PlayerRef.IsInFaction(zbfFactionAnimating) && !Sexlab.GetIsAnimating(PlayerRef) && PlayerRef.GetSitState() != 3 && PlayerRef.GetSleepState() != 3 && PlayerRef.GetCombatState() == 0
				;Debug.SendAnimationEvent(PlayerRef, "ZaZAPCSHMOFF") ; Covers pussy only
				Debug.SendAnimationEvent(PlayerRef, "ZaZAPCSHFOFF") ; Covers tits and pussy
			EndIf
		Else
			If !PlayerRef.IsOnMount() && !PlayerRef.IsDead() && !PlayerRef.WornHasKeyword(zbfEffectKeepOffsetAnim) && !PlayerRef.IsWeaponDrawn() && !PlayerRef.IsSwimming() && !PlayerRef.IsInFaction(zbfFactionAnimating) && PlayerRef.GetSitState() != 3 && PlayerRef.GetSleepState() != 3 && PlayerRef.GetCombatState() == 0
				;Debug.SendAnimationEvent(PlayerRef, "ZaZAPCSHMOFF") ; Covers pussy only
				Debug.SendAnimationEvent(PlayerRef, "ZaZAPCSHFOFF") ; Covers tits and pussy
			EndIf
		EndIf
	EndIf
EndFunction

; VARIABLES ===========================================================================


; PROPERTIES ==========================================================================

ObjectReference[] Property SearchBoxes Auto Hidden

Int Property TotalRepairCost = 0 Auto Hidden

Actor Property PlayerRef Auto

Sound Property _MWA_ArmorBreakHeavy Auto
Sound Property _MWA_ArmorBreakLight Auto
Sound Property _MWA_FemaleGrunt Auto
Sound Property _MWA_MaleGrunt Auto
Sound Property _MWA_ClothesRipAndGrunt Auto
Sound Property _MWA_FemaleGasp Auto

Keyword Property ArmorGauntlets Auto
Keyword Property ArmorHelmet Auto
Keyword Property ArmorBoots Auto
Keyword Property ArmorCuirass Auto
Keyword Property ArmorShield Auto

Keyword Property ArmorClothing Auto
Keyword Property ClothingHands Auto
Keyword Property ClothingHead Auto
Keyword Property ClothingFeet Auto
Keyword Property ClothingBody Auto

FormList Property _MWA_BrokenHeavyList Auto
FormList Property _MWA_BrokenLightList Auto
FormList Property _MWA_BrokenClothingList Auto
Formlist Property _MWA_BrokenWeaponList Auto

ObjectReference Property EquippedShield Auto Hidden
ObjectReference Property LeftWeapon Auto Hidden
ObjectReference Property RightWeapon Auto Hidden
ObjectReference Property _MWA_TempEquipBarrelRef Auto

ObjectReference Property _MWA_ObjectSearch001 Auto
ObjectReference Property _MWA_ObjectSearch002 Auto
ObjectReference Property _MWA_ObjectSearch003 Auto
ObjectReference Property _MWA_ObjectSearch004 Auto
ObjectReference Property _MWA_ObjectSearch005 Auto
ObjectReference Property _MWA_ObjectSearch006 Auto
ObjectReference Property _MWA_ObjectSearch007 Auto
ObjectReference Property _MWA_ObjectSearch008 Auto
ObjectReference Property _MWA_ObjectSearch009 Auto
ObjectReference Property _MWA_ObjectSearch010 Auto
ObjectReference Property _MWA_ObjectSearch011 Auto
ObjectReference Property _MWA_ObjectSearch012 Auto
ObjectReference Property _MWA_ObjectSearch013 Auto
ObjectReference Property _MWA_ObjectSearch014 Auto
ObjectReference Property _MWA_ObjectSearch015 Auto
ObjectReference Property _MWA_ObjectSearch016 Auto
ObjectReference Property _MWA_ObjectSearch017 Auto
ObjectReference Property _MWA_ObjectSearch018 Auto
ObjectReference Property _MWA_ObjectSearch019 Auto
ObjectReference Property _MWA_ObjectSearch020 Auto
ObjectReference Property _MWA_ObjectSearch021 Auto
ObjectReference Property _MWA_ObjectSearch022 Auto
ObjectReference Property _MWA_ObjectSearch023 Auto
ObjectReference Property _MWA_ObjectSearch024 Auto
ObjectReference Property _MWA_ObjectSearch025 Auto
ObjectReference Property _MWA_ObjectSearch026 Auto
ObjectReference Property _MWA_ObjectSearch027 Auto
ObjectReference Property _MWA_ObjectSearch028 Auto
ObjectReference Property _MWA_ObjectSearch029 Auto
ObjectReference Property _MWA_ObjectSearch030 Auto
ObjectReference Property _MWA_ObjectSearch031 Auto
ObjectReference Property _MWA_ObjectSearch032 Auto
ObjectReference Property _MWA_ObjectSearch033 Auto
ObjectReference Property _MWA_ObjectSearch034 Auto
ObjectReference Property _MWA_ObjectSearch035 Auto
ObjectReference Property _MWA_ObjectSearch036 Auto
ObjectReference Property _MWA_ObjectSearch037 Auto
ObjectReference Property _MWA_ObjectSearch038 Auto
ObjectReference Property _MWA_ObjectSearch039 Auto
ObjectReference Property _MWA_ObjectSearch040 Auto

Quest Property _MWA_BrokenTrack Auto
Quest Property _MWA_ArmorTrack Auto

_MWA_Utility Property Util Auto
_MWA_Init Property Init Auto
_MWA_Mcm Property Menu Auto
_MWA_SanityChecker Property SanityChecker Auto
_MWA_InterfaceSexlab Property Sexlab Auto
