Scriptname _MWA_CombatArmor extends ReferenceAlias  

; EVENTS ==============================================================================

Event OnInit()
	GoToState("DegradeEnabled")
EndEvent

Event OnUpdate()
	;GoToState("DegradeEnabled")
EndEvent

Event OnPlayerLoadGame()
	
EndEvent

State DegradeEnabled
	Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
		If akSource as Weapon 
			;GoToState("Cooldown") ; Only allow 1 rip every (update) seconds
			WeaponHit(abPowerAttack, abHitBlocked, akSource, akAggressor = akAggressor)
			;Debug.Trace("_MWA_: Attack akAggressor: " + akAggressor + " - " + ". Source: " + akSource)
			;GoToState("DegradeEnabled")
		EndIf
	EndEvent
EndState

State Cooldown
	Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)

	EndEvent
EndState

; CUSTOM EVENTS =======================================================================

; FUNCTIONS ===========================================================================

Function ApiDamageArmorSlot(ObjectReference ObjRef, Int StrikeCount, Form Sender, Form akSource = None, Keyword MagicKeyword = None)
	While GetState() == "Cooldown" && !Menu.DegradationT
		Utility.Wait(0.5)
	EndWhile
	If Menu.DegradationT
		ArmorHit(ObjRef, 999, false, 0, akSource, MagicKeyword, StrikeCount, Sender)
	Else
		Debug.Trace("_MWA_: Warning: _MWA_CombatArmor received ApiDamageArmorSlot event but degradation is disabled in MCM")
	EndIf
EndFunction

Function WeaponHit(Bool abPowerAttack, Bool abHitBlocked, Form akSource = None, Keyword MagicKeyword = None, ObjectReference akAggressor = None)
	If !SanityChecker.WornListUpdateInProgress && !Util.DegradeInProgress
		Util.DegradeInProgress = true
		If abHitBlocked ; Degrade shield
			If PlayerRef.GetEquippedItemType(0) == 11 ; Light
				If 70.0 > Utility.RandomFloat(0.0, 100.0)
					PlayerRef.UnEquipItem(Torch01)
					PlayerRef.RemoveItem(Torch01, 1)
				EndIf
			Else
				If ArmorDest.EquippedShield != None && PlayerRef.GetWornForm(512) != None
					Util.DegradeInProgress = false ; this is shit
					ArmorHit(ArmorDest.EquippedShield, StorageUtil.FormListFind(none, "_MWA_WornDestructibles", ArmorDest.EquippedShield), abPowerAttack, 0, akSource, MagicKeyword, akAggressor = akAggressor)
				ElseIf ArmorDest.LeftWeapon != None ; Degrade left weapon
					Util.DegradeInProgress = false
					ArmorHit(ArmorDest.LeftWeapon, -1, abPowerAttack, 2, akSource, MagicKeyword, akAggressor = akAggressor)
				ElseIf ArmorDest.RightWeapon != None ; degrade right weapon
					Util.DegradeInProgress = false
					ArmorHit(ArmorDest.RightWeapon, -1, abPowerAttack, 1, akSource, MagicKeyword, akAggressor = akAggressor)
				EndIf
			EndIf
		Else ; Degrade a random armor
		
			Int j = Menu.ArmorHitsPerHit
			If Menu.ArmorHitsPerHitRandomT
				j = Utility.RandomInt(1, Menu.ArmorHitsPerHit)
			EndIf
			While j > 0
				j -= 1
				
				; pick a random equipped armor to hit, make sure is not none
				ObjectReference ArmorObjRef
				Int WornCount = StorageUtil.FormListCount(none, "_MWA_WornDestructibles")
				
				Int Index = Utility.RandomInt(0, WornCount - 1)
				ArmorObjRef = StorageUtil.FormListGet(none, "_MWA_WornDestructibles", Index) as ObjectReference
				;Debug.Trace("_MWA_: WornCount " + WornCount)
				While ArmorObjRef == None && WornCount > 0
					Debug.Trace("_MWA_: Error: None found in _MWA_WornDestructibles")
					Util.WornListRemove(ArmorObjRef, "WeaponHit()", Index)
					WornCount = StorageUtil.FormListCount(none, "_MWA_WornDestructibles")
					Index = Utility.RandomInt(0, WornCount)
					ArmorObjRef = StorageUtil.FormListGet(none, "_MWA_WornDestructibles", Index) as ObjectReference
				EndWhile
				
				;/
				; Debugging ---------------------------
				Int i = 0
				While i < StorageUtil.FormListCount(none, "_MWA_WornDestructibles")
					ObjectReference ArmorSelect = StorageUtil.FormListGet(none, "_MWA_WornDestructibles", i) as ObjectReference
					If ArmorSelect == None
						Debug.Trace("_MWA_: HIT - List index " + i + ": ObjRef: " + ArmorSelect + ". Base: none")
					Else
						Debug.Trace("_MWA_: HIT - List index " + i + ": ObjRef: " + ArmorSelect + ". Base: " + ArmorSelect.GetBaseObject())
					EndIf
					i += 1
				EndWhile
				; Debugging --------------------------
				/;
				
				If ArmorObjRef != None
					 Util.DegradeInProgress = false
					ArmorHit(ArmorObjRef, Index, abPowerAttack, 0, akSource, MagicKeyword, akAggressor = akAggressor)
				EndIf
			EndWhile
		EndIf
		Util.DegradeInProgress = false
	EndIf
EndFunction

Bool Function ArmorHit(ObjectReference ObjRef, Int Index, Bool abPowerAttack, Int HandSlot, Form akSource = None, Keyword MagicKeyword = None, Int NumOfHits = 1, Form Sender = None, ObjectReference akAggressor = None) ; HandSlot. 0 - Worn, 1 - Right Hand, 2 - Left hand
	If !SanityChecker.WornListUpdateInProgress && !Util.DegradeInProgress
		Util.DegradeInProgress = true
		Form akObjectBase = ObjRef.GetBaseObject()
		Int Durability = StorageUtil.GetIntValue(ObjRef, "_MWA_Durability", missing = -1)
		;Debug.Trace("_MWA_: Index: " + Index + ". Hit on: " + akObjectBase.GetName() + ". ObjRef: " + ObjRef + ". BaseObject: " + akObjectBase + ". OldHealth: " + ObjRef.GetItemHealthPercent() + ". Old Durability: "+ Durability)
		If Durability == -1 && Index != -1
			Debug.Notification("_MWA_: Error: Armor durability not found. This should not happen - Removing index " + Index)
			Util.WornListRemove(ObjRef, "ArmorHit()", Index)
		
		Else
			If PenetratesMagicShield(akObjectBase, abPowerAttack)
				Float Vulnerability = GetVulnerability(akObjectBase, akSource, MagicKeyword, akAggressor)
				;Debug.MessageBox("Vul: " + Vulnerability)
				If ObjRef == ArmorDest.EquippedShield
					Vulnerability *= 0.5
				EndIf
				Float ObjectHealth = Util.GetWornObjectHealth(ObjRef, akObjectBase)
				
				;/
				If HandSlot >= 0 ; Armor ;!!!!!!!!!!!!!!!!!!!!! >
					ObjectHealth = ObjRef.GetItemHealthPercent() ; ObjRef.GetItemHealthPercent() wont work for equipped weapons ??????????
				Else ; Weapon
					ObjectHealth = WornObject.GetItemHealthPercent(PlayerRef, HandSlot, 0)
					;Debug.MessageBox(ObjectHealth)
				EndIf
				/;

				If ObjectHealth < Util.TemperFloor ; Not tempered, decrease durability
					
					Int DurDamage = Math.Ceiling((1 + abPowerAttack as Int) * Vulnerability) * NumOfHits
					;Debug.MessageBox("DurDamage: " + DurDamage)
					If Durability <= DurDamage
						ArmorDest.DestroyObject(ObjRef, akObjectBase, HandSlot)
						If Sender != None
							Int DestructionEvent = ModEvent.Create("_MWA_DestructionEvent")
							If (DestructionEvent)
								ModEvent.PushForm(DestructionEvent, Sender)
								ModEvent.PushForm(DestructionEvent, akObjectBase)
								ModEvent.PushForm(DestructionEvent, ObjRef)
								ModEvent.Send(DestructionEvent)
							EndIf
						EndIf
					Else
						StorageUtil.AdjustIntValue(ObjRef, "_MWA_Durability", -DurDamage)
						;Debug.Notification(akObjectBase.GetName() + " durability decreased to " + StorageUtil.GetIntValue(ObjRef, "_MWA_Durability"))
						Util.DispItemDurability(ObjRef, akObjectBase, ObjectHealth)
					EndIf
					StorageUtil.SetFloatValue(ObjRef, "_MWA_LastHealth", 1.0)
					
				Else ; Decrease tempering
					;Debug.Notification(akObjectBase.GetName() + ": " + ObjectHealth)
					Float DegradeResist = StorageUtil.GetFloatValue(ObjRef, "_MWA_DurabilityBonus")
					Float Damage
					If abPowerAttack
						Damage = Menu.TemperDegradePowerA * Vulnerability * NumOfHits
					Else
						Damage = Menu.TemperDegrade * Vulnerability * NumOfHits
					EndIf
					Damage -= (Damage * DegradeResist)
					;Debug.MessageBox("Source: " + akSource + ". Damage: " + Damage)
					Util.CheckTemperLevelChange(akObjectBase, ObjectHealth, Damage)
					ObjectHealth -= Damage
					If ObjectHealth < Util.TemperFloor
						ObjectHealth = 1.0
					EndIf
					Int SlotMask = 0
					If HandSlot == 0
						SlotMask = (akObjectBase as Armor).GetSlotMask()
					EndIf
					ObjRef.SetItemHealthPercent(ObjectHealth)
					WornObject.SetItemHealthPercent(PlayerRef, HandSlot, SlotMask, ObjectHealth)
					Util.DispItemDurability(ObjRef, akObjectBase, ObjectHealth)
					StorageUtil.SetFloatValue(ObjRef, "_MWA_LastHealth", ObjectHealth)
				EndIf
			EndIf
			Util.DegradeInProgress = false
			Return true
		EndIf
		Util.DegradeInProgress = false
	EndIf
	Return false
EndFunction

Bool Function PenetratesMagicShield(Form akArmorObject, Bool abPowerAttack)
	If PlayerRef.HasMagicEffectWithKeyword(MagicArmorSpell)
		Float PowerAttackBonus = (abPowerAttack as Int) * Menu.MagicArmorPattack
		Bool IsClothing = akArmorObject.HasKeyword(ArmorClothing)
		Float TestFloat = Utility.RandomFloat((0.0 + PowerAttackBonus), (100.0 + PowerAttackBonus))
		If TestFloat > GetMagicArmorBonus(IsClothing)
			;debug.messagebox("IsClothing: " + IsClothing + ". Power: " + abPowerAttack + ". Test: " + testfloat + ". Compare: " + GetMagicArmorBonus(IsClothing) + ". Return true")
			Return true
		Else
			;debug.messagebox("IsClothing: " + IsClothing + ". Power: " + abPowerAttack + ". Test: " + testfloat + ". Compare: " + GetMagicArmorBonus(IsClothing) + ". Return false")
			Return false
		EndIf
	Else
		Return true
	EndIf
EndFunction

Int Function GetArmorSpellTier()
	If PlayerRef.HasMagicEffect(ArmorFFSelf100)
		Return 4
	ElseIf PlayerRef.HasMagicEffect(ArmorFFSelf75)
		Return 3
	ElseIf PlayerRef.HasMagicEffect(ArmorFFSelf50)
		Return 2
	ElseIf PlayerRef.HasMagicEffect(ArmorFFSelf25)
		Return 1
	Else
		Return 0
	EndIf
EndFunction

Float Function GetMagicArmorBonus(Bool IsClothing)
	If IsClothing
		Return Menu.MagicArmorClothing + (GetArmorSpellTier() * Menu.MagicArmorClothingDelta)
	Else
		Return Menu.MagicArmorArmor + (GetArmorSpellTier() * Menu.MagicArmorArmorDelta)
	EndIf
EndFunction

Float Function GetVulnerability(Form HitObject, Form akSourceWeapon, Keyword MagicKeyword, ObjectReference akAggressor)
	If Menu.ComplexDegradationT
		If HitObject as Armor ; Hit object is armor
			Int HitArmorClass = (HitObject as Armor).GetWeightClass() ; 2 = None, 0 = Light, 1 = Heavy
			If akSourceWeapon ; Physical weapon
				Int WeaponType = (akSourceWeapon as Weapon).GetWeaponType()
				
				; Creatures
				If akSourceWeapon == Unarmed
					If akAggressor as Actor
						Actor Enemy = (akAggressor as Actor)
						If Enemy.GetRace().IsRaceFlagSet(0) ; Is not playable race
							Float AggressorHealth = Enemy.GetBaseActorValue("Health")
							;Debug.MessageBox("damage: " + Math.Ceiling(AggressorHealth / 110.0))
							Return Math.Ceiling(AggressorHealth / Menu.CreatureVulnerability)
						EndIf
					EndIf
				EndIf
				
				; Weapons / Magic
				If HitArmorClass == 1 ; Heavy Armor
					If WeaponType == 4 ; Mace
						Return Menu.VulnerabilityMultMace
					ElseIf akSourceWeapon.HasKeyword(WeapTypeWarhammer) ; Warhammer
						Return Menu.VulnerabilityMultWarhammer
					ElseIf WeaponType == 3 ; Axe
						If Menu.ExtraDamageChanceAxe > Utility.RandomFloat(0.0, 100.0)
							Return Menu.VulnerabilityMultAxe
						EndIf 
					ElseIf akSourceWeapon.HasKeyword(WeapTypeBattleaxe) ; Battleaxe
						If Menu.ExtraDamageChanceAxe > Utility.RandomFloat(0.0, 100.0)
							Return Menu.VulnerabilityMultBattleAxe
						EndIf
					EndIf
					
				Else ; Clothing / Light armor
					
					If WeaponType == 2 ; Sword
						Return Menu.VulnerabilityMultSword
					ElseIf WeaponType == 5 ; Greatsword
						Return Menu.VulnerabilityMultGreatsword
					ElseIf WeaponType == 1 ; Dagger
						Return Menu.VulnerabilityMultDagger
					ElseIf WeaponType == 3 ; Axe
						If Menu.ExtraDamageChanceAxe > Utility.RandomFloat(0.0, 100.0)
							Return Menu.VulnerabilityMultAxe
						EndIf
					ElseIf akSourceWeapon.HasKeyword(WeapTypeBattleaxe) ; Battleaxe
						If Menu.ExtraDamageChanceAxe > Utility.RandomFloat(0.0, 100.0)
							Return  Menu.VulnerabilityMultBattleAxe
						EndIf
					EndIf
				EndIf
				
			Else ; Magic
				If MagicKeyword == MagicDamageFire
					If HitArmorClass != 1
						Return Menu.VulnerabilityMultFire
					EndIf
				ElseIf MagicKeyword == MagicDamageShock
					If Menu.ExtraDamageChanceLightning > Utility.RandomFloat(0.0, 100.0)
						Return Menu.VulnerabilityMultLightning
					EndIf
				ElseIf MagicKeyword == MagicDamageFrost
					If HitArmorClass == 1
						Return Menu.VulnerabilityMultIce
					EndIf
					
				ElseIf MagicKeyword == _MWA_ShoutForce1
					Return Menu.VulnerabilityShoutOne
				ElseIf MagicKeyword == _MWA_ShoutForce2
					Return Menu.VulnerabilityShoutTwo
				ElseIf MagicKeyword == _MWA_ShoutForce3
					Return Menu.VulnerabilityShoutThree
				EndIf
			EndIf
		
		Else ; Hit object is weapon (Weapon block)		
			Int BlockWeaponType = (HitObject as Weapon).GetWeaponType()
			Int AttackWeaponType = (akSourceWeapon as Weapon).GetWeaponType()
			
			; Creatures
			If akSourceWeapon == Unarmed
				If akAggressor as Actor
					Actor Enemy = (akAggressor as Actor)
					If Enemy.GetRace().IsRaceFlagSet(0) ; Is not playable race
						Float AggressorHealth = Enemy.GetBaseActorValue("Health")
						;Debug.MessageBox("damage: " + Math.Ceiling(AggressorHealth / 110.0))
						Int HitMagnitude = Math.Ceiling(AggressorHealth / Menu.CreatureVulnerability)
						If BlockWeaponType > 0 && BlockWeaponType < 5 ; One handed weapons
							If BlockWeaponType == 2 ; Dagger
								Return HitMagnitude / 2
							Else
								Return HitMagnitude / 3
							EndIf
						
						ElseIf BlockWeaponType == 7 || BlockWeaponType == 9 ; Bows / Crossbows
							Return HitMagnitude / 2
						ElseIf BlockWeaponType == 5 || BlockWeaponType == 6 ; 2 handed weapons
							Return HitMagnitude / 4
						EndIf
					EndIf
				EndIf
			EndIf
			

			If AttackWeaponType == 5 || AttackWeaponType == 6 ; Attacks with 2 handed weapons
				If BlockWeaponType > 0 && BlockWeaponType < 5 ; One handed weapons
					If BlockWeaponType == 2 ; Dagger
						Return 5.0
					Else
						Return 3.0
					EndIf
				ElseIf BlockWeaponType == 7 || BlockWeaponType == 9 ; Bows / Crossbows
					Return 4.0
				ElseIf BlockWeaponType == 5 || BlockWeaponType == 6 ; 2 handed weapons
					Return 2.0
				EndIf
			
			Else  ; Attacks with 1 handed weapons
				If BlockWeaponType == 7 || BlockWeaponType == 9 ; Bows / Crossbows
					Return 2.0
				EndIf
			EndIf
			Return 1.0
		EndIf
	EndIf
	Return 1.0
EndFunction

; PROPERTIES =========================================================================

Keyword Property MagicArmorSpell Auto
Keyword Property ArmorClothing Auto
Keyword Property WeapTypeBattleaxe Auto
Keyword Property WeapTypeWarhammer Auto
Keyword Property MagicDamageFire Auto
Keyword Property MagicDamageFrost Auto
Keyword Property MagicDamageShock Auto

Keyword Property _MWA_ShoutForce1 Auto
Keyword Property _MWA_ShoutForce2 Auto
Keyword Property _MWA_ShoutForce3 Auto

Actor Property PlayerRef Auto

Weapon Property Unarmed Auto

Light Property Torch01 Auto

MagicEffect Property ArmorFFSelf0 Auto
MagicEffect Property ArmorFFSelf25 Auto
MagicEffect Property ArmorFFSelf50 Auto
MagicEffect Property ArmorFFSelf75 Auto
MagicEffect Property ArmorFFSelf100 Auto

_MWA_Mcm Property Menu Auto
_MWA_ArmorDestruction Property ArmorDest Auto
_MWA_Init Property Init Auto
_MWA_Utility Property Util Auto
_MWA_SanityChecker Property SanityChecker Auto
