Scriptname _MWA_CombatWeapon extends ReferenceAlias  

Event OnInit()
	RegisterForMenu("RaceSex") ; CK WIKI: Changing race can also stop an animation event from being registered on an alias. (It does)
	ScriptStartup()
EndEvent

Event OnPlayerLoadGame() ; Something (other than racemenu) is still preventing OnAnimationEvents from firing
	If Menu.DegradationT
		ScriptStartup()
	EndIf
EndEvent

Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	If !SanityChecker.WornListUpdateInProgress && !Util.DegradeInProgress
		Util.DegradeInProgress = true
		If asEventName == "weaponSwing"
			WeaponHit(ArmorDest.RightWeapon, 1, PlayerRef.GetAnimationVariableBool("bAllowRotation"))
		ElseIf asEventName == "arrowRelease"
			WeaponHit(ArmorDest.RightWeapon, 2)
		ElseIf asEventName == "bashStop"
			If ArmorDest.EquippedShield != None
				WeaponHit(ArmorDest.EquippedShield, 0)
			ElseIf ArmorDest.RightWeapon != None
				WeaponHit(ArmorDest.RightWeapon, 1)
			EndIf
		ElseIf asEventName == "weaponLeftSwing"
			WeaponHit(ArmorDest.LeftWeapon, 0, PlayerRef.GetAnimationVariableBool("bAllowRotation"))
		EndIf
		Util.DegradeInProgress = false
	EndIf
EndEvent

State CoolOff
	Event OnAnimationEvent(ObjectReference akSource, string asEventName)
	
	EndEvent
EndState

Event OnMenuClose(String MenuName)
	ScriptStartup()
EndEvent

Function ScriptStartup()
	RegisterForAnimationEvent(PlayerRef, "weaponSwing")
	RegisterForAnimationEvent(PlayerRef, "weaponLeftSwing")
	RegisterForAnimationEvent(PlayerRef, "arrowRelease")
	RegisterForAnimationEvent(PlayerRef, "bashStop")
EndFunction

Function WeaponHit(ObjectReference ObjRef, Int HandSlot, Bool IsPowerAttack = false)
	GoToState("CoolOff")
	If ObjRef
		Form akBaseObject = ObjRef.GetBaseObject()
		;Float ObjectHealth = ObjRef.GetItemHealthPercent()
		Float ObjectHealth = Util.GetWornObjectHealth(ObjRef, akBaseObject)
		;Debug.Messagebox(akBaseObject.GetName() + " Health: " + ObjectHealth)

		If ObjectHealth < Util.TemperFloor
			Int Durability = StorageUtil.GetIntValue(ObjRef, "_MWA_Durability", missing = -1)
			If Durability <= (1 + (IsPowerAttack as Int)) ; Destroy Weapon
				ArmorDest.DestroyObject(ObjRef, akBaseObject, HandSlot)
				
			Else ; Decrease durability
				StorageUtil.AdjustIntValue(ObjRef, "_MWA_Durability", -(1 + (IsPowerAttack as Int)))
				Util.DispItemDurability(ObjRef, akBaseObject, ObjectHealth)
			EndIf
			StorageUtil.SetFloatValue(ObjRef, "_MWA_LastHealth", 1.0)
				
			
		Else ; Decrease tempering
			;Debug.Messagebox("decrease tempering")
			Float DegradeResist = StorageUtil.GetFloatValue(ObjRef, "_MWA_DurabilityBonus")
			Float Damage
			If IsPowerAttack
				Damage = Menu.WeaponDegradePower
			Else
				Damage = Menu.WeaponDegrade
			EndIf
			Damage -= (Damage * DegradeResist)
			Util.CheckTemperLevelChange(akBaseObject, ObjectHealth, Damage)
			ObjectHealth -= Damage
			If ObjectHealth < Util.TemperFloor
				ObjectHealth = 1.0
			EndIf
			
			; Double check handslot is right - crossbow bug
			HandSlot = 1
			If ArmorDest.LeftWeapon == ObjRef
				HandSlot = 0
			EndIf
			
			;ObjRef.SetItemHealthPercent(ObjectHealth)
			;Debug.Messagebox("Setting object health to: " + ObjectHealth)
			WornObject.SetItemHealthPercent(PlayerRef, HandSlot, 0, ObjectHealth)
			Util.DispItemDurability(ObjRef, akBaseObject, ObjectHealth)
			StorageUtil.SetFloatValue(ObjRef, "_MWA_LastHealth", ObjectHealth)
		EndIf
	EndIf
	GoToState("")
EndFunction

Actor Property PlayerRef Auto

_MWA_ArmorDestruction Property ArmorDest Auto
_MWA_Utility Property Util Auto
_MWA_Mcm Property Menu Auto
_MWA_SanityChecker Property SanityChecker Auto
