Scriptname _MWA_DegradeOverTime extends Quest  

Event OnInit() ; Need this for 'Pause degradation' MCM option to resume quest
	If (MQ101.GetCurrentStageID() >= 240)
		LastUpdate = Utility.GetCurrentGameTime()
		RegisterForSingleUpdateGameTime(Menu.TimeDegradeFreq)
	EndIf
EndEvent

Event OnUpdateGameTime()
	If Menu.TimeDegradeFreq != 0
		;Debug.Trace("_MWA_: DegradeOverTime: BEGINNING >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")
		Int PeriodsPassed = Math.Floor(((Utility.GetCurrentGameTime() - LastUpdate) * 24.0) / Menu.TimeDegradeFreq)
		Int i = StorageUtil.FormListCount(none, "_MWA_WornDestructibles")
		ObjectReference ObjRef
		Int HandSlot = 0
		While i > 0
			i -= 1
			ObjRef = StorageUtil.FormListGet(none, "_MWA_WornDestructibles", i) as ObjectReference
			DegradeObject(ObjRef, 0, PeriodsPassed)
		EndWhile
		If ArmorDest.RightWeapon != None
			DegradeObject(ArmorDest.RightWeapon, 1, PeriodsPassed)
		EndIf
		If ArmorDest.LeftWeapon != None
			DegradeObject(ArmorDest.LeftWeapon, 0, PeriodsPassed)
		EndIf
		If ArmorDest.EquippedShield != None
			DegradeObject(ArmorDest.EquippedShield, 0, PeriodsPassed)
		EndIf
		RegisterForSingleUpdateGameTime(Menu.TimeDegradeFreq)
		;Debug.Trace("_MWA_: DegradeOverTime: ENDINF <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<")
	EndIf
	LastUpdate = Utility.GetCurrentGameTime()
EndEvent

Function DegradeObject(ObjectReference ObjRef, Int HandSlot, Int PeriodsPassed)
	If ObjRef != None
		Form akObjectBase
		Float ObjectHealth
		Int SlotMask = 0
	
		akObjectBase = ObjRef.GetBaseObject()
		ObjectHealth = Util.GetWornObjectHealth(ObjRef, akObjectBase)
		;Debug.Trace("_MWA_: DegradeOverTime: Procing: " + akObjectBase.GetName() + ". CurrentHealth: " + ObjectHealth)
		If ObjectHealth < Util.TemperFloor ; Not tempered, decrease durability
			If Menu.TimeDegradeDurDecT
				If StorageUtil.GetIntValue(ObjRef, "_MWA_Durability", missing = -1) <= 1
					ArmorDest.DestroyObject(ObjRef, akObjectBase, HandSlot)
				Else
					StorageUtil.AdjustIntValue(ObjRef, "_MWA_Durability", -1)
					Util.DispItemDurability(ObjRef, akObjectBase, ObjectHealth)
				EndIf
			EndIf
		
		Else ; Decrease tempering
			Float DegradeResist = StorageUtil.GetFloatValue(ObjRef, "_MWA_DurabilityBonus")
			Float Damage = Menu.TimeDegradeDamage * PeriodsPassed
			Damage = Damage - (Damage * DegradeResist)
			Util.CheckTemperLevelChange(akObjectBase, ObjectHealth, Damage)
			ObjectHealth -= Damage
			If ObjectHealth < 1.0
				ObjectHealth = 1.0
			EndIf
			If akObjectBase as Armor
			;If HandSlot == 0
				SlotMask = (akObjectBase as Armor).GetSlotMask()
			EndIf
			ObjRef.SetItemHealthPercent(ObjectHealth)
			WornObject.SetItemHealthPercent(PlayerRef, HandSlot, SlotMask, ObjectHealth)
			Util.DispItemDurability(ObjRef, akObjectBase, ObjectHealth)
			StorageUtil.SetFloatValue(ObjRef, "_MWA_LastHealth", ObjectHealth)
			;Debug.Trace("_MWA_: DegradeOverTime: Procing: " + akObjectBase.GetName() + ". NewHealth: " + Util.GetWornObjectHealth(ObjRef, akObjectBase))
		EndIf
	EndIf
EndFunction

Function BeginUpdates()
	RegisterForSingleUpdateGameTime(Menu.TimeDegradeFreq)
EndFunction

Float LastUpdate = 0.0

Actor Property PlayerRef Auto

Quest Property MQ101 Auto

_MWA_ArmorDestruction Property ArmorDest Auto
_MWA_Utility Property Util Auto
_MWA_Mcm Property Menu Auto
