 Scriptname _MWA_InterfaceDeviousDevices extends Quest  

Event OnInit()
	;Utility.Wait(10.0)
	;PlayerLoadsGame()
EndEvent

Function PlayerLoadsGame()
	If Game.GetModByName("Devious Devices - Expansion.esm") != 255
		If GetState() != "Installed"
			Menu.CursedChanceContainer = 5.0
			Menu.CursedChanceCorpse = 5.0
			GoToState("Installed")
		EndIf
	
	Else
		If GetState() != ""
			Menu.CursedChanceContainer = 0.0
			Menu.CursedChanceCorpse = 0.0
			GoToState("")
		EndIf
	EndIf
EndFunction

Bool Function GetIsInterfaceActive()
	If GetState() == "Installed"
		Return true
	EndIf
	Return false
EndFunction

Event OnEndState()
	Utility.Wait(5.0) ; Wait before entering active state to help avoid making function calls to scripts that may not have initialized yet.
	
	libsQuest = Game.GetFormFromFile(0x00F624, "Devious Devices - Integration.esm") as Quest
	
	zad_DeviousBlindfold = Game.GetFormFromFile(0x011B1A, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousBoots = Game.GetFormFromFile(0x027F29, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousCollar = Game.GetFormFromFile(0x003DF7, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousHarness = Game.GetFormFromFile(0x017C43, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousCorset = Game.GetFormFromFile(0x027F28, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousArmCuffs = Game.GetFormFromFile(0x003DF9, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousLegCuffs = Game.GetFormFromFile(0x003DF8, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousGag = Game.GetFormFromFile(0x007EB8, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousGloves = Game.GetFormFromFile(0x02AFA1, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousPiercingsNipple = Game.GetFormFromFile(0x00CA39, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousPiercingsVaginal = Game.GetFormFromFile(0x023E70, "Devious Devices - Assets.esm") as Keyword
	zad_PermitOral = Game.GetFormFromFile(0x00FAC9, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousBelt = Game.GetFormFromFile(0x003330, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousBra = Game.GetFormFromFile(0x003DFA, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousArmbinder = Game.GetFormFromFile(0x00CA3A, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousYoke = Game.GetFormFromFile(0x02C531, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousPlugAnal = Game.GetFormFromFile(0x01DD7D, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousPlugVaginal = Game.GetFormFromFile(0x01DD7C, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousSuit = Game.GetFormFromFile(0x02AFA3, "Devious Devices - Assets.esm") as Keyword
	zad_Lockable = Game.GetFormFromFile(0x003894, "Devious Devices - Assets.esm") as Keyword
	
	zad_DeviousPetSuit = Game.GetFormFromFile(0x086C1D, "Devious Devices - Integration.esm") as Keyword
	zad_DeviousStraitJacket = Game.GetFormFromFile(0x060A46, "Devious Devices - Integration.esm") as Keyword
	zad_DeviousHeavyBondage = Game.GetFormFromFile(0x05226C, "Devious Devices - Integration.esm") as Keyword
	zad_DeviousArmbinderElbow = Game.GetFormFromFile(0x062539, "Devious Devices - Integration.esm") as Keyword
	zad_DeviousYokeBB = Game.GetFormFromFile(0x062538, "Devious Devices - Integration.esm") as Keyword
	zad_DeviousAnkleShackles = Game.GetFormFromFile(0x05F4BB, "Devious Devices - Integration.esm") as Keyword
	zad_DeviousBondageMittens = Game.GetFormFromFile(0x05FF81, "Devious Devices - Integration.esm") as Keyword
	zad_DeviousHood = Game.GetFormFromFile(0x02AFA2, "Devious Devices - Assets.esm") as Keyword
	zad_DeviousHobbleSkirt = Game.GetFormFromFile(0x05F4BA, "Devious Devices - Integration.esm") as Keyword
	
	;zad_DialGagHard = Game.GetFormFromFile(0x07C51F, "Devious Devices - Integration.esm") as Keyword
	zad_BlockGeneric  = Game.GetFormFromFile(0x0429FB, "Devious Devices - Integration.esm") as Keyword

	_MWA_DeviceExceptions.AddForm(zad_DeviousBondageMittens)
	_MWA_DeviceExceptions.AddForm(zad_DeviousGloves)
	_MWA_DeviceExceptions.AddForm(zad_DeviousArmbinder)
	_MWA_DeviceExceptions.AddForm(zad_DeviousArmbinderElbow)
	_MWA_DeviceExceptions.AddForm(zad_DeviousYoke)
	_MWA_DeviceExceptions.AddForm(zad_DeviousYokeBB)
	_MWA_DeviceExceptions.AddForm(zad_DeviousSuit)
	_MWA_DeviceExceptions.AddForm(zad_DeviousPetSuit)
	_MWA_DeviceExceptions.AddForm(zad_DeviousStraitJacket)
	_MWA_DeviceExceptions.AddForm(zad_DeviousHobbleSkirt)
	
	; Create a corrsponding list of exception keywords and their associated string to search the json file for
	ExceptionKeywords = new Keyword[10]
	ExceptionKeywords[0] = zad_DeviousBondageMittens
	ExceptionKeywords[1] = zad_DeviousGloves
	ExceptionKeywords[2] = zad_DeviousArmbinder
	ExceptionKeywords[3] = zad_DeviousArmbinderElbow
	ExceptionKeywords[4] = zad_DeviousYoke
	ExceptionKeywords[5] = zad_DeviousYokeBB
	ExceptionKeywords[6] = zad_DeviousSuit
	ExceptionKeywords[7] = zad_DeviousPetSuit
	ExceptionKeywords[8] = zad_DeviousStraitJacket
	ExceptionKeywords[9] = zad_DeviousHobbleSkirt
	
	ExceptionStrings = new String[10]
	ExceptionStrings[0] = "mitts" ; Not used - Use instead GetDeviceByTags
	ExceptionStrings[1] = "gloves" ; Not used - Use instead GetDeviceByTags
	ExceptionStrings[2] = "armbinders"
	ExceptionStrings[3] = "elbowbinders"
	ExceptionStrings[4] = "yokes"
	ExceptionStrings[5] = "breastyokes"
	ExceptionStrings[6] = "suits"
	ExceptionStrings[7] = "petsuits"
	ExceptionStrings[8] = "straitjackets"
	ExceptionStrings[9] = "hobbleskirts"
	
	;/
	DeviousSlots = new Int[17]
	DeviousSlots[0] = 30 ; Head (Hood)
	DeviousSlots[1] = 32 ; Body
	DeviousSlots[2] = 33 ; Gloves
	DeviousSlots[3] = 37 ; Boots
	DeviousSlots[4] = 44 ; Gag
	DeviousSlots[5] = 45 ; Collar
	DeviousSlots[6] = 46 ; Armbinder
	DeviousSlots[7] = 48 ; Anal Plug
	DeviousSlots[8] = 49 ; Chastity Belt
	DeviousSlots[9] = 50 ; Vaginal Piercing
	DeviousSlots[10] = 51 ; Nipple Piercings
	DeviousSlots[11] = 53 ; Leg Cuffs
	DeviousSlots[12] = 55 ; Blindfold
	DeviousSlots[13] = 56 ; Chastity Bra
	DeviousSlots[14] = 57 ; Vaginal Plug
	DeviousSlots[15] = 58 ; Harness/Corset
	DeviousSlots[16] = 59 ; Arm Cuffs
	/;
EndEvent

State Installed
	Event OnEndState()
	EndEvent
	
	Function PoofToDevice(Form akBaseObject, ObjectReference ObjRef)
		_MWA_DeviceSelection.Revert()
		Armor Device
		Bool WasAllProc = false ; Set to true when PoofToAny() is used so that piercings aren't proced twice. 
		If akBaseObject as Armor
			Armor akArmor = akBaseObject as Armor
			If Math.LogicalAnd((akArmor).GetSlotMask(), 4) == 4 ; Body
				PoofToBody()
			ElseIf Math.LogicalAnd((akArmor).GetSlotMask(), 128) == 128 ; Feet
				PoofToFeet()
			ElseIf Math.LogicalAnd((akArmor).GetSlotMask(), 8) == 8 ; Hands
				PoofToHands()
			ElseIf Math.LogicalAnd((akArmor).GetSlotMask(), 1) == 1 || Math.LogicalAnd((akArmor).GetSlotMask(), 2) == 2 ; Head / Hair
				PoofToHead()
			Else ; Other slots
				WasAllProc = true
				PoofToAny()
			EndIf
		
		ElseIf akBaseObject as Weapon
			WasAllProc = true
			PoofToAny()
		EndIf
		;/
		Debug.Trace("_MWA_: Device Selection List: ==================================================== ")
		Int i = 0
		While i < _MWA_DeviceSelection.GetSize()
			Debug.Trace("_MWA_: " + i + ") " + _MWA_DeviceSelection.GetAt(i))
			i += 1
		EndWhile
		/;
		Device = GetRandomDeviceByKeyword()
		If Device == None
			PoofToAny()
			Device = GetRandomDeviceByKeyword()
		EndIf
		BeginDeviceSwap(akBaseObject, ObjRef, Device, WasAllProc)
	EndFunction
	
	Function PoofToAny()
		PoofToBody()
		PoofToFeet()
		PoofToHands()
		PoofToHead()
		PoofToOther()
	EndFunction
	
	Function PoofToBody()
		If !PlayerRef.WornHasKeyword(zad_DeviousHarness) && !PlayerRef.WornHasKeyword(zad_DeviousCorset)
			If Menu.AllowDeviousCorsets
				_MWA_DeviceSelection.AddForm(zad_DeviousCorset)
			EndIf
			If Menu.AllowDeviousHarnesses && !PlayerRef.WornHasKeyword(zad_DeviousBelt) && !PlayerRef.WornHasKeyword(zad_DeviousCollar)
				_MWA_DeviceSelection.AddForm(zad_DeviousHarness)
			EndIf
		EndIf
		If Menu.AllowDeviousBelts && !PlayerRef.WornHasKeyword(zad_DeviousBelt) && !PlayerRef.WornHasKeyword(zad_DeviousHarness)
			_MWA_DeviceSelection.AddForm(zad_DeviousBelt)
		EndIf
		If Menu.AllowDeviousBras && !PlayerRef.WornHasKeyword(zad_DeviousBra)
			_MWA_DeviceSelection.AddForm(zad_DeviousBra)
		EndIf
		If !PlayerRef.WornHasKeyword(zad_DeviousSuit) && !PlayerRef.WornHasKeyword(zad_DeviousPetSuit) ;&& !PlayerRef.WornHasKeyword(zad_DeviousStraitJacket) && !PlayerRef.WornHasKeyword(zad_DeviousHobbleSkirt) - 2x Not needed?
			If Menu.AllowDeviousSuits
				_MWA_DeviceSelection.AddForm(zad_DeviousSuit)
			EndIf
			If Menu.AllowDeviousHobble
				_MWA_DeviceSelection.AddForm(zad_DeviousHobbleSkirt)
			EndIf
			If Menu.AllowDeviousPetSuits
				_MWA_DeviceSelection.AddForm(zad_DeviousPetSuit)
			EndIf
			If Menu.AllowDeviousStraitJackets
				_MWA_DeviceSelection.AddForm(zad_DeviousStraitJacket)
			EndIf
		EndIf
		If PlayerRef.WornHasKeyword(zad_DeviousBelt) || PlayerRef.WornHasKeyword(zad_DeviousHarness)
			If Menu.AllowDeviousPlugsAnal && !PlayerRef.WornHasKeyword(zad_DeviousPlugAnal)
				_MWA_DeviceSelection.AddForm(zad_DeviousPlugAnal)
			EndIf
			If Menu.AllowDeviousPlugsVag && !PlayerRef.WornHasKeyword(zad_DeviousPlugVaginal)
				_MWA_DeviceSelection.AddForm(zad_DeviousPlugVaginal)
			EndIf
		EndIf
	EndFunction
	
	Function PoofToFeet()
		If Menu.AllowDeviousBoots && !PlayerRef.WornHasKeyword(zad_DeviousBoots)
			_MWA_DeviceSelection.AddForm(zad_DeviousBoots)
		EndIf
		If Menu.AllowDeviousLegCuffs && !PlayerRef.WornHasKeyword(zad_DeviousLegCuffs) && !PlayerRef.WornHasKeyword(zad_DeviousAnkleShackles)
			_MWA_DeviceSelection.AddForm(zad_DeviousLegCuffs)
			_MWA_DeviceSelection.AddForm(zad_DeviousAnkleShackles)
		EndIf
	EndFunction
	
	Function PoofToHands()
		If !PlayerRef.WornHasKeyword(zad_DeviousGloves)
			If Menu.AllowDeviousGloves
				_MWA_DeviceSelection.AddForm(zad_DeviousGloves)
			EndIf
			If Menu.AllowDeviousMittens
				_MWA_DeviceSelection.AddForm(zad_DeviousBondageMittens)
			EndIf
		EndIf
		If Menu.AllowDeviousArmCuffs && !PlayerRef.WornHasKeyword(zad_DeviousArmCuffs)
			_MWA_DeviceSelection.AddForm(zad_DeviousArmCuffs)
		EndIf
		If Menu.AllowDeviousArmbinders && !PlayerRef.WornHasKeyword(zad_DeviousArmbinder) && !PlayerRef.WornHasKeyword(zad_DeviousYoke) && !PlayerRef.WornHasKeyword(zad_DeviousYokeBB) && !PlayerRef.WornHasKeyword(zad_DeviousArmbinderElbow) && !PlayerRef.WornHasKeyword(zad_DeviousPetSuit) && !PlayerRef.WornHasKeyword(zad_DeviousStraitJacket)
			_MWA_DeviceSelection.AddForm(zad_DeviousArmbinder)
			_MWA_DeviceSelection.AddForm(zad_DeviousYoke)
			_MWA_DeviceSelection.AddForm(zad_DeviousYokeBB)
			_MWA_DeviceSelection.AddForm(zad_DeviousArmbinderElbow)
		EndIf
	EndFunction
	
	Function PoofToHead()
		If Menu.AllowDeviousGags && !PlayerRef.WornHasKeyword(zad_DeviousGag)
			_MWA_DeviceSelection.AddForm(zad_DeviousGag)
		EndIf
		If Menu.AllowDeviousBlindfolds && !PlayerRef.WornHasKeyword(zad_DeviousBlindfold)
			_MWA_DeviceSelection.AddForm(zad_DeviousBlindfold)
		EndIf
		If Menu.AllowDeviousCollars && !PlayerRef.WornHasKeyword(zad_DeviousCollar) && !PlayerRef.WornHasKeyword(zad_DeviousHarness)
			_MWA_DeviceSelection.AddForm(zad_DeviousCollar)
		EndIf
	EndFunction
		
	Function PoofToOther()
		If Menu.AllowDeviousNipples && !PlayerRef.WornHasKeyword(zad_DeviousPiercingsNipple)
			_MWA_DeviceSelection.AddForm(zad_DeviousPiercingsNipple)
		EndIf
		If Menu.AllowDeviousClit && !PlayerRef.WornHasKeyword(zad_DeviousPiercingsVaginal)
			_MWA_DeviceSelection.AddForm(zad_DeviousPiercingsVaginal)
		EndIf
	EndFunction
	
	Function BeginDeviceSwap(Form akBaseObject, ObjectReference ObjRef, Armor Device, Bool WasAllProc)
		If !Device && !WasAllProc ; Give a chance to convert to piercings if there's no area appropriate devices left. 
			_MWA_DeviceSelection.Revert()
			PoofToOther()
			Device = GetRandomDeviceByKeyword()
		EndIf
		DoDeviceSwap(akBaseObject, ObjRef, Device)
	EndFunction
	
	Function DoDeviceSwap(Form akBaseObject, ObjectReference ObjRef, Armor Device)
		If Device
			Bool WasCovered = false
			;PlayerRef.RemoveItem(ObjRef)
			If CurseUnequip
				PlayerRef.UnequipItem(akBaseObject)
				Debug.Notification(akBaseObject.GetName() + " is cursed and must be sanctified first")
			EndIf
			If CurseDestroy
				_MWA_CursedObjectDumpRef.AddItem(ObjRef)
			EndIf
			While Utility.IsInMenuMode()
				Input.TapKey(Input.GetMappedKey("Tween Menu", DeviceType = 0xFF))
				Utility.WaitMenuMode(0.1)
			EndWhile
			If CurseExplosionEffectPush ; Could not seem to apply seperate magic effects with a global condition.... (CK bug?)
				_MWA_CursedObjectEffectSpell.Cast(PlayerRef, PlayerRef)
			Else
				_MWA_CursedObjectEffectNoPushSpell.Cast(PlayerRef, PlayerRef)
			EndIf
			If PlayerRef.WornHasKeyword(ArmorCuirass) || PlayerRef.WornHasKeyword(ClothingBody)
				WasCovered = true
			EndIf
			EquipDevice(PlayerRef, Device)
			Utility.Wait(0.1)
			If WasCovered && !(PlayerRef.WornHasKeyword(ArmorCuirass) || PlayerRef.WornHasKeyword(ClothingBody) || PlayerRef.WornHasKeyword(zad_DeviousGag))
				Utility.Wait(1.0)
				Int Gasp = _MWA_FemaleGasp.Play(PlayerRef)
			EndIf
			
		Else
			If CurseUnequip
				PlayerRef.UnequipItem(akBaseObject)
				Debug.Notification(akBaseObject.GetName() + " is cursed and must be sanctified first")
			EndIf
			If CurseDestroy
				_MWA_CursedObjectDumpRef.AddItem(ObjRef)
			EndIf			
		EndIf
	EndFunction
	
	Armor Function GetRandomDeviceByKeyword()
		Keyword KwSelect
		Armor DeviceSelect
		While DeviceSelect == None && _MWA_DeviceSelection.GetSize() > 0
			KwSelect = _MWA_DeviceSelection.GetAt(Utility.RandomInt(0, _MWA_DeviceSelection.GetSize() - 1)) as Keyword
			
			If _MWA_DeviceExceptions.HasForm(KwSelect) ; Is an awkward keyword that doesn't either A) filter right - zad_DeviousGloves returning gloves and mitts or B) doesn't return any device at all.... - Armbinders, straitjackets, petsuits, mitts, yoke, elbowbinder
				If KwSelect == zad_DeviousGloves ; Handle gloves/mittens via GetDeviceByTags
					DeviceSelect = GetDeviceByTags(KwSelect,  tags = "gloves", requireAll = true, tagsToSuppress = "mittens", fallBack = true)
				ElseIf KwSelect == zad_DeviousBondageMittens
					DeviceSelect = GetDeviceByTags(zad_DeviousGloves,  tags = "mittens", requireAll = true, tagsToSuppress = "gloves", fallBack = true)
				
				Else ; Handle the rest via the json file
					String DeviceCat = ExceptionStrings[ExceptionKeywords.Find(KwSelect)]
					DeviceSelect = JsonUtil.FormlistGet("MWA/DeviceList.json", DeviceCat, Utility.RandomInt(0, JsonUtil.FormlistCount("MWA/DeviceList.json", DeviceCat) - 1)) as Armor
				EndIf
			
			Else
				DeviceSelect = GetGenericDeviceByKeyword(KwSelect)
			EndIf
			_MWA_DeviceSelection.RemoveAddedForm(KwSelect)
		EndWhile
		Debug.Trace("_MWA_: Selected curse keyword >>>>>>> " + KwSelect + ". Device: " + DeviceSelect)
		Return DeviceSelect
	EndFunction
	
	Armor Function GetGenericDeviceByKeyword(Keyword kw)
		Return _MWA_IntDevious.GetGenericDeviceByKeyword(libsQuest, kw)
	EndFunction
	
	Armor Function GetDeviceByTags(Keyword kw, String tags, bool requireAll = true, String tagsToSuppress = "", bool fallBack = true)
		Return _MWA_IntDevious.GetDeviceByTags(libsQuest, kw, tags, requireAll = true, tagsToSuppress = "", fallBack = true)
	EndFunction
	
	Function EquipDevice(Actor akActor, Armor deviceInventory)
		debug.trace("_MWA_: Devious.EquipDevice: " + deviceInventory + " - " + deviceInventory.GetName())
		_MWA_IntDevious.EquipDevice(libsQuest, akActor, deviceInventory)
	EndFunction
EndState

Function PoofToDevice(Form akBaseObject, ObjectReference ObjRef)
EndFunction

Function PoofToAny()
EndFunction

Function PoofToBody()
EndFunction

Function PoofToFeet()
EndFunction

Function PoofToHands()
EndFunction

Function PoofToHead()
EndFunction

Function PoofToOther()
EndFunction

Function BeginDeviceSwap(Form akBaseObject, ObjectReference ObjRef, Armor Device, Bool WasAllProc)
EndFunction

Function DoDeviceSwap(Form akBaseObject, ObjectReference ObjRef, Armor Device)
EndFunction

Armor Function GetRandomDeviceByKeyword()
	Return None
EndFunction

Armor Function GetGenericDeviceByKeyword(Keyword kw)
	Return None
EndFunction

Armor Function GetDeviceByTags(Keyword kw, String tags, bool requireAll = true, String tagsToSuppress = "", bool fallBack = true)
	Return None
EndFunction

Function EquipDevice(Actor akActor, Armor deviceInventory)
EndFunction

Bool Property CurseUnequip = false Auto Hidden
Bool Property CurseDestroy = false Auto Hidden
Bool Property CurseExplosionEffectPush = true Auto Hidden

Quest libsQuest

Int[] DeviousSlots
Keyword[] ExceptionKeywords
String[] ExceptionStrings

Formlist Property _MWA_DeviceSelection Auto
Formlist Property _MWA_DeviceExceptions Auto

Keyword Property ClothingBody Auto
Keyword Property ArmorCuirass Auto

Keyword Property zad_DeviousBlindfold Auto Hidden
Keyword Property zad_DeviousBoots Auto Hidden
Keyword Property zad_DeviousCollar Auto Hidden
Keyword Property zad_DeviousHarness Auto Hidden
Keyword Property zad_DeviousCorset Auto Hidden
Keyword Property zad_DeviousArmCuffs Auto Hidden
Keyword Property zad_DeviousLegCuffs Auto Hidden
Keyword Property zad_DeviousGag Auto Hidden
Keyword Property zad_DeviousGloves Auto Hidden
Keyword Property zad_DeviousPiercingsNipple Auto Hidden
Keyword Property zad_DeviousPiercingsVaginal Auto Hidden
Keyword Property zad_DeviousHeavyBondage Auto Hidden
Keyword Property zad_PermitOral Auto Hidden
Keyword Property zad_DeviousBelt Auto Hidden
Keyword Property zad_DeviousBra Auto Hidden
Keyword Property zad_DeviousArmbinder Auto Hidden
Keyword Property zad_DeviousArmbinderElbow Auto Hidden
Keyword Property zad_DeviousYoke Auto Hidden
Keyword Property zad_DeviousYokeBB Auto Hidden
Keyword Property zad_DeviousPlugAnal Auto Hidden
Keyword Property zad_DeviousPlugVaginal Auto Hidden
Keyword Property zad_DeviousSuit Auto Hidden
Keyword Property zad_DeviousPetSuit  Auto Hidden
Keyword Property zad_DeviousStraitJacket Auto Hidden
Keyword Property zad_DeviousAnkleShackles Auto Hidden
Keyword Property zad_DeviousBondageMittens Auto Hidden
Keyword Property zad_DeviousHood Auto Hidden
Keyword Property zad_DeviousHobbleSkirt Auto Hidden
;Keyword Property zad_DialGagHard Auto Hidden
Keyword Property zad_Lockable Auto Hidden
Keyword Property zad_BlockGeneric Auto Hidden

Actor Property PlayerRef Auto

ObjectReference Property _MWA_CursedObjectDumpRef Auto

Spell Property _MWA_CursedObjectEffectSpell Auto
Spell Property _MWA_CursedObjectEffectNoPushSpell Auto

Sound Property _MWA_FemaleGasp Auto

_MWA_Mcm Property Menu Auto
