Scriptname _MWA_Mcm extends SKI_ConfigBase  

; MCM Config Begin =======================================================

Function PlayerLoadsGame()
	If Game.GetModByName("Devious Devices - Expansion.esm") != 255
		If !DdsInstalled
			DdsInstalled = true
			BuildPages()
		EndIf
	Else
		If DdsInstalled
			DdsInstalled = false
			BuildPages()
		EndIf
	EndIf
	If Game.GetModByName("Requiem.esp") != 255
		OoTemperMax = 8.1
	Else
		OoTemperMax = 1.7
	EndIf
EndFunction

Event OnConfigInit()
	SetupMenuArrays()
EndEvent

Function SetupMenuArrays()
	BuildPages()
	
	DropTypeList = new string[2]
	DropTypeList[0] = "Unequip "
	DropTypeList[1] = "Safe Drop"
	
	DestructableTypesList = new string[4]
	DestructableTypesList[0] = "Original "
	DestructableTypesList[1] = "Original + Jewelry"
	DestructableTypesList[2] = "Original + Daedric"
	DestructableTypesList[3] = "Everything "
	
	ObjectSearchVisionTypeList = new String[3]
	ObjectSearchVisionTypeList[0] = "Disabled "
	ObjectSearchVisionTypeList[1] = "Glow Only"
	ObjectSearchVisionTypeList[2] = "Glow & Aura"
EndFunction

Function BuildPages()
	If Game.GetModByName("Devious Devices - Expansion.esm") != 255
		Pages = new string[8]
		Pages[0] = "General Settings"
		Pages[1] = "Durability "
		Pages[2] = "Degradation "
		Pages[3] = "Magic Armor"
		Pages[4] = "Repair/Refit"
		Pages[5] = "Equip Status"
		Pages[6] = "Object Options"
		Pages[7] = "Cursed Objects"
	Else
		Pages = new string[7]
		Pages[0] = "General Settings"
		Pages[1] = "Durability "
		Pages[2] = "Degradation "
		Pages[3] = "Magic Armor"
		Pages[4] = "Repair/Refit"
		Pages[5] = "Equip Status"
		Pages[6] = "Object Options"
	EndIf
EndFunction

Event OnPageReset(string page)
	SetCursorFillMode(LEFT_TO_RIGHT)
	OoSelectedObject = None
	SelectedObjectForm = None
	
	If Page == ""
		LoadCustomContent("MWA/Mcm.dds")
		Return
	Else
		UnloadCustomContent()
	EndIf
	If(page == "General Settings")
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption("Mod Controls")
		MasterSwitchTOID = AddToggleOption("Enable Mod", MasterSwitchT)
		AliasCleanupOID_T = AddTextOption("Run Alias Cleanup Routine", "")
		AddEmptyOption()
		
		AddHeaderOption("Player Degradation Controls")
		DegradationTOID = AddToggleOption("Player Object Degradation", DegradationT)
		AddEmptyOption()

		AddHeaderOption("World Degradation Controls")
		NpcDegradationScanTOID = AddToggleOption("Scan Enemy Npcs", NpcDegradationScanT)
		WorldObjectScanTOID = AddToggleOption("Scan World Objects", WorldObjectScanT)
		ContainerScanTOID = AddToggleOption("Scan Containers", ContainerScanT)
		ContainerScanMaxItemsOID_S = AddSliderOption("Max Number Of Items: ", ContainerScanMaxItems, "{0} items")
		AddEmptyOption()
		
		AddHeaderOption("Food Options")
		;RemoveFoodCANsOID_S = AddToggleOption("Remove Food From Containers & Npcs", RemoveFoodCANs)
		RemoveFoodCANsOID_S = AddSliderOption("Remove From Containers & Npcs:", RemoveFoodCANs, "{1}%")
		RemoveFoodWorldTOID = AddToggleOption("Remove From World", RemoveFoodWorldT)
		AddEmptyOption()
		
		AddHeaderOption("Lockpick Options")
		;RemoveFoodCANsOID_S = AddToggleOption("Remove Food From Containers & Npcs", RemoveFoodCANs)
		RemoveLockpicksOID_S = AddSliderOption("Remove From Containers & Npcs:", RemoveLockpicks, "{1}%")
		LockpickValueOID_S = AddSliderOption("Lockpick Value:", LockpickValue, "{0} Gold")
		AddEmptyOption()
		
		AddHeaderOption("Combat Equipping")
		Int CombatEquipFlag
		If CombatEquipT
			CombatEquipFlag = OPTION_FLAG_NONE
		Else
			CombatEquipFlag = OPTION_FLAG_DISABLED
		Endif
		CombatEquipTOID = AddToggleOption("Enable Combat Equipping", CombatEquipT)
		CombatEquipWaitPerItemTOID = AddToggleOption("Time Needed Is Per Item", CombatEquipWaitPerItemT, CombatEquipFlag)
		CombatEquipTimeOID_S = AddSliderOption("Time Needed To Equip: ", CombatEquipTime, "{2} Seconds", CombatEquipFlag)
		AddEmptyOption()

		
		Int SlFlag
		If Init.IsSexlabInstalled
			SlFlag = OPTION_FLAG_NONE
		Else
			SlFlag = OPTION_FLAG_DISABLED
		EndIf
		AddHeaderOption("SL Options")
		RapeMinDamageOID_S = AddSliderOption("Min Damage: ", RapeMinDamage, "{0}", SlFlag)
		RapeMaxDamageOID_S = AddSliderOption("Max Damage: ", RapeMaxDamage, "{0}", SlFlag)
		AddEmptyOption()
		
		AddHeaderOption("Interfaces ")
		SexlabIntOIDT = AddToggleOption("SL Interface", SexlabInterface.GetIsInterfaceActive())
		
		
		SetCursorPosition(1)
		AddHeaderOption("Save/Load Settings")
		ExportSettingsOID_T = AddTextOption("Export Settings ", "")
		ImportSettingsOID_T = AddTextOption("Import Settings", "")
		AddEmptyOption()
		
		AddHeaderOption("Object Destruction")
		DestructableTypesDB = AddMenuOption("Destructible Types: ", DestructableTypesList[DestructableTypes], 0)
		DropTypeDB = AddMenuOption("Destruction Method: ", DropTypeList[DropType], 0)
		BreakSoundVolumeOID_S = AddSliderOption("Break Sound Volume: ", BreakSoundVolume * 100.0, "{0}%")
		DestructStaggerOID_S = AddSliderOption("Object Destruction Staggers", DestructStagger, "{0}%")
		
		ObjectSearchVisionTypeDB = AddMenuOption("Object Search Vision: ", ObjectSearchVisionTypeList[ObjectSearchVisionType], 0)
		If DropType != 1
			LostObjectSearchTimeOID_S = AddSliderOption("Time To Find Broken Object: ", LostObjectSearchTime, "{0} seconds", OPTION_FLAG_DISABLED)
		Else
			LostObjectSearchTimeOID_S = AddSliderOption("Time To Find Broken Object: ", LostObjectSearchTime, "{0} seconds")
		EndIf
		DroppedTeleportDistanceOID_S = AddSliderOption("Teleport Distance: ", DroppedTeleportDistance, "{0}")
		SearchBoxNotifyTOID = AddToggleOption("Search Box Notifications", SearchBoxNotifyT)
		ObjectLossChanceOID_S = AddSliderOption("Complete Destruction Chance: ", ObjectLossChance, "{1}%")
		AddEmptyOption()
		
		AddHeaderOption("Item Suitability")
		SuitabilityTOID = AddToggleOption("Enable Suitability", SuitabilityT)
		SuitabilityBodyTOID = AddToggleOption("Body Only", SuitabilityBodyT)
		SuitabilityWeightOID_S = AddSliderOption("Weight must be +/- ", SuitabilityWeight, "{0}")
		SuitabilityBikiniOID_S = AddSliderOption("Bikini Weight must be +/- ", SuitabilityBikini, "{0}")
		SuitabilityDescripOID = AddToggleOption("Add Fit To Item Name", AddSuitabilityDes)
		EverythingFitsTOID = AddToggleOption("Everything Fits!", EverythingFits)
		ItemFitsPcChanceOID_S = AddSliderOption("Chance To Find Fitting Item", ItemFitsPcChance, "{0}%")
		RandomNpcFitTOID = AddToggleOption("Randomize Npcs", RandomNpcFitT)
		AddEmptyOption()
		
	ElseIf(page == "Durability ")
		SetCursorFillMode(LEFT_TO_RIGHT)
		AddMaterialBonusTOID =  AddToggleOption("Material Type Durability Bonus", AddMaterialBonusT)
		DurabilityToleranceOID_S = AddSliderOption("Durability Tolerance: ", DurabilityTolerance, "{0}%")
		ResetWornDursOID_T = AddTextOption("Reset Worn Durabilities ", "")
		ResetDurCacheOID_T = AddTextOption("Reset Durability Cache ", "")
		SkipLine()
		DurabilityMinOID_S = AddSliderOption("Durability Minimum: ", DurabilityMin * 100.0, "{0}%")
		DurabilityMaxOID_S = AddSliderOption("Durability Maximum: ", DurabilityMax * 100.0, "{0}%")
		CorpseDurabilityMinOID_S = AddSliderOption("Corpse Durability Minimum: ", CorpseDurabilityMin * 100.0, "{0}%")
		CorpseDurabilityMaxOID_S = AddSliderOption("Corpse Durability Maximum: ", CorpseDurabilityMax * 100.0, "{0}%")
		SkipLine()
		
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption("Armor ")
		ClothesDurabilityOID_S = AddSliderOption("Durability Clothing: ", ClothesDurability, "{0}")
		LightDurabilityOID_S = AddSliderOption("Durability Light Armor: ", LightDurability, "{0}")
		HeavyDurabilityOID_S = AddSliderOption("Durability Heavy Armor: ", HeavyDurability, "{0}")
		ShieldDurabilityModOID_S = AddSliderOption("Shield Durability Mod: ", ShieldDurabilityMod, "{1}")
		SkipLine()
		
		SetCursorPosition(11)
		
		AddEmptyOption()
		AddHeaderOption("Weapons ")
		OneHDurabilityOID_S = AddSliderOption("Swords, Waraxes, Maces: ", OneHDurability, "{0}")
		TwoHDurabilityOID_S = AddSliderOption("Greatswords, Battleaxes, Warhammers: ", TwoHDurability, "{0}")
		RangedDurabilityOID_S = AddSliderOption("Bows, Crossbows: ", RangedDurability, "{0}")
		DaggerDurabilityOID_S = AddSliderOption("Daggers: ", DaggerDurability, "{0}")
		StaffDurabilityOID_S = AddSliderOption("Staves: ", StaffDurability, "{0}")
		
	ElseIf(page == "Degradation ")
		AddEmptyOption()
		AddTextOption("Requiem Installed: " + Init.IsRequiemInstalled, "")
		AddHeaderOption("Armor Degradation")
		AddHeaderOption("")
		TemperDegradeOID_S = AddSliderOption("Normal Attack Hit: ", TemperDegrade, "{4}")
		TemperDegradeHitsOID_T = AddTextOption("Hits To Degrade 1 level " + Math.Floor(ItemHealthPerTier / TemperDegrade), "")
		TemperDegradePowerAOID_S = AddSliderOption("Power Attack Hit: ", TemperDegradePowerA, "{4}")
		TemperDegradePowerHitsOID_T = AddTextOption("Power Hits to degrade 1 level " + Math.Floor(ItemHealthPerTier / TemperDegradePowerA), "")
		ArmorHitsPerHitOID_S = AddSliderOption("Number Of Strikes Per Hit: ", ArmorHitsPerHit, "{0}")
		ArmorHitsPerHitRandomTOID = AddToggleOption("Random ", ArmorHitsPerHitRandomT)
		SkipLine()
		
		AddHeaderOption("Armor Vulnerability To Weapons")
		AddEmptyOption()
		ComplexDegradationOID = AddToggleOption("Complex Degradation", ComplexDegradationT)
		AddEmptyOption()
		
		
		Int ComplexDegradeFlag
		If ComplexDegradationT
			ComplexDegradeFlag = OPTION_FLAG_NONE
		Else
			ComplexDegradeFlag = OPTION_FLAG_DISABLED
		EndIf
		
		VulnerabilityMultDaggerOID_S = AddSliderOption("Dagger Vulnerability Mult: ", VulnerabilityMultDagger, "{2}x", ComplexDegradeFlag)
		VulnerabilityMultAxeOID_S = AddSliderOption("Axe Vulnerability Mult: ", VulnerabilityMultAxe, "{2}x", ComplexDegradeFlag)
		VulnerabilityMultSwordOID_S = AddSliderOption("Sword Vulnerability Mult: ", VulnerabilityMultSword, "{2}x", ComplexDegradeFlag)
		VulnerabilityMultBattleAxeOID_S = AddSliderOption("BattleAxe Vulnerability Mult: ", VulnerabilityMultBattleAxe, "{2}x", ComplexDegradeFlag)
		VulnerabilityMultGreatswordOID_S = AddSliderOption("Greatsword Vulnerability Mult: ", VulnerabilityMultGreatsword, "{2}x", ComplexDegradeFlag)
		ExtraDamageChanceAxeOID_S = AddSliderOption("Extra Damage Chance (Axes): ", ExtraDamageChanceAxe, "{0}%", ComplexDegradeFlag)
		SkipLine()
		
		VulnerabilityMultMaceOID_S = AddSliderOption("Mace Vulnerability Mult: ", VulnerabilityMultMace, "{2}x", ComplexDegradeFlag)
		VulnerabilityMultWarhammerOID_S = AddSliderOption("Warhammer Vulnerability Mult: ", VulnerabilityMultWarhammer, "{2}x", ComplexDegradeFlag)
		SkipLine()
		
		AddHeaderOption("Armor Vulnerability To Magic")
		AddEmptyOption()
		VulnerabilityMultFireOID_S = AddSliderOption("Fire Vulnerability Mult: ", VulnerabilityMultFire, "{2}x", ComplexDegradeFlag)
		VulnerabilityMultIceOID_S = AddSliderOption("Ice Vulnerability Mult: ", VulnerabilityMultIce, "{2}x", ComplexDegradeFlag)
		VulnerabilityMultLightningOID_S = AddSliderOption("Lightning Vulnerability Mult: ", VulnerabilityMultLightning, "{2}x", ComplexDegradeFlag)
		ExtraDamageChanceLightningOID_S = AddSliderOption("Extra Damage Chance (Lightning): ", ExtraDamageChanceLightning, "{0}%", ComplexDegradeFlag)
		MagicDegradeCooldownOID_S = AddSliderOption("Magic Attack Cooldown: ", MagicDegradeCooldown, "{2}", ComplexDegradeFlag)
		AddEmptyOption()
		SkipLine()

		AddHeaderOption("Armor Vulnerability To Force Shouts")
		AddEmptyOption()
		VulnerabilityShoutOneOID_S = AddSliderOption("Unrelenting Force 1 Mult: ", VulnerabilityShoutOne, "{2}x", ComplexDegradeFlag)
		VulnerabilityShoutTwoOID_S = AddSliderOption("Unrelenting Force 2 Mult: ", VulnerabilityShoutTwo, "{2}x", ComplexDegradeFlag)
		VulnerabilityShoutThreeOID_S = AddSliderOption("Unrelenting Force 3 Mult: ", VulnerabilityShoutThree, "{2}x", ComplexDegradeFlag)
		AddEmptyOption()
		SkipLine()
		
		AddHeaderOption("Armor Vulnerability To Creatures")
		AddEmptyOption()
		CreatureVulnerabilityOID_S = AddSliderOption("1 x Damage Per: ", CreatureVulnerability, "{0} Points Of Health", ComplexDegradeFlag)
		AddEmptyOption()
		SkipLine()
		
		AddHeaderOption("Weapon Degradation")
		AddHeaderOption("")
		WeaponDegradeOID_S = AddSliderOption("Normal Attack: ", WeaponDegrade, "{4}")
		WeaponDegradeHitsOID_T = AddTextOption("Attacks To Degrade 1 level " + Math.Floor(ItemHealthPerTier / WeaponDegrade), "")
		WeaponDegradePowerOID_S = AddSliderOption("Power Attack: ", WeaponDegradePower, "{4}")
		WeaponDegradePowerHitsOID_T = AddTextOption("Power Attacks to degrade 1 level " + Math.Floor(ItemHealthPerTier / WeaponDegradePower), "")
		SkipLine()
		
		AddHeaderOption("Degradation Over Time ")
		AddHeaderOption("")
		TimeDegradeFreqOID_S = AddSliderOption("How Often: ", TimeDegradeFreq, "{0}")
		TimeDegradeDamageOID_S = AddSliderOption("Degradation Over Time: ", TimeDegradeDamage, "{4}")
		TimeDegradeDurDecTOID = AddToggleOption("Durability Decrease", TimeDegradeDurDecT)
		
	ElseIf(page == "Magic Armor")
		AddHeaderOption("Clothing Deflection:")
		AddHeaderOption("Armor Deflection:")
		MagicArmorClothingOID_S = AddSliderOption("Base Chance For Clothing", MagicArmorClothing, "{0}%")
		MagicArmorArmorOID_S = AddSliderOption("Base Chance For Armor", MagicArmorArmor, "{0}%")
		MagicArmorClothingDeltaOID_S = AddSliderOption("Increase Per Spell Tier", MagicArmorClothingDelta, "{0}%")
		MagicArmorArmorDeltaOID_S = AddSliderOption("Increase Per Spell Tier", MagicArmorArmorDelta, "{0}%")
		
		AddHeaderOption("Power Attacks")
		AddEmptyOption()
		
		MagicArmorPattackOID_S = AddSliderOption("Power Attack Bonus", MagicArmorPattack, "{0}%")
		
	ElseIf(page == "Repair/Refit")
		AddHeaderOption("Destroyed Repair Cost")
		AddEmptyOption()
		RepairCostMinOID_S = AddSliderOption("Minimum Repair Cost: ", RepairCostMin, "{0}")
		AddEmptyOption()
		RepairCostBaseOID_S = AddSliderOption("Repair Cost Base: ", RepairCostBase, "{2}X")
		RepairCostEnchantOID_S = AddSliderOption("Repair Cost Enchantment: ", RepairCostEnchant, "{2}X")
		
		AddHeaderOption("Durability Repair Cost")
		AddEmptyOption()
		DurRepairCostMinOID_S = AddSliderOption("Minimum Repair Cost: ", DurRepairCostMin, "{0}")
		AddEmptyOption()
		DurRepairCostBaseOID_S = AddSliderOption("Repair Cost Base: ", DurRepairCostBase, "{2}X")
		DurRepairCostEnchantOID_S = AddSliderOption("Repair Cost Enchantment: ", DurRepairCostEnchant, "{2}X")
		
		AddHeaderOption("Refit Weight Cost")
		AddEmptyOption()
		TemperingRefitTOID = AddToggleOption("Tempering Refits Armor", TemperingRefitT)
		AddEmptyOption()
		WeightAdjustCostMinOID_S = AddSliderOption("Minimum Weight Refit Cost", WeightAdjustCostMin, "{0}")
		AddEmptyOption()
		WeightAdjustCostBaseOID_S = AddSliderOption("Refit Weight Cost Base", WeightAdjustCostBase, "{2}X")
		WeightAdjustCostEnchantOID_S = AddSliderOption("Refit Weight Cost Enchant", WeightAdjustCostEnchant, "{2}X")
		
		AddHeaderOption("Refit Gender Cost")
		AddEmptyOption()
		GenderAdjustCostMinOID_S = AddSliderOption("Minimum Gender Refit Cost", GenderAdjustCostMin, "{0}")
		AddEmptyOption()
		GenderAdjustCostBaseOID_S = AddSliderOption("Refit Gender Cost Base", GenderAdjustCostBase, "{2}X")
		GenderAdjustCostEnchantOID_S = AddSliderOption("Refit Gender Cost Enchant", GenderAdjustCostEnchant, "{2}X")
		
	ElseIf(page == "Equip Status")
		
		CleanWornListOID_T = AddTextOption("Cleanup Worn List ", "")
		AddEmptyOption()

		AddHeaderOption("Item Name - (Durability)")
		AddHeaderOption("FormID - Object Reference - Object Health")
		ObjectReference ObjRef
		Form akBaseObject
		If ArmorDes.LeftWeapon != None
			ObjRef = ArmorDes.LeftWeapon
			akBaseObject = ObjRef.GetBaseObject()
			AddTextOption(akBaseObject.GetName() + " - " + "(" + StorageUtil.GetIntValue(ObjRef, "_MWA_Durability", missing = -1) + "/" + StorageUtil.GetIntValue(ObjRef, "_MWA_DurabilityMax", missing = -1) + ")", "")
			AddTextOption(akBaseObject.GetFormID() + " - " + StringUtil.Substring(ObjRef, 19, len = 0) + " - " + Util.GetWornObjectHealth(ObjRef, akBaseObject), "")
		EndIf
		If ArmorDes.RightWeapon != None
			ObjRef = ArmorDes.RightWeapon
			akBaseObject = ObjRef.GetBaseObject()
			AddTextOption(akBaseObject.GetName() + " - " + "(" + StorageUtil.GetIntValue(ObjRef, "_MWA_Durability", missing = -1) + "/" + StorageUtil.GetIntValue(ObjRef, "_MWA_DurabilityMax", missing = -1) + ")", "")
			AddTextOption(akBaseObject.GetFormID() + " - " + StringUtil.Substring(ObjRef, 19, len = 0) + " - " + Util.GetWornObjectHealth(ObjRef, akBaseObject), "")
		EndIf
		
		Int i = 0
		While i < StorageUtil.FormListCount(none, "_MWA_WornDestructibles")
			ObjRef = StorageUtil.FormListGet(none, "_MWA_WornDestructibles", i) as ObjectReference
			akBaseObject = ObjRef.GetBaseObject()
			Debug.Trace("_MWA_: Equip Status " + i + " = " + ObjRef)
			AddTextOption(akBaseObject.GetName() + " - " + "(" + StorageUtil.GetIntValue(ObjRef, "_MWA_Durability", missing = -1) + "/" + StorageUtil.GetIntValue(ObjRef, "_MWA_DurabilityMax", missing = -1) + ")", "") 
			AddTextOption(akBaseObject.GetFormID() + " - " + StringUtil.Substring(ObjRef, 19, len = 0) + " - " + Util.GetWornObjectHealth(ObjRef, akBaseObject), "")
			i += 1
		EndWhile
		
	ElseIf(page == "Object Options")
	
	
		; Collect info
		GatherObjects()
		If InvScanned
			ScanAllInvObjects()
		EndIf

		; Get selected object
		ObjectReference ObjRef = StorageUtil.FormListGet(Self, "_MWA_WornListCopy", ObjectSelect) as ObjectReference
		If ObjRef
			SelectedObjectForm = ObjRef.GetBaseObject()
			OoDurability = StorageUtil.GetIntValue(ObjRef, "_MWA_Durability")
			OoDurabilityMax = StorageUtil.GetIntValue(ObjRef, "_MWA_DurabilityMax")
			OoSelectedObject = ObjRef
			OoTemper = Util.GetWornObjectHealth(ObjRef, SelectedObjectForm) ;ObjRef.GetItemHealthPercent()
			OoCursed = StorageUtil.GetIntValue(ObjRef, "_MWA_IsCursedObject", Missing = 0) as Bool
			
		Else
			SelectedObjectForm = StorageUtil.FormListGet(Self, "_MWA_WornListCopy", ObjectSelect)
			OoDurability = 0
			OoDurabilityMax = 0
			OoSelectedObject = None
			OoTemper = 1.0
			OoCursed = false
		EndIf
		
		; Flags
		Int ObjectOptionsFlag = OPTION_FLAG_DISABLED
		If ObjectSelect > 0
			ObjectOptionsFlag = OPTION_FLAG_NONE
		EndIf
		Int HasObjRef = OPTION_FLAG_DISABLED
		Int CursedFlag = OPTION_FLAG_DISABLED
		If ObjRef
			HasObjRef = OPTION_FLAG_NONE
			If Init.IsDdInstalled
				CursedFlag = OPTION_FLAG_NONE
			EndIf
		Endif
	
		; Begin menu
		SetCursorFillMode(TOP_TO_BOTTOM)
		ScanInvOID_T = AddTextOption("Scan Inventory ", "")
		ObjectSelectDB = AddMenuOption("Object Select", EquipListNames[ObjectSelect], 0)
		RenameObjectOID = AddInputOption("Rename Object", EquipListNames[ObjectSelect], HasObjRef)
		ResetObjectNameOID_T = AddTextOption("Reset Object Name ", "", HasObjRef)

		OoAddFittedObjectOID_T = AddTextOption("Add Fitted Object", "", ObjectOptionsFlag)
		OoDurabilityOID_S = AddSliderOption("Durability ", OoDurability, "{0}", HasObjRef)
		OoDurabilityMaxOID_S = AddSliderOption("Durability Max", OoDurabilityMax, "{0}", HasObjRef)
		OoTemperingOID_S = AddSliderOption("Tempering ", OoTemper, "{3}", HasObjRef)
		OoCursedTOID = AddToggleOption("Cursed ", OoCursed, CursedFlag)
	
		String ImmunityString = "Add Immunity"
		If ObjectSelect > 0 && _MWA_ImmuneList.HasForm(SelectedObjectForm)
			;Debug.MessageBox(SelectedObjectForm + " - " + SelectedObjectForm.GetName())
			ImmunityString = "Remove Immunity"
		EndIf
		ModImmunityOID_T = AddTextOption(ImmunityString, "", ObjectOptionsFlag)
		ClearImmuneListOID_T = AddTextOption("Erase Immune List ", "")
		
		SetCursorPosition(1)
		AddHeaderOption("Immune List")
		Int i = _MWA_ImmuneList.GetSize()
		While i > 0
			i -= 1
			AddTextOption(_MWA_ImmuneList.GetAt(i).GetName(), "")
		EndWhile
		
	ElseIf(page == "Cursed Objects")
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption("Settings ")
		CurseUnequipTOID = AddToggleOption("Curse Trigger Unequips", Devious.CurseUnequip)
		CurseDestroyTOID = AddToggleOption("Curse Trigger Destroys", Devious.CurseDestroy)
		CurseForceTOID = AddToggleOption("Explosion Force", Devious.CurseExplosionEffectPush)
		CursedSanctifyCostOID_S = AddSliderOption("Sanctification Cost", _MWA_SanctCost.GetValueInt(), "{0} Gold")
		
		SetCursorPosition(1)
		AddHeaderOption("Cursed Object Chance")
		CursedChanceContainerOID_S = AddSliderOption("Container & World Objects", CursedChanceContainer, "{1}%")
		CursedChanceCorpseOID_S = AddSliderOption("Corpse Objects", CursedChanceCorpse, "{1}%")

		SetCursorPosition(12)
		SetCursorFillMode(LEFT_TO_RIGHT)
		AddHeaderOption("Device Categories")
		AddEmptyOption()
		AllowDeviousBeltsTOID = AddToggleOption("Chastity Belts", AllowDeviousBelts)
		AllowDeviousBrasTOID = AddToggleOption("Chastity Bras", AllowDeviousBras)
		AllowDeviousPlugsAnalTOID = AddToggleOption("Anal Plugs", AllowDeviousPlugsAnal)
		AllowDeviousPlugsVagTOID = AddToggleOption("Vaginal Plugs", AllowDeviousPlugsVag)
		AllowDeviousCorsetsTOID = AddToggleOption("Corsets ", AllowDeviousCorsets)
		AllowDeviousHarnessesTOID = AddToggleOption("Harnesses", AllowDeviousHarnesses)
		AllowDeviousArmCuffsTOID = AddToggleOption("Arm Cuffs", AllowDeviousArmCuffs)
		AllowDeviousLegCuffsTOID = AddToggleOption("Leg Cuffs", AllowDeviousLegCuffs)
		AllowDeviousBootsTOID = AddToggleOption("Boots ", AllowDeviousBoots)
		AllowDeviousGlovesTOID = AddToggleOption("Gloves ", AllowDeviousGloves)
		AllowDeviousMittensTOID = AddToggleOption("Mittens ", AllowDeviousMittens)
		AllowDeviousCollarsTOID = AddToggleOption("Collars ", AllowDeviousCollars)
		AllowDeviousGagsTOID = AddToggleOption("Gags ", AllowDeviousGags)
		AllowDeviousBlindfoldsTOID = AddToggleOption("Blindfolds ", AllowDeviousBlindfolds)
		AllowDeviousNipplesTOID = AddToggleOption("Nipple Piercings", AllowDeviousNipples)
		AllowDeviousClitTOID = AddToggleOption("Clit Piercings", AllowDeviousClit)
		AllowDeviousArmbindersTOID = AddToggleOption("Armbinders ", AllowDeviousArmbinders)
		AllowDeviousElbowBindersTOID = AddToggleOption("Elbow Binders", AllowDeviousElbowBinders)
		AllowDeviousYokesTOID = AddToggleOption("Yokes ", AllowDeviousYokes)
		AllowDeviousBreastYokesTOID = AddToggleOption("Breast Yokes", AllowDeviousBreastYokes)
		AllowDeviousSuitsTOID = AddToggleOption("Suits ", AllowDeviousSuits)
		AllowDeviousHobbleTOID = AddToggleOption("Hobble Skirts", AllowDeviousHobble)
		AllowDeviousStraitJacketsTOID = AddToggleOption("Strait Jackets", AllowDeviousStraitJackets)
		AllowDeviousPetSuitsTOID = AddToggleOption("Pet Suits", AllowDeviousPetSuits)
			
	EndIf
EndEvent

Event OnOptionHighlight(int option)

	; Settings
	If (option == MasterSwitchTOID)
		SetInfoText("Enable/Disable the mod. Shuts down everything\nDurabilities will be lost\nBroken objects will deleted and made unrecoverable")
	ElseIf (option == AliasCleanupOID_T)
		SetInfoText("Run the alias cleanup routine that's normally run on game load\nUse this if you get the 'I simply can not carry any more' message")
	ElseIf (option == DegradationTOID)
		SetInfoText("Disable this if for some reason you need to pause degradation\nThis will pause armor/weapon tempering and durability degradtion (and degradation over time)\nThis should be safe to switch on and off and shouldn't affect broken objects etc")
	ElseIf (option == NpcDegradationScanTOID)
		SetInfoText("Initialize objects in dead Npcs with a durability and fit\nThis can be safely disabled without affecting anything but you won't be able to see the durability or fit before it's added to your inventory\nRequires cell scan - Disabling this may increase performance")
	ElseIf (option == WorldObjectScanTOID)
		SetInfoText("Initialize objects lying around in the world (not in any container) with a durability and fit\nThis can be safely disabled without affecting anything but you won't be able to see the durability or fit of such an object before you pick it up\nRequires cell scan - Disabling this may increase performance")
	ElseIf (option == ContainerScanTOID)
		SetInfoText("Initialize objects in containers (chests/wardrobes etc) with a durability and fit. This can be safely disabled without affecting anything but you won't be able to see the durability or fit before it's added to your inventory\nRequires cell scan - Disabling this may increase performance")
	ElseIf (option == ContainerScanMaxItemsOID_S)
		SetInfoText("I have not discovered any good way of determining whether a container is a shop container\nIt's ok if a shop container is initialized but it can be very slow when they contain a great number of objects\nAny containers with more than this number of object types will not be scanned by the container scanner\nOtherwise there's a good chance you would be able to open the shop store menu and see the items changing")
	ElseIf (option == ExportSettingsOID_T)
		SetInfoText("Save your settings to file /SKSE/Plugins/StorageUtilData/MWA/Settings.json")
	ElseIf (option == ImportSettingsOID_T)
		SetInfoText("Load your settings from file /SKSE/Plugins/StorageUtilData/MWA/Settings.json")
	ElseIf (option == DestructableTypesDB)
		SetInfoText("What types of objects are destroyable. Description is self-explanatory\nOriginal = normal Weapons/Armors/Clothing\nDaedric = daedric artifacts")
	ElseIf (option == DropTypeDB)
		SetInfoText("The method that will be employed when a weapon/armor is destroyed\nUnequip: Basic, straight-forward, unequip to inventory. For wusses\nSafe Drop: Drop the item. A trigger will be moved to your position to help you locate it\n")
	ElseIf (option == BreakSoundVolumeOID_S)
		SetInfoText("The volume of object breaking and grunting sounds")
	ElseIf (option == DestructStaggerOID_S)
		SetInfoText("The chance that when an object is destroyed you will be staggered, leaving you open to follow up attacks")
	ElseIf (option == SearchBoxNotifyTOID)
		SetInfoText("Turns on/off notifications when entering/leaving object search boxes")
	ElseIf (option == ObjectSearchVisionTypeDB)
		SetInfoText("The dropped object vision mode applied automatically when inside a search box and outside of combat. Does not apply to 'Detect Equipment'\nGlow - Highlights the dropped object only. May be difficult to see it it's behind another object or has sunk slightly into the ground\nGlow & Aura: Adds a colored smoke-like field around an dropped object making it easier to see when direct line of sight to it is blocked somehow")
	ElseIf (option == LostObjectSearchTimeOID_S)
		SetInfoText("How long it takes to automatically recover your destroyed weapon/armor\nNote that the timer does not begin during combat")
	ElseIf (option == DroppedTeleportDistanceOID_S)
		SetInfoText("The distance a broken object must be from where it was broken before it will be teleported back")
	ElseIf (option == ObjectLossChanceOID_S)
		SetInfoText("The chance for an object to be utterly destroyed when it's durability drops to zero\nThere will be no chance to recover an item destroyed this way!!!")
	ElseIf (option == ModImmunityOID_T)
		SetInfoText("Add/Remove items from the immune list\nObjects on the immune list will not degrade")
	ElseIf (option == ClearImmuneListOID_T)
		SetInfoText("Completely erase the immune list /SKSE/Plugins/StorageUtilData/MWA/ImmuneObjects.json\nThis is irreversible - Be sure.")
	ElseIf (option == SuitabilityTOID)
		SetInfoText("Enable/Disable clothes and armor suitability\nFemale player characters will only be able to wear clothes or armor that came from female corpses or vice versa\nClothes/armors can be adjusted by tailors/smiths at a cost. Tempering armor also makes it fit your current weight")
	ElseIf (option == SuitabilityBodyTOID)
		SetInfoText("If enabled suitability only affects clothes and armor for the body slot\nIf disabled every piece of armor must match")
	ElseIf (option == SuitabilityWeightOID_S)
		SetInfoText("Not only must the gender of the outfit match but it must be within this much of your characters weight for it to fit\nSet to -1 to disable")
	ElseIf (option == SuitabilityBikiniOID_S)
		SetInfoText("Bikini armors are less constrictive and fit more easily. This is the same as above but for bikini armors. The armor needs to have SL Survivals _SLS_BikiniArmor keyword for it to be considered a bikini")
	ElseIf (option == ItemFitsPcChanceOID_S)
		SetInfoText("Chance for an item to fit your character. Applies only to container/world objects - Not actors\nThis is in addition to the usual, completely random chance an object fits")
	ElseIf (option == SuitabilityDescripOID)
		SetInfoText("Add the fit of an armor to the objects name\nFit will appear as M or F (male or female) and it's fitting weight (0 - 100)\nThe object may need to be picked up to determine it's fit")
	ElseIf (option == EverythingFitsTOID)
		SetInfoText("When this option is enabled anything initialized into MWA will be forced to fit your character")
	ElseIf (option == RandomNpcFitTOID)
		SetInfoText("Randomize the weight of Npcs in the world\nNote that this doesn't actually visually affect the Npcs weight because of broken Skyrim functions so you may pull a size 0 armor off a bandit that looks like size 100\n")
		
	ElseIf (option == RapeMinDamageOID_S) && Init.IsSexlabInstalled
		SetInfoText("The minimum amount of damage inflicted upon each item you are wearing on rape events. Actual damage is random between min & max. Simulates clothes/armor being ripped off\nMWA 'races' Sexlab to damage objects before they are unequipped. As such, some objects may not get damaged\nIf using Defeat you might want to disable it's stripping of armors")
	ElseIf (option == RapeMaxDamageOID_S) && Init.IsSexlabInstalled
		SetInfoText("The maximum amount of damage inflicted upon each item you are wearing on rape events. Actual damage is random between min & max. Simulates clothes/armor being ripped off\nMWA 'races' Sexlab to damage objects before they are unequipped. As such, some objects may not get damaged\nIf using Defeat you might want to disable it's stripping of armors")
	ElseIf (option == CombatEquipTOID)
		SetInfoText("To successfully equip armors during combat your character will need to complete an animation without being interrupted. You can be interrupted by getting hit with either weapons or magic. If enemies are closing in you can interrupt the animation yourself just by moving\nIf interrupted anything you equipped will be unequipped")
	ElseIf (option == CombatEquipWaitPerItemTOID)
		SetInfoText("If enabled every item you equip will increase the amount of time required by 1x the timer\nIf disabled it doesn't matter how much stuff you equip")
	ElseIf (option == CombatEquipTimeOID_S)
		SetInfoText("The amount of time needed to successfully equip armor during combat\nThis does not include the time needed to sheathe your weapon (if drawn)")
	ElseIf (option == RemoveFoodCANsOID_S)
		SetInfoText("Percentage chance to remove a food item from a container or Npc")
	ElseIf (option == RemoveFoodWorldTOID)
		SetInfoText("When enabled removes food lying around in the game world\nMay not remove all food from exterior cells as it only runs once whereas when inside it loops until no more food is found")
	ElseIf (option == RemoveLockpicksOID_S)
		SetInfoText("Chance to remove lockpicks from containers and Npcs")
	ElseIf (option == LockpickValueOID_S)
		SetInfoText("Gold value of lockpicks")
	ElseIf (option == SexlabIntOIDT)
		SetInfoText("If enabled then an active (working) interface to this soft dependency is installed\nIf disabled then a dummy (non-working) interface is installed\nIf you add or remove this soft dependency, you should reinstall MWA. Don't worry, you'll get a reminder if you forget")
		
	; Durability
	ElseIf (option == AddMaterialBonusTOID)
		SetInfoText("Add a bonus to the durability of an item based on what it's made from\nThis way ebony armor/weapons will have a higher durability than steel etc\nThis option also adds a degrade resistance based on material type\nDegrade resistance = higher quality materials degrading more slowly than lower quality items\nEnabling this is better but comes at the cost of increased processing time. There are a lot of keywords to check...")
	ElseIf (option == ResetWornDursOID_T)
		SetInfoText("Updates the durabilities of all worn equipment\nUse this if you have changed durability settings and want your worn items to reflect the changes\nYou can choose to only update the maximum durability which will not change the current durability\nThis will also remove the durability description from items if the option 'Add Durability To Item Name' has been disabled")
	ElseIf (option == ResetDurCacheOID_T)
		SetInfoText("Resets the cached durability for all stored forms\nTry this if stuff is getting assigned a weird maximum durability")
	ElseIf (option == ClothesDurabilityOID_S)
		SetInfoText("The base durability of clothing\nChanging the setting here won't update items that have already been initialized")
	ElseIf (option == LightDurabilityOID_S)
		SetInfoText("The base durability of light armor\nChanging the setting here won't update items that have already been initialized")
	ElseIf (option == HeavyDurabilityOID_S)
		SetInfoText("The base durability of heavy armor\nChanging the setting here won't update items that have already been initialized")
	ElseIf (option == DurabilityToleranceOID_S)
		SetInfoText("Modifies the range of durability\nExample: Base durability = 10 and tolerance = 50%\nThen the highest/lowest durabilities will be 5 - 15")
	ElseIf (option == ShieldDurabilityModOID_S)
		SetInfoText("Further modifier for shields only since they're designed to take a beating\nShield durability = ((Armor type durability) + (Tolerance)) * Shield Modifier")
	ElseIf (option == OneHDurabilityOID_S) || (option == TwoHDurabilityOID_S) || (option == RangedDurabilityOID_S) || (option == DaggerDurabilityOID_S) || (option == StaffDurabilityOID_S)
		SetInfoText("The base durability of the weapon category\nChanging the setting here won't update items that have already been initialized")
	
	ElseIf (option == DurabilityMinOID_S)
		SetInfoText("The minimum durability of objects found in the world or in containers as a percentage of the items maximum durability")
	ElseIf (option == DurabilityMaxOID_S)
		SetInfoText("The maximum durability of objects found in the world or in containers as a percentage of the items maximum durability")
	ElseIf (option == CorpseDurabilityMinOID_S)
		SetInfoText("The minimum durability of objects found on dead NPCs as a percentage of the items maximum durability")
	ElseIf (option == CorpseDurabilityMaxOID_S)
		SetInfoText("The maximum durability of objects found on dead NPCs as a percentage of the items maximum durability")
	
	; Degradation
	ElseIf (option == ComplexDegradationOID)
		SetInfoText("Enable/Disable complex degradation which multiplies the base damage done by weapons/magic depending on what type they are and what type of armor they're hitting")
	ElseIf (option == TemperDegradeOID_S)
		SetInfoText("When a tempered armor piece is hit with a normal attack it will degrade this much\nFor Reference, in vanilla Skyrim tempering (item health) is represented as a number\n1.0 = Untempered. 1.1 = Fine. 1.2 = Superior. 1.3 = Exquisite. 1.4 = Flawless. 1.5 = Epic. 1.6 = Legendary")
	ElseIf (option == TemperDegradeHitsOID_T)
		SetInfoText("How many normal hits an item of armor can take before it degrades one temper level\nThis is just a rough guide and does not include the degrade resistance gained from the material type\nDegrade resistance = Higher quality armor material will wear less quickly than lower quality\nEg: Iron armor will wear faster than ebony armor")
	ElseIf (option == TemperDegradePowerAOID_S)
		SetInfoText("When a tempered armor piece is hit with a power attack it will degrade this much\nFor Reference, in vanilla Skyrim tempering (item health) is represented as a number\n1.0 = Untempered. 1.1 = Fine. 1.2 = Superior. 1.3 = Exquisite. 1.4 = Flawless. 1.5 = Epic. 1.6 = Legendary")
	ElseIf (option == TemperDegradePowerHitsOID_T)
		SetInfoText("How many power attack hits an item of armor can take before it degrades one temper level\nThis is just a rough guide and does not include the degrade resistance gained from the material type\nDegrade resistance = Higher quality armor material will wear less quickly than lower quality\nEg: Iron armor will wear faster than ebony armor")
	
	ElseIf (option == ArmorHitsPerHitOID_S)
		SetInfoText("By default when you're hit it generates one strike on a random piece of equipped armor\nIf you play a nimble character OR a mod setup where 2 or 3 hits kills you OR wear lots of armor pieces (bikini armors) then just affecting one armor piece per hit won't have much impact\nIncrease this if you want one hit to strike multiple armor pieces (it may hit the same piece more than once)\nThe downside is that anything above 1 won't be as instantaneous as the extra strikes take more time to process")
	ElseIf (option == ArmorHitsPerHitRandomTOID)
		SetInfoText("If enabled hits will generate a random number of armor strikes between one and 'Number Of Strikes Per Hit'\nNote that hits are throttled to one at a time\nIf you are hit again while a hit is already processing it will be ignored")
		
	ElseIf (option == WeaponDegradeOID_S)
		SetInfoText("How many normal attacks you can make before a weapon degrades one temper level\nFor Reference, in vanilla Skyrim tempering (item health) is represented as a number\n1.0 = Untempered. 1.1 = Fine. 1.2 = Superior. 1.3 = Exquisite. 1.4 = Flawless. 1.5 = Epic. 1.6 = Legendary")
	ElseIf (option == WeaponDegradeHitsOID_T)
		SetInfoText("How many attacks a weapon can take before it degrades one temper level\nThis is just a rough guide and does not include the degrade resistance gained from the material type\nDegrade resistance = Higher quality armor material will wear less quickly than lower quality\nEg: Iron armor will wear faster than ebony armor")
	ElseIf (option == WeaponDegradePowerOID_S)
		SetInfoText("How many power attacks you can make before a weapon degrades one temper level\nFor Reference, in vanilla Skyrim tempering (item health) is represented as a number\n1.0 = Untempered. 1.1 = Fine. 1.2 = Superior. 1.3 = Exquisite. 1.4 = Flawless. 1.5 = Epic. 1.6 = Legendary")		
	ElseIf (option == WeaponDegradePowerHitsOID_T)
		SetInfoText("How many power attacks a weapon can take before it degrades one temper level\nThis is just a rough guide and does not include the degrade resistance gained from the material type\nDegrade resistance = Higher quality armor material will wear less quickly than lower quality\nEg: Iron armor will wear faster than ebony armor")
	
	ElseIf (option == TimeDegradeFreqOID_S)
		SetInfoText("How often (in game hours) should your worn items degrade\nSet to zero to disable degradation over time")
	ElseIf (option == TimeDegradeDamageOID_S)
		SetInfoText("How much degradation should be applied\nNote that if the object isn't tempered it's durability will instead decrease by one")
	ElseIf (option == TimeDegradeDurDecTOID)
		SetInfoText("If the object isn't tempered decrease it's durability by one\nDurability won't decrease over time if this is disabled")
		
	ElseIf (option == VulnerabilityMultDaggerOID_S) || (option == VulnerabilityMultAxeOID_S) || (option == VulnerabilityMultSwordOID_S) || (option == VulnerabilityMultBattleAxeOID_S) || (option == VulnerabilityMultGreatswordOID_S) || (option == VulnerabilityMultMaceOID_S) || (option == VulnerabilityMultWarhammerOID_S)
		SetInfoText("Multiplies the base damage done to an armor based on what type of weapon hit which type of armor\nDaggers/Swords/Greatswords do extra damage to light armor and clothing\nMaces and warhammers do extra damage to heavy armor. Axes and battleaxes have a chance to deal extra damage to all armor types\nPower attacks will double this amount")
	ElseIf (option == ExtraDamageChanceAxeOID_S)
		SetInfoText("The chance axes and battleaxes have to do extra damage per hit")
		
	ElseIf (option == VulnerabilityMultFireOID_S) || (option == VulnerabilityMultIceOID_S) || (option == VulnerabilityMultLightningOID_S) 
		SetInfoText("Different magic types are more effective against certain armor types\nFire magic does extra damage to light armor and clothing. Ice magic does extra damage to heavy armor\nLightning magic has a chance to do extra damage to all armor types")
	ElseIf (option == ExtraDamageChanceLightningOID_S)
		SetInfoText("The chance for lightning magic to do extra damage per hit")
	ElseIf (option == MagicDegradeCooldownOID_S)
		SetInfoText("The cooldown between magic attacks degrading your armor\nAnother magic hit while cooling down will have no effect\nThis is to stop continuous spells like Flamesparks melting your armor off you")
	ElseIf (option == VulnerabilityShoutOneOID_S)
		SetInfoText("Damage multiplier applied to an armor when hit by an unrelenting force shout level 1")
	ElseIf (option == VulnerabilityShoutTwoOID_S)
		SetInfoText("Damage multiplier applied to an armor when hit by an unrelenting force shout level 2")
	ElseIf (option == VulnerabilityShoutThreeOID_S)
		SetInfoText("Damage multiplier applied to an armor when hit by an unrelenting force shout level 3")
	ElseIf (option == CreatureVulnerabilityOID_S)
		SetInfoText("Creatures (Unarmed + Unplayable race) attacks against your armor will be multiplied by their maximum health divided by this value\nThis makes more powerful creatures do more damage to your armor\nDragons may be able to rip off an armor piece in a single hit\nSet this really high if you want to effectively disable it")

	; Magic Armor
	ElseIf (option == MagicArmorClothingOID_S) || (option == MagicArmorArmorOID_S)
		SetInfoText("Magic armor spells have a percentage chance of completely deflecting armor damage\nThat includes damage to durabilty and tempering\nThis is the base chance for the vanilla 'Oakflesh' spell to deflect")
	ElseIf (option == MagicArmorClothingDeltaOID_S) || (option == MagicArmorArmorDeltaOID_S)
		SetInfoText("The bonus to deflection chance per tier of the mage armor spell\nGives higher level spells a greater chance to deflect\nWhich gives you a reason to cast high level mage armor spells instead of just spamming the low-cost oakflesh spell\nAt default settings: Clothing- Oakflesh: 50%. Stoneflesh: 75%. Ironflesh: 100%. Ebonyflesh: 125%. Dragonhide: 150%\nAt default settings: Armor- Oakflesh: 10%. Stoneflesh: 20%. Ironflesh: 30%. Ebonyflesh: 40%. Dragonhide: 50%")
	ElseIf (option == MagicArmorPattackOID_S)
		SetInfoText("When hit your deflection total is rolled against a random number (0 - 100) for a normal hit.\nIf the hit is a power attack then this number is added to the base chance - \nThe random number becomes ((0 + PowerAttack Bonus) - (100 + PowerAttack Bonus))\nThis gives power attacks extra chance to penetrate your mage armor\nAt default settings only the master level mage armor spell will fully protect clothes against power attacks")
	
	; Repair
	ElseIf (option == TemperingRefitTOID)
		SetInfoText("Tempering an armor will refit it to your gender/weight")
	ElseIf (option == RepairCostMinOID_S)
		SetInfoText("The minimum cost to repair a destroyed object\nTotal Cost = (Min Cost) + (Base Cost) + (Enchant Cost)")
	ElseIf (option == RepairCostBaseOID_S)
		SetInfoText("How much to repair destroyed items\nThe value of an item is split between the base (unenchanted) form + the value of the enchantment\nThis slider modifies the repair cost of the base value")
	ElseIf (option == RepairCostEnchantOID_S)
		SetInfoText("How much to repair destroyed items\nThe value of an item is split between the base (unenchanted) form + the value of the enchantment\nThis slider modifies the repair cost of the enchantment value")
	ElseIf (option == DurRepairCostMinOID_S)
		SetInfoText("The minimum cost to repair the durability of an object\nTotal Cost = (Min Cost) + (Base Cost) + (Enchant Cost))")
	ElseIf (option == DurRepairCostBaseOID_S)
		SetInfoText("How much to repair the durability of items\nThe value of an item is split between the base (unenchanted) form + the value of the enchantment\nThis slider modifies the repair cost of the base value")
	ElseIf (option == DurRepairCostEnchantOID_S)
		SetInfoText("How much to repair the durability of items\nThe value of an item is split between the base (unenchanted) form + the value of the enchantment\nThis slider modifies the repair cost of the enchantment")
		
	ElseIf (option == WeightAdjustCostMinOID_S)
		SetInfoText("The minimum cost to refit an object that does not match your current weight\nTotal Cost = (Min Cost) + (Base Cost) + (Enchant Cost)")
	ElseIf (option == WeightAdjustCostBaseOID_S)
		SetInfoText("How much to refit items that do not match your current weight\nThe value of an item is split between the base (unenchanted) form + the value of the enchantment\nThis slider modifies the repair cost of the base value")
	ElseIf (option == WeightAdjustCostEnchantOID_S)
		SetInfoText("How much to refit items that do not match your current weight\nThe value of an item is split between the base (unenchanted) form + the value of the enchantment\nThis slider modifies the repair cost of the enchantment value")
		
	ElseIf (option == GenderAdjustCostMinOID_S)
		SetInfoText("The minimum cost to refit an object that does not match your gender\nTotal Cost = (Min Cost) + (Base Cost) + (Enchant Cost)")
	ElseIf (option == GenderAdjustCostBaseOID_S)
		SetInfoText("How much to refit items that do not match your gender\nThe value of an item is split between the base (unenchanted) form + the value of the enchantment\nThis slider modifies the repair cost of the base value")
	ElseIf (option == GenderAdjustCostEnchantOID_S)
		SetInfoText("How much to refit items that do not match your gender\nThe value of an item is split between the base (unenchanted) form + the value of the enchantment\nThis slider modifies the repair cost of the enchantment value")
	
	; Equip Status
	ElseIf (option == CleanWornListOID_T)
		SetInfoText("Try this if you think there's something in the list that shouldn't be there\nChecks if each item in the list is equipped and removes it if it is not\nThe list is used in other more important ways than just being displayed here so it needs to be accurate")
	
	; Object Options
	ElseIf (option == ScanInvOID_T)
		SetInfoText("Scan all unequipped inventory objects into object options")
	ElseIf (option == OoAddFittedObjectOID_T)
		SetInfoText("Add another of the selected item to your inventory that will fit you and be full durability")
	ElseIf (option == ObjectSelectDB)
		SetInfoText("Select an equipped item to perform various operations on")
	ElseIf (option == RenameObjectOID)
		SetInfoText("Rename the currently selected object\nThe current name is stored and can be restored below\nIf you want to change the name again you should probably reset it first so that your current name doesn't become the stored name")
	ElseIf (option == ResetObjectNameOID_T)
		SetInfoText("Restore the stored name for the selected object")
	ElseIf (option == OoDurabilityOID_S)
		SetInfoText("Set the current durability of the selected object")
	ElseIf (option == OoDurabilityMaxOID_S)
		SetInfoText("Set the maximum durability of the selected object")
	ElseIf (option == OoTemperingOID_S)
		SetInfoText("Set the tempering on the currently selected object")
	ElseIf (option == OoCursedTOID)
		SetInfoText("Curse/Uncurse the selected object")

	; Cursed Objects
	ElseIf (option == CursedChanceContainerOID_S)
		SetInfoText("Chance for an item found in a container to be cursed")
	ElseIf (option == CursedChanceCorpseOID_S)
		SetInfoText("Chance for an item found on a corpse to be cursed")
	ElseIf (option == CurseUnequipTOID)
		SetInfoText("Equipping a cursed object immediately unequips it\nDefault is disabled so you can still use cursed objects but each time they are equipped another device will be equipped :)")
	ElseIf (option == CurseDestroyTOID)
		SetInfoText("When a cursed object is triggered the original item is 'destroyed'\nIf it's important you can 'coc _MWA_StorageCell' and retrieve it from the 'Cursed Object Dump' barrel there. Don't go messing around in that cell please. Get in, get out.")
	ElseIf (option == CurseForceTOID)
		SetInfoText("Enable/Disable the force physics effect when a cursed object is triggered - throws objects about in the game world")
	ElseIf (option == CursedSanctifyCostOID_S)
		SetInfoText("How much it will cost to have a priest remove a curse from an object")
	EndIf
EndEvent

Event OnOptionMenuOpen(int option)
	If (option == DropTypeDB)
		SetMenuDialogStartIndex(DropType)
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(DropTypeList)
	ElseIf (option == DestructableTypesDB)
		SetMenuDialogStartIndex(DestructableTypes)
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(DestructableTypesList)
	ElseIf (option == ObjectSearchVisionTypeDB)
		SetMenuDialogStartIndex(ObjectSearchVisionType)
		SetMenuDialogDefaultIndex(1)
		SetMenuDialogOptions(ObjectSearchVisionTypeList)
	ElseIf (option == ObjectSelectDB)
		SetMenuDialogStartIndex(ObjectSelect)
		SetMenuDialogDefaultIndex(0)
		SetMenuDialogOptions(EquipListNames)
	EndIf
EndEvent

Event OnOptionMenuAccept(int option, int index)
	If (option == DropTypeDB)
		DropType = index
		SetMenuOptionValue(option, DropTypeList[DropType])
		ForcePageReset()
	ElseIf (option == DestructableTypesDB)
		DestructableTypes = index
		SetMenuOptionValue(option, DestructableTypesList[DestructableTypes])
		DestTypes.UpdateState()
		ForcePageReset()
	ElseIf (option == ObjectSearchVisionTypeDB)
		ObjectSearchVisionType = index
		SetMenuOptionValue(option, ObjectSearchVisionTypeList[ObjectSearchVisionType])
		ForcePageReset()
	ElseIf (option == ObjectSelectDB)
		ObjectSelect = index
		SetMenuOptionValue(option, EquipListNames[ObjectSelect])
		ForcePageReset()
	EndIf
EndEvent

Event OnOptionSelect(int option)
	
	; Settings
	If (option == MasterSwitchTOID)
		If MasterSwitchT
			If ShowMessage("Be sure you want to shutdown the mod. Check the warning info below. Proceed?")
				Debug.Messagebox("Shutting down. Exit menu to apply. Wait for the completion notification before restarting the mod.")
				MasterSwitchT = !MasterSwitchT
				SetToggleOptionValue(MasterSwitchTOID, MasterSwitchT)
				Main.ShutdownMod()
			EndIf
		Else
			Debug.Messagebox("Starting up. Exit menu to apply")
			MasterSwitchT = !MasterSwitchT
			SetToggleOptionValue(MasterSwitchTOID, MasterSwitchT)
			Main.StartupMod()
		EndIf
	ElseIf (option == AliasCleanupOID_T)
		SetTextOptionValue(AliasCleanupOID_T, "Running... ", false)
		Debug.MessageBox("Please wait here until 'Done'")
		InvUtil.CleanInventoryAliases(-1)
		SetTextOptionValue(AliasCleanupOID_T, "Done! ", false)
	ElseIf (option == DegradationTOID)
		DegradationT = !DegradationT
		SetToggleOptionValue(DegradationTOID, DegradationT)
		If DegradationT
			Main.ResumeDegradation()
		Else
			Main.PauseDegradation()
		EndIf
	ElseIf (option == WorldObjectScanTOID)
		WorldObjectScanT = !WorldObjectScanT
		SetToggleOptionValue(WorldObjectScanTOID, WorldObjectScanT)
	ElseIf (option == ContainerScanTOID)
		ContainerScanT = !ContainerScanT
		SetToggleOptionValue(ContainerScanTOID, ContainerScanT)
	ElseIf (option == NpcDegradationScanTOID)
		NpcDegradationScanT = !NpcDegradationScanT
		Main.ToggleNpcDegradeScan()
		SetToggleOptionValue(NpcDegradationScanTOID, NpcDegradationScanT)
	ElseIf (option == ExportSettingsOID_T)
		SetTextOptionValue(ExportSettingsOID_T, "Exporting Settings ", false)
		If ShowMessage("Overwrite settings file with your current settings?")
			SaveSettings()
			SetTextOptionValue(ExportSettingsOID_T, "Done! ", false)
		Else
			SetTextOptionValue(ExportSettingsOID_T, "", false)
		Endif
	ElseIf (option == ImportSettingsOID_T)
		SetTextOptionValue(ImportSettingsOID_T, "Importing Settings ", false)
		If ShowMessage("Overwrite your current settings with the settings saved to file?")
			LoadSettings()
			SetTextOptionValue(ImportSettingsOID_T, "Done! ", false)
		Else
			SetTextOptionValue(ImportSettingsOID_T, "", false)
		Endif
	
	ElseIf (option == ClearImmuneListOID_T)
		If ShowMessage("Are you sure you want to remove all items in the immune list?")
			SetTextOptionValue(ClearImmuneListOID_T, "Erasing ", false)
			Util.ClearImmuneList()	
		Endif
	ElseIf (option == SuitabilityTOID)
		SuitabilityT = !SuitabilityT
		SetToggleOptionValue(SuitabilityTOID, SuitabilityT)
	ElseIf (option == SuitabilityBodyTOID)
		SuitabilityBodyT = !SuitabilityBodyT
		SetToggleOptionValue(SuitabilityBodyTOID, SuitabilityBodyT)
	ElseIf (option == SearchBoxNotifyTOID)
		SearchBoxNotifyT = !SearchBoxNotifyT
		SetToggleOptionValue(SearchBoxNotifyTOID, SearchBoxNotifyT)
	
	ElseIf (option == CombatEquipTOID)
		CombatEquipT = !CombatEquipT
		SetToggleOptionValue(CombatEquipTOID, CombatEquipT)
		ForcePageReset()		
	ElseIf (option == CombatEquipWaitPerItemTOID)
		CombatEquipWaitPerItemT = !CombatEquipWaitPerItemT
		SetToggleOptionValue(CombatEquipWaitPerItemTOID, CombatEquipWaitPerItemT)
	ElseIf (option == RemoveFoodWorldTOID)
		RemoveFoodWorldT = !RemoveFoodWorldT
		SetToggleOptionValue(RemoveFoodWorldTOID, RemoveFoodWorldT)
	
	; Durability
	ElseIf (option == SuitabilityDescripOID)
		AddSuitabilityDes = !AddSuitabilityDes
		SetToggleOptionValue(SuitabilityDescripOID, AddSuitabilityDes)
	ElseIf (option == EverythingFitsTOID)
		EverythingFits = !EverythingFits
		SetToggleOptionValue(EverythingFitsTOID, EverythingFits)
	ElseIf (option == RandomNpcFitTOID)
		RandomNpcFitT = !RandomNpcFitT
		SetToggleOptionValue(RandomNpcFitTOID, RandomNpcFitT)
	ElseIf (option == AddMaterialBonusTOID)
		AddMaterialBonusT = !AddMaterialBonusT
		SetToggleOptionValue(AddMaterialBonusTOID, AddMaterialBonusT)
	ElseIf (option == ResetWornDursOID_T)
		If ShowMessage("Are you sure you want to reset the durabilities of your equipped stuff?", a_acceptLabel = "Yes", a_cancelLabel = "No")
			If ShowMessage("Do you want to reset the items current durability to the new maximum?", a_acceptLabel = "Yes", a_cancelLabel = "No")
				SetTextOptionValue(ResetWornDursOID_T, "Resetting ", false)
				Util.ResetWornDurabilities(ResetToFullDurability = true)
				SetTextOptionValue(ResetWornDursOID_T, "Done ", false)
			Else
				SetTextOptionValue(ResetWornDursOID_T, "Resetting ", false)
				Util.ResetWornDurabilities(ResetToFullDurability = false)
				SetTextOptionValue(ResetWornDursOID_T, "Done ", false)
			Endif
		EndIf
	ElseIf (option == ResetDurCacheOID_T)
		If ShowMessage("Are you sure you want to clear the cached durability for all forms?", a_acceptLabel = "Yes", a_cancelLabel = "No")
			SetTextOptionValue(ResetDurCacheOID_T, "Clearing ", false)
			Util.ClearDurabilityCaching()
			SetTextOptionValue(ResetDurCacheOID_T, "Done ", false)
		EndIf
		
	; Degradation
	ElseIf (option == ArmorHitsPerHitRandomTOID)
		ArmorHitsPerHitRandomT = !ArmorHitsPerHitRandomT
		SetToggleOptionValue(ArmorHitsPerHitRandomTOID, ArmorHitsPerHitRandomT)
	ElseIf (option == TimeDegradeDurDecTOID)
		TimeDegradeDurDecT = !TimeDegradeDurDecT
		SetToggleOptionValue(TimeDegradeDurDecTOID, TimeDegradeDurDecT)
	ElseIf (option == ComplexDegradationOID)
		ComplexDegradationT = !ComplexDegradationT
		SetToggleOptionValue(ComplexDegradationOID, ComplexDegradationT)	
		ForcePageReset()
		
	; Refit / Repair
	ElseIf (option == TemperingRefitTOID)
		TemperingRefitT = !TemperingRefitT
		SetToggleOptionValue(TemperingRefitTOID, TemperingRefitT)	
		ForcePageReset()
	
	; Equip Status
	ElseIf (option == ModImmunityOID_T)
		Form akBaseObject
		ObjectReference ObjRef = StorageUtil.FormListGet(Self, "_MWA_WornListCopy", ObjectSelect) as ObjectReference
		If ObjRef
			akBaseObject = ObjRef.GetBaseObject()
		Else
			akBaseObject = StorageUtil.FormListGet(Self, "_MWA_WornListCopy", ObjectSelect)
		EndIf
		If _MWA_ImmuneList.HasForm(akBaseObject)
			Util.AddImmunity(ObjRef, akBaseObject, false)
		Else
			Util.AddImmunity(ObjRef, akBaseObject, true)
		Endif
		ForcePageReset()
	ElseIf (option == CleanWornListOID_T)
		SetTextOptionValue(CleanWornListOID_T, "Cleaning list ", false)
		Util.CheckWornList()
		ForcePageReset()
		SetTextOptionValue(CleanWornListOID_T, "Done! ", false)
	ElseIf (option == ScanInvOID_T)
		;SetTextOptionValue(ScanInvOID_T, "Scanning...", false)
		ScanAllInvObjects()
		;SetTextOptionValue(ScanInvOID_T, "Scan Done!", false)
	ElseIf (option == OoAddFittedObjectOID_T)
		SetTextOptionValue(OoAddFittedObjectOID_T, "Working... ", false)
		Api.On_MWA_AddFittedObject(PlayerRef, SelectedObjectForm, DurMinMod = 1.0, DurMaxMod = 1.0, Silent = false, FitLoosely = false, CursedChance = 0.0)
		SetTextOptionValue(OoAddFittedObjectOID_T, "Done! ", false)
		Utility.WaitMenuMode(0.3)
		SetTextOptionValue(OoAddFittedObjectOID_T, "", false)
	ElseIf (option == ResetObjectNameOID_T)
		ResetObjectName()
		
	; Object Options
	ElseIf (option == OoCursedTOID)
		OoCursed = !OoCursed
		SetToggleOptionValue(OoCursedTOID, OoCursed)
		Util.ToggleCurse(OoSelectedObject, OoCursed)
		ForcePageReset()
		
	; Cursed Objects
	ElseIf (option == CurseUnequipTOID)
		Devious.CurseUnequip = !Devious.CurseUnequip
		SetToggleOptionValue(CurseUnequipTOID, Devious.CurseUnequip)
	ElseIf (option == CurseDestroyTOID)
		Devious.CurseDestroy = !Devious.CurseDestroy
		SetToggleOptionValue(CurseDestroyTOID, Devious.CurseDestroy)
	ElseIf (option == CurseForceTOID)
		Devious.CurseExplosionEffectPush = !Devious.CurseExplosionEffectPush
		SetToggleOptionValue(CurseForceTOID, Devious.CurseExplosionEffectPush)
	ElseIf (option == AllowDeviousBeltsTOID)
		AllowDeviousBelts = !AllowDeviousBelts
		SetToggleOptionValue(AllowDeviousBeltsTOID, AllowDeviousBelts)
	ElseIf (option == AllowDeviousBrasTOID)
		AllowDeviousBras = !AllowDeviousBras
		SetToggleOptionValue(AllowDeviousBrasTOID, AllowDeviousBras)
	ElseIf (option == AllowDeviousPlugsAnalTOID)
		AllowDeviousPlugsAnal = !AllowDeviousPlugsAnal
		SetToggleOptionValue(AllowDeviousPlugsAnalTOID, AllowDeviousPlugsAnal)
	ElseIf (option == AllowDeviousPlugsVagTOID)
		AllowDeviousPlugsVag = !AllowDeviousPlugsVag
		SetToggleOptionValue(AllowDeviousPlugsVagTOID, AllowDeviousPlugsVag)
	ElseIf (option == AllowDeviousCorsetsTOID)
		AllowDeviousCorsets = !AllowDeviousCorsets
		SetToggleOptionValue(AllowDeviousCorsetsTOID, AllowDeviousCorsets)
	ElseIf (option == AllowDeviousHarnessesTOID)
		AllowDeviousHarnesses = !AllowDeviousHarnesses
		SetToggleOptionValue(AllowDeviousHarnessesTOID, AllowDeviousHarnesses)
	ElseIf (option == AllowDeviousArmCuffsTOID)
		AllowDeviousArmCuffs = !AllowDeviousArmCuffs
		SetToggleOptionValue(AllowDeviousArmCuffsTOID, AllowDeviousArmCuffs)
	ElseIf (option == AllowDeviousLegCuffsTOID)
		AllowDeviousLegCuffs = !AllowDeviousLegCuffs
		SetToggleOptionValue(AllowDeviousLegCuffsTOID, AllowDeviousLegCuffs)
	ElseIf (option == AllowDeviousBootsTOID)
		AllowDeviousBoots = !AllowDeviousBoots
		SetToggleOptionValue(AllowDeviousBootsTOID, AllowDeviousBoots)
	ElseIf (option == AllowDeviousGlovesTOID)
		AllowDeviousGloves = !AllowDeviousGloves
		SetToggleOptionValue(AllowDeviousGlovesTOID, AllowDeviousGloves)
	ElseIf (option == AllowDeviousMittensTOID)
		AllowDeviousMittens = !AllowDeviousMittens
		SetToggleOptionValue(AllowDeviousMittensTOID, AllowDeviousMittens)
	ElseIf (option == AllowDeviousCollarsTOID)
		AllowDeviousCollars = !AllowDeviousCollars
		SetToggleOptionValue(AllowDeviousCollarsTOID, AllowDeviousCollars)
	ElseIf (option == AllowDeviousGagsTOID)
		AllowDeviousGags = !AllowDeviousGags
		SetToggleOptionValue(AllowDeviousGagsTOID, AllowDeviousGags)
	ElseIf (option == AllowDeviousBlindfoldsTOID)
		AllowDeviousBlindfolds = !AllowDeviousBlindfolds
		SetToggleOptionValue(AllowDeviousBlindfoldsTOID, AllowDeviousBlindfolds)
	ElseIf (option == AllowDeviousNipplesTOID)
		AllowDeviousNipples = !AllowDeviousNipples
		SetToggleOptionValue(AllowDeviousNipplesTOID, AllowDeviousNipples)
	ElseIf (option == AllowDeviousClitTOID)
		AllowDeviousClit = !AllowDeviousClit
		SetToggleOptionValue(AllowDeviousClitTOID, AllowDeviousClit)
	ElseIf (option == AllowDeviousArmbindersTOID)
		AllowDeviousArmbinders = !AllowDeviousArmbinders
		SetToggleOptionValue(AllowDeviousArmbindersTOID, AllowDeviousArmbinders)
	ElseIf (option == AllowDeviousElbowBindersTOID)
		AllowDeviousElbowBinders = !AllowDeviousElbowBinders
		SetToggleOptionValue(AllowDeviousElbowBindersTOID, AllowDeviousElbowBinders)
	ElseIf (option == AllowDeviousYokesTOID)
		AllowDeviousYokes = !AllowDeviousYokes
		SetToggleOptionValue(AllowDeviousYokesTOID, AllowDeviousYokes)
	ElseIf (option == AllowDeviousBreastYokesTOID)
		AllowDeviousBreastYokes = !AllowDeviousBreastYokes
		SetToggleOptionValue(AllowDeviousBreastYokesTOID, AllowDeviousBreastYokes)
	ElseIf (option == AllowDeviousSuitsTOID)
		AllowDeviousSuits = !AllowDeviousSuits
		SetToggleOptionValue(AllowDeviousSuitsTOID, AllowDeviousSuits)
	ElseIf (option == AllowDeviousHobbleTOID)
		AllowDeviousHobble = !AllowDeviousHobble
		SetToggleOptionValue(AllowDeviousHobbleTOID, AllowDeviousHobble)
	ElseIf (option == AllowDeviousStraitJacketsTOID)
		AllowDeviousStraitJackets = !AllowDeviousStraitJackets
		SetToggleOptionValue(AllowDeviousStraitJacketsTOID, AllowDeviousStraitJackets)
	ElseIf (option == AllowDeviousPetSuitsTOID)
		AllowDeviousPetSuits = !AllowDeviousPetSuits
		SetToggleOptionValue(AllowDeviousPetSuitsTOID, AllowDeviousPetSuits)
	EndIf
EndEvent

Event OnOptionDefault(int option)
	
	; Settings
	If(option == NpcDegradationScanTOID)
		NpcDegradationScanT = true
		Main.ToggleNpcDegradeScan()
		SetToggleOptionValue(NpcDegradationScanTOID, NpcDegradationScanT)
		ElseIf(option == WorldObjectScanTOID)
		WorldObjectScanT = true
		SetToggleOptionValue(WorldObjectScanTOID, WorldObjectScanT)
		ElseIf(option == ContainerScanTOID)
		ContainerScanT = true
		SetToggleOptionValue(ContainerScanTOID, ContainerScanT)
	ElseIf(option == SuitabilityTOID)
		SuitabilityT = true
		SetToggleOptionValue(SuitabilityTOID, SuitabilityT)
	ElseIf(option == SuitabilityBodyTOID)
		SuitabilityBodyT = false
		SetToggleOptionValue(SuitabilityBodyTOID, SuitabilityBodyT)
	ElseIf(option == SearchBoxNotifyTOID)
		SearchBoxNotifyT = false
		SetToggleOptionValue(SearchBoxNotifyTOID, SearchBoxNotifyT)
		
	ElseIf(option == CombatEquipTOID)
		CombatEquipT = true
		SetToggleOptionValue(CombatEquipTOID, CombatEquipT)
		ForcePageReset()
	ElseIf(option == CombatEquipWaitPerItemTOID)
		CombatEquipWaitPerItemT = true
		SetToggleOptionValue(CombatEquipWaitPerItemTOID, CombatEquipWaitPerItemT)
	ElseIf(option == RemoveFoodWorldTOID)
		RemoveFoodWorldT = true
		SetToggleOptionValue(RemoveFoodWorldTOID, RemoveFoodWorldT)
		
	; Durability
	ElseIf(option == SuitabilityDescripOID)
		AddSuitabilityDes = true
		SetToggleOptionValue(SuitabilityDescripOID, AddSuitabilityDes)
	ElseIf(option == EverythingFitsTOID)
		EverythingFits = false
		SetToggleOptionValue(EverythingFitsTOID, EverythingFits)
	ElseIf(option == RandomNpcFitTOID)
		RandomNpcFitT = false
		SetToggleOptionValue(RandomNpcFitTOID, RandomNpcFitT)
	ElseIf(option == AddMaterialBonusTOID)
		AddMaterialBonusT = true
		SetToggleOptionValue(AddMaterialBonusTOID, AddMaterialBonusT)
	
	; Degradation
	ElseIf(option == ArmorHitsPerHitRandomTOID)
		ArmorHitsPerHitRandomT = true
		SetToggleOptionValue(ArmorHitsPerHitRandomTOID, ArmorHitsPerHitRandomT)
	ElseIf(option == TimeDegradeDurDecTOID)
		TimeDegradeDurDecT = true
		SetToggleOptionValue(TimeDegradeDurDecTOID, TimeDegradeDurDecT)
	ElseIf(option == ComplexDegradationOID)
		ComplexDegradationT = true
		SetToggleOptionValue(ComplexDegradationOID, ComplexDegradationT)
		ForcePageReset()
		
	; Refit / Repair
	ElseIf(option == TemperingRefitTOID)
		TemperingRefitT = false
		SetToggleOptionValue(TemperingRefitTOID, TemperingRefitT)
		ForcePageReset()

	; Equip Status
	
	; Object Options
	
	; Cursed Objects
	ElseIf(option == CurseUnequipTOID)
		Devious.CurseUnequip = false
		SetToggleOptionValue(CurseUnequipTOID, Devious.CurseUnequip)
	ElseIf(option == CurseDestroyTOID)
		Devious.CurseDestroy = false
		SetToggleOptionValue(CurseDestroyTOID, Devious.CurseDestroy)
	ElseIf(option == CurseForceTOID)
		Devious.CurseExplosionEffectPush = true
		SetToggleOptionValue(CurseForceTOID, Devious.CurseExplosionEffectPush)
	EndIf
EndEvent

Event OnOptionSliderOpen(int option)

	; Settings
	If (option == LostObjectSearchTimeOID_S)
		SetSliderDialogStartValue(LostObjectSearchTime)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(1.0, 60.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == ContainerScanMaxItemsOID_S)
		SetSliderDialogStartValue(ContainerScanMaxItems)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == BreakSoundVolumeOID_S)
		SetSliderDialogStartValue(BreakSoundVolume * 100.0)
		SetSliderDialogDefaultValue(60.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == DestructStaggerOID_S)
		SetSliderDialogStartValue(DestructStagger)
		SetSliderDialogDefaultValue(65.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == DroppedTeleportDistanceOID_S)
		SetSliderDialogStartValue(DroppedTeleportDistance)
		SetSliderDialogDefaultValue(512.0)
		SetSliderDialogRange(32.0, 4096.0)
		SetSliderDialogInterval(32.0)
	ElseIf (option == ObjectLossChanceOID_S)
		SetSliderDialogStartValue(ObjectLossChance)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(0.5)
	ElseIf (option == SuitabilityWeightOID_S)
		SetSliderDialogStartValue(SuitabilityWeight)
		SetSliderDialogDefaultValue(5.0)
		SetSliderDialogRange(-1.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == SuitabilityBikiniOID_S)
		SetSliderDialogStartValue(SuitabilityBikini)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
		
	ElseIf (option == ItemFitsPcChanceOID_S)
		SetSliderDialogStartValue(ItemFitsPcChance)
		SetSliderDialogDefaultValue(5.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == RapeMinDamageOID_S)
		SetSliderDialogStartValue(RapeMinDamage)
		SetSliderDialogDefaultValue(4.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == RapeMaxDamageOID_S)
		SetSliderDialogStartValue(RapeMaxDamage)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == CombatEquipTimeOID_S)
		SetSliderDialogStartValue(CombatEquipTime)
		SetSliderDialogDefaultValue(2.5)
		SetSliderDialogRange(0.0, 20.0)
		SetSliderDialogInterval(0.25)
		
	ElseIf (option == RemoveFoodCANsOID_S)
		SetSliderDialogStartValue(RemoveFoodCANs)
		SetSliderDialogDefaultValue(90.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(0.5)
	ElseIf (option == RemoveLockpicksOID_S)
		SetSliderDialogStartValue(RemoveLockpicks)
		SetSliderDialogDefaultValue(90.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(0.5)
	ElseIf (option == LockpickValueOID_S)
		SetSliderDialogStartValue(LockpickValue)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(10.0, 1000.0)
		SetSliderDialogInterval(10.0)
	
	; Durability
	ElseIf (option == ClothesDurabilityOID_S)
		SetSliderDialogStartValue(ClothesDurability)
		SetSliderDialogDefaultValue(8.0)
		SetSliderDialogRange(1.0, 1000.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == LightDurabilityOID_S)
		SetSliderDialogStartValue(LightDurability)
		SetSliderDialogDefaultValue(12.0)
		SetSliderDialogRange(1.0, 1000.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == HeavyDurabilityOID_S)
		SetSliderDialogStartValue(HeavyDurability)
		SetSliderDialogDefaultValue(16.0)
		SetSliderDialogRange(1.0, 1000.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == DurabilityToleranceOID_S)
		SetSliderDialogStartValue(DurabilityTolerance)
		SetSliderDialogDefaultValue(25.0)
		SetSliderDialogRange(1.0, 99.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == ShieldDurabilityModOID_S)
		SetSliderDialogStartValue(ShieldDurabilityMod)
		SetSliderDialogDefaultValue(1.5)
		SetSliderDialogRange(1.0, 5.0)
		SetSliderDialogInterval(0.1)
		
	ElseIf (option == OneHDurabilityOID_S)
		SetSliderDialogStartValue(OneHDurability)
		SetSliderDialogDefaultValue(25.0)
		SetSliderDialogRange(1.0, 1000.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == TwoHDurabilityOID_S)
		SetSliderDialogStartValue(TwoHDurability)
		SetSliderDialogDefaultValue(35.0)
		SetSliderDialogRange(1.0, 1000.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == RangedDurabilityOID_S)
		SetSliderDialogStartValue(RangedDurability)
		SetSliderDialogDefaultValue(40.0)
		SetSliderDialogRange(1.0, 1000.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == DaggerDurabilityOID_S)
		SetSliderDialogStartValue(DaggerDurability)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(1.0, 1000.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == StaffDurabilityOID_S)
		SetSliderDialogStartValue(StaffDurability)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(1.0, 1000.0)
		SetSliderDialogInterval(1.0)
		
	ElseIf (option == DurabilityMinOID_S)
		SetSliderDialogStartValue(DurabilityMin * 100.0)
		SetSliderDialogDefaultValue(5.0)
		SetSliderDialogRange(1.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == DurabilityMaxOID_S)
		SetSliderDialogStartValue(DurabilityMax * 100.0)
		SetSliderDialogDefaultValue(100.0)
		SetSliderDialogRange(1.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == CorpseDurabilityMinOID_S)
		SetSliderDialogStartValue(CorpseDurabilityMin * 100.0)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(1.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == CorpseDurabilityMaxOID_S)
		SetSliderDialogStartValue(CorpseDurabilityMax * 100.0)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(1.0, 100.0)
		SetSliderDialogInterval(1.0)
	
	; Degradation
	ElseIf (option == TemperDegradeOID_S)
		SetSliderDialogStartValue(TemperDegrade)
		SetSliderDialogDefaultValue(0.0025)
		SetSliderDialogRange(0.0, 0.1)
		SetSliderDialogInterval(0.0001)
	ElseIf (option == TemperDegradePowerAOID_S)
		SetSliderDialogStartValue(TemperDegradePowerA)
		SetSliderDialogDefaultValue(0.0050)
		SetSliderDialogRange(0.0, 0.1)
		SetSliderDialogInterval(0.0001)
	ElseIf (option == ArmorHitsPerHitOID_S)
		SetSliderDialogStartValue(ArmorHitsPerHit)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(1.0, 5.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == WeaponDegradeOID_S)
		SetSliderDialogStartValue(WeaponDegrade)
		SetSliderDialogDefaultValue(0.0005)
		SetSliderDialogRange(0.0, 0.1)
		SetSliderDialogInterval(0.0001)
	ElseIf (option == WeaponDegradePowerOID_S)
		SetSliderDialogStartValue(WeaponDegradePower)
		SetSliderDialogDefaultValue(0.0010)
		SetSliderDialogRange(0.0, 0.1)
		SetSliderDialogInterval(0.0001)
		
	ElseIf (option == TimeDegradeDamageOID_S)
		SetSliderDialogStartValue(TimeDegradeDamage)
		SetSliderDialogDefaultValue(0.0050)
		SetSliderDialogRange(0.0, 0.1)
		SetSliderDialogInterval(0.0001)
	ElseIf (option == TimeDegradeFreqOID_S)
		SetSliderDialogStartValue(TimeDegradeFreq)
		SetSliderDialogDefaultValue(12.0)
		SetSliderDialogRange(0.0, 48.0)
		SetSliderDialogInterval(1.0)
		
	ElseIf (option == VulnerabilityMultDaggerOID_S)
		SetSliderDialogStartValue(VulnerabilityMultDagger)
		SetSliderDialogDefaultValue(1.5)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == VulnerabilityMultAxeOID_S)
		SetSliderDialogStartValue(VulnerabilityMultAxe)
		SetSliderDialogDefaultValue(2.0)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == VulnerabilityMultSwordOID_S)
		SetSliderDialogStartValue(VulnerabilityMultSword)
		SetSliderDialogDefaultValue(2.0)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == VulnerabilityMultBattleAxeOID_S)
		SetSliderDialogStartValue(VulnerabilityMultBattleAxe)
		SetSliderDialogDefaultValue(3.0)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == VulnerabilityMultGreatswordOID_S)
		SetSliderDialogStartValue(VulnerabilityMultGreatsword)
		SetSliderDialogDefaultValue(3.0)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == VulnerabilityMultMaceOID_S)
		SetSliderDialogStartValue(VulnerabilityMultMace)
		SetSliderDialogDefaultValue(2.0)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == VulnerabilityMultWarhammerOID_S)
		SetSliderDialogStartValue(VulnerabilityMultWarhammer)
		SetSliderDialogDefaultValue(3.0)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == ExtraDamageChanceAxeOID_S)
		SetSliderDialogStartValue(ExtraDamageChanceAxe)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == VulnerabilityMultFireOID_S)
		SetSliderDialogStartValue(VulnerabilityMultFire)
		SetSliderDialogDefaultValue(2.5)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == VulnerabilityMultIceOID_S)
		SetSliderDialogStartValue(VulnerabilityMultIce)
		SetSliderDialogDefaultValue(2.5)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == VulnerabilityMultLightningOID_S)
		SetSliderDialogStartValue(VulnerabilityMultLightning)
		SetSliderDialogDefaultValue(2.5)
		SetSliderDialogRange(1.0, 10.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == ExtraDamageChanceLightningOID_S)
		SetSliderDialogStartValue(ExtraDamageChanceLightning)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == MagicDegradeCooldownOID_S)
		SetSliderDialogStartValue(MagicDegradeCooldown)
		SetSliderDialogDefaultValue(0.2)
		SetSliderDialogRange(0.0, 2.0)
		SetSliderDialogInterval(0.05)
	ElseIf (option == VulnerabilityShoutOneOID_S)
		SetSliderDialogStartValue(VulnerabilityShoutOne)
		SetSliderDialogDefaultValue(3.0)
		SetSliderDialogRange(1.0, 20.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == VulnerabilityShoutTwoOID_S)
		SetSliderDialogStartValue(VulnerabilityShoutTwo)
		SetSliderDialogDefaultValue(5.0)
		SetSliderDialogRange(1.0, 20.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == VulnerabilityShoutThreeOID_S)
		SetSliderDialogStartValue(VulnerabilityShoutThree)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(1.0, 20.0)
		SetSliderDialogInterval(0.25)
	ElseIf (option == CreatureVulnerabilityOID_S)
		SetSliderDialogStartValue(CreatureVulnerability)
		SetSliderDialogDefaultValue(110.0)
		SetSliderDialogRange(1.0, 10000.0)
		SetSliderDialogInterval(10.0)
	
	; Magic Armor
	ElseIf (option == MagicArmorClothingOID_S)
		SetSliderDialogStartValue(MagicArmorClothing)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(1.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == MagicArmorArmorOID_S)
		SetSliderDialogStartValue(MagicArmorArmor)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(1.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == MagicArmorClothingDeltaOID_S)
		SetSliderDialogStartValue(MagicArmorClothingDelta)
		SetSliderDialogDefaultValue(25.0)
		SetSliderDialogRange(1.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == MagicArmorArmorDeltaOID_S)
		SetSliderDialogStartValue(MagicArmorArmorDelta)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(1.0, 100.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == MagicArmorPattackOID_S)
		SetSliderDialogStartValue(MagicArmorPattack)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 101.0)
		SetSliderDialogInterval(1.0)
	
	; Repair
	ElseIf (option == RepairCostMinOID_S)
		SetSliderDialogStartValue(RepairCostMin)
		SetSliderDialogDefaultValue(25.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(5.0)
	ElseIf (option == RepairCostBaseOID_S)
		SetSliderDialogStartValue(RepairCostBase)
		SetSliderDialogDefaultValue(0.20)
		SetSliderDialogRange(0.01, 1.50)
		SetSliderDialogInterval(0.01)
	ElseIf (option == RepairCostEnchantOID_S)
		SetSliderDialogStartValue(RepairCostEnchant)
		SetSliderDialogDefaultValue(0.20)
		SetSliderDialogRange(0.01, 1.50)
		SetSliderDialogInterval(0.01)
	ElseIf (option == DurRepairCostMinOID_S)
		SetSliderDialogStartValue(DurRepairCostMin)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(5.0)
	ElseIf (option == DurRepairCostBaseOID_S)
		SetSliderDialogStartValue(DurRepairCostBase)
		SetSliderDialogDefaultValue(0.05)
		SetSliderDialogRange(0.01, 1.50)
		SetSliderDialogInterval(0.01)
	ElseIf (option == DurRepairCostEnchantOID_S)
		SetSliderDialogStartValue(DurRepairCostEnchant)
		SetSliderDialogDefaultValue(0.05)
		SetSliderDialogRange(0.01, 1.50)
		SetSliderDialogInterval(0.01)
		
	ElseIf (option == WeightAdjustCostMinOID_S)
		SetSliderDialogStartValue(WeightAdjustCostMin)
		SetSliderDialogDefaultValue(25.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(5.0)
	ElseIf (option == WeightAdjustCostBaseOID_S)
		SetSliderDialogStartValue(WeightAdjustCostBase)
		SetSliderDialogDefaultValue(1.25)
		SetSliderDialogRange(0.01, 3.00)
		SetSliderDialogInterval(0.01)
	ElseIf (option == WeightAdjustCostEnchantOID_S)
		SetSliderDialogStartValue(WeightAdjustCostEnchant)
		SetSliderDialogDefaultValue(1.25)
		SetSliderDialogRange(0.01, 3.00)
		SetSliderDialogInterval(0.01)
		
	ElseIf (option == GenderAdjustCostMinOID_S)
		SetSliderDialogStartValue(GenderAdjustCostMin)
		SetSliderDialogDefaultValue(50.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(5.0)
	ElseIf (option == GenderAdjustCostBaseOID_S)
		SetSliderDialogStartValue(GenderAdjustCostBase)
		SetSliderDialogDefaultValue(1.75)
		SetSliderDialogRange(0.01, 3.00)
		SetSliderDialogInterval(0.01)
	ElseIf (option == GenderAdjustCostEnchantOID_S)
		SetSliderDialogStartValue(GenderAdjustCostEnchant)
		SetSliderDialogDefaultValue(1.25)
		SetSliderDialogRange(0.01, 3.00)
		SetSliderDialogInterval(0.01)
		
	; Object Options
	ElseIf (option == OoDurabilityOID_S)
		SetSliderDialogStartValue(OoDurability)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == OoDurabilityMaxOID_S)
		SetSliderDialogStartValue(OoDurabilityMax)
		SetSliderDialogDefaultValue(10.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(1.0)
	ElseIf (option == OoTemperingOID_S)
		SetSliderDialogStartValue(OoTemper)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(1.0, OoTemperMax)
		SetSliderDialogInterval(0.1)
		
	; Cursed Objects
	ElseIf (option == CursedSanctifyCostOID_S)
		SetSliderDialogStartValue(_MWA_SanctCost.GetValueInt())
		SetSliderDialogDefaultValue(500.0)
		SetSliderDialogRange(0.0, 10000.0)
		SetSliderDialogInterval(100.0)
	ElseIf (option == CursedChanceContainerOID_S)
		SetSliderDialogStartValue(CursedChanceContainer)
		SetSliderDialogDefaultValue(5.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(0.5)
	ElseIf (option == CursedChanceCorpseOID_S)
		SetSliderDialogStartValue(CursedChanceCorpse)
		SetSliderDialogDefaultValue(5.0)
		SetSliderDialogRange(0.0, 100.0)
		SetSliderDialogInterval(0.5)
	EndIf
EndEvent

Event OnOptionSliderAccept(int option, float value)
	
	; Settings
	If (option == LostObjectSearchTimeOID_S)
		LostObjectSearchTime = value as Int
		SetSliderOptionValue(LostObjectSearchTimeOID_S, LostObjectSearchTime)
	ElseIf (option == BreakSoundVolumeOID_S)
		BreakSoundVolume = value / 100.0
		SetSliderOptionValue(BreakSoundVolumeOID_S, BreakSoundVolume)
	ElseIf (option == DestructStaggerOID_S)
		DestructStagger = value
		SetSliderOptionValue(DestructStaggerOID_S, DestructStagger)
	ElseIf (option == ContainerScanMaxItemsOID_S)
		ContainerScanMaxItems = value as Int
		SetSliderOptionValue(ContainerScanMaxItemsOID_S, ContainerScanMaxItems)
	ElseIf (option == DroppedTeleportDistanceOID_S)
		DroppedTeleportDistance = value
		SetSliderOptionValue(DroppedTeleportDistanceOID_S, DroppedTeleportDistance)
	ElseIf (option == ObjectLossChanceOID_S)
		ObjectLossChance = value
		SetSliderOptionValue(ObjectLossChanceOID_S, ObjectLossChance)
	ElseIf (option == SuitabilityWeightOID_S)
		SuitabilityWeight = value
		SetSliderOptionValue(SuitabilityWeightOID_S, SuitabilityWeight)
	ElseIf (option == SuitabilityBikiniOID_S)
		SuitabilityBikini = value
		SetSliderOptionValue(SuitabilityBikiniOID_S, SuitabilityBikini)
	ElseIf (option == ItemFitsPcChanceOID_S)
		ItemFitsPcChance = value
		SetSliderOptionValue(ItemFitsPcChanceOID_S, ItemFitsPcChance)
	ElseIf (option == RapeMinDamageOID_S)
		RapeMinDamage = value as Int
		SetSliderOptionValue(RapeMinDamageOID_S, RapeMinDamage)
	ElseIf (option == RapeMaxDamageOID_S)
		RapeMaxDamage = value as Int
		SetSliderOptionValue(RapeMaxDamageOID_S, RapeMaxDamage)
	ElseIf (option == CombatEquipTimeOID_S)
		CombatEquipTime = value
		SetSliderOptionValue(CombatEquipTimeOID_S, CombatEquipTime)
	ElseIf (option == RemoveFoodCANsOID_S)
		RemoveFoodCANs = value
		SetSliderOptionValue(RemoveFoodCANsOID_S, RemoveFoodCANs)
		ToggleRemoveFoodCans()
	ElseIf (option == RemoveLockpicksOID_S)
		RemoveLockpicks = value
		SetSliderOptionValue(RemoveLockpicksOID_S, RemoveLockpicks)
		ToggleLockpickRemoval()
	ElseIf (option == LockpickValueOID_S)
		LockpickValue = value as int
		SetSliderOptionValue(LockpickValueOID_S, value)
		Util.SetLockpickValue()
		
	; Durability
	ElseIf (option == ClothesDurabilityOID_S)
		If ClothesDurability != value as Int
			Util.ClearDurabilityCaching()
		EndIf
		ClothesDurability = value as Int
		SetSliderOptionValue(ClothesDurabilityOID_S, ClothesDurability)
	ElseIf (option == LightDurabilityOID_S)
		If LightDurability != value as Int
			Util.ClearDurabilityCaching()
		EndIf
		LightDurability = value as Int
		SetSliderOptionValue(LightDurabilityOID_S, LightDurability)
	ElseIf (option == HeavyDurabilityOID_S)
		If HeavyDurability != value as Int
			Util.ClearDurabilityCaching()
		EndIf
		HeavyDurability = value as Int
		SetSliderOptionValue(HeavyDurabilityOID_S, HeavyDurability)
	ElseIf (option == DurabilityToleranceOID_S)
		DurabilityTolerance = value
		SetSliderOptionValue(DurabilityToleranceOID_S, DurabilityTolerance)
	ElseIf (option == ShieldDurabilityModOID_S)
		ShieldDurabilityMod = value
		SetSliderOptionValue(ShieldDurabilityModOID_S, ShieldDurabilityMod)
		
	ElseIf (option == OneHDurabilityOID_S)
		If OneHDurability != value as Int
			Util.ClearDurabilityCaching()
		EndIf
		OneHDurability = value as Int
		SetSliderOptionValue(OneHDurabilityOID_S, OneHDurability)
	ElseIf (option == TwoHDurabilityOID_S)
		If TwoHDurability != value as Int
			Util.ClearDurabilityCaching()
		EndIf
		TwoHDurability = value as Int
		SetSliderOptionValue(TwoHDurabilityOID_S, TwoHDurability)
	ElseIf (option == RangedDurabilityOID_S)
		If RangedDurability != value as Int
			Util.ClearDurabilityCaching()
		EndIf
		RangedDurability = value as Int
		SetSliderOptionValue(RangedDurabilityOID_S, RangedDurability)
	ElseIf (option == DaggerDurabilityOID_S)
		If DaggerDurability != value as Int
			Util.ClearDurabilityCaching()
		EndIf
		DaggerDurability = value as Int
		SetSliderOptionValue(DaggerDurabilityOID_S, DaggerDurability)
	ElseIf (option == StaffDurabilityOID_S)
		If StaffDurability != value as Int
			Util.ClearDurabilityCaching()
		EndIf
		StaffDurability = value as Int
		SetSliderOptionValue(StaffDurabilityOID_S, StaffDurability)
		
	ElseIf (option == DurabilityMinOID_S)
		DurabilityMin = value / 100.0
		SetSliderOptionValue(DurabilityMinOID_S, DurabilityMin)
	ElseIf (option == DurabilityMaxOID_S)
		DurabilityMax = value / 100.0
		SetSliderOptionValue(DurabilityMaxOID_S, DurabilityMax)
	ElseIf (option == CorpseDurabilityMinOID_S)
		CorpseDurabilityMin = value / 100.0
		SetSliderOptionValue(CorpseDurabilityMinOID_S, CorpseDurabilityMin)
	ElseIf (option == CorpseDurabilityMaxOID_S)
		CorpseDurabilityMax = value / 100.0
		SetSliderOptionValue(CorpseDurabilityMaxOID_S, CorpseDurabilityMax)
		
	; Degradation
	ElseIf (option == TemperDegradeOID_S)
		TemperDegrade = value
		SetSliderOptionValue(TemperDegradeOID_S, TemperDegrade)
	ElseIf (option == TemperDegradePowerAOID_S)
		TemperDegradePowerA = value
		SetSliderOptionValue(TemperDegradePowerAOID_S, TemperDegradePowerA)
	ElseIf (option == ArmorHitsPerHitOID_S)
		ArmorHitsPerHit = value as Int
		SetSliderOptionValue(ArmorHitsPerHitOID_S, ArmorHitsPerHit)
	ElseIf (option == WeaponDegradeOID_S)
		WeaponDegrade = value
		SetSliderOptionValue(WeaponDegradeOID_S, WeaponDegrade)
	ElseIf (option == WeaponDegradePowerOID_S)
		WeaponDegradePower = value
		SetSliderOptionValue(WeaponDegradePowerOID_S, WeaponDegradePower)
	ElseIf (option == TimeDegradeFreqOID_S)
		TimeDegradeFreq = value
		SetSliderOptionValue(TimeDegradeFreqOID_S, TimeDegradeFreq)
		DegradeOverTime.BeginUpdates()
	ElseIf (option == TimeDegradeDamageOID_S)
		TimeDegradeDamage = value
		SetSliderOptionValue(TimeDegradeDamageOID_S, TimeDegradeDamage)
	ElseIf (option == VulnerabilityMultDaggerOID_S)
		VulnerabilityMultDagger = value
		SetSliderOptionValue(VulnerabilityMultDaggerOID_S, VulnerabilityMultDagger)
	ElseIf (option == VulnerabilityMultAxeOID_S)
		VulnerabilityMultAxe = value
		SetSliderOptionValue(VulnerabilityMultAxeOID_S, VulnerabilityMultAxe)
	ElseIf (option == VulnerabilityMultSwordOID_S)
		VulnerabilityMultSword = value
		SetSliderOptionValue(VulnerabilityMultSwordOID_S, VulnerabilityMultSword)
	ElseIf (option == VulnerabilityMultBattleAxeOID_S)
		VulnerabilityMultBattleAxe = value
		SetSliderOptionValue(VulnerabilityMultBattleAxeOID_S, VulnerabilityMultBattleAxe)
	ElseIf (option == VulnerabilityMultGreatswordOID_S)
		VulnerabilityMultGreatsword = value
		SetSliderOptionValue(VulnerabilityMultGreatswordOID_S, VulnerabilityMultGreatsword)
	ElseIf (option == VulnerabilityMultMaceOID_S)
		VulnerabilityMultMace = value
		SetSliderOptionValue(VulnerabilityMultMaceOID_S, VulnerabilityMultMace)
	ElseIf (option == VulnerabilityMultWarhammerOID_S)
		VulnerabilityMultWarhammer = value
		SetSliderOptionValue(VulnerabilityMultWarhammerOID_S, VulnerabilityMultWarhammer)
	ElseIf (option == ExtraDamageChanceAxeOID_S)
		ExtraDamageChanceAxe = value
		SetSliderOptionValue(ExtraDamageChanceAxeOID_S, ExtraDamageChanceAxe)
	ElseIf (option == VulnerabilityMultFireOID_S)
		VulnerabilityMultFire = value
		SetSliderOptionValue(VulnerabilityMultFireOID_S, VulnerabilityMultFire)
	ElseIf (option == VulnerabilityMultIceOID_S)
		VulnerabilityMultIce = value
		SetSliderOptionValue(VulnerabilityMultIceOID_S, VulnerabilityMultIce)
	ElseIf (option == VulnerabilityMultLightningOID_S)
		VulnerabilityMultLightning = value
		SetSliderOptionValue(VulnerabilityMultLightningOID_S, VulnerabilityMultLightning)
	ElseIf (option == ExtraDamageChanceLightningOID_S)
		ExtraDamageChanceLightning = value
		SetSliderOptionValue(ExtraDamageChanceLightningOID_S, ExtraDamageChanceLightning)
	ElseIf (option == MagicDegradeCooldownOID_S)
		If MagicDegradeCooldown == 0.0 && value != 0.0
			Debug.MessageBox("Pfft, wuss :p")
		ElseIf value == 0.0 && MagicDegradeCooldown != 0.0
			Debug.MessageBox("Zero...? You're sure?\nIt's your funeral buddy")
		EndIf
		MagicDegradeCooldown = value
		SetSliderOptionValue(MagicDegradeCooldownOID_S, MagicDegradeCooldown)
		
	ElseIf (option == VulnerabilityShoutOneOID_S)
		VulnerabilityShoutOne = value
		SetSliderOptionValue(VulnerabilityShoutOneOID_S, VulnerabilityShoutOne)
	ElseIf (option == VulnerabilityShoutTwoOID_S)
		VulnerabilityShoutTwo = value
		SetSliderOptionValue(VulnerabilityShoutTwoOID_S, VulnerabilityShoutTwo)
	ElseIf (option == VulnerabilityShoutThreeOID_S)
		VulnerabilityShoutThree = value
		SetSliderOptionValue(VulnerabilityShoutThreeOID_S, VulnerabilityShoutThree)
		
	ElseIf (option == CreatureVulnerabilityOID_S)
		CreatureVulnerability = value
		SetSliderOptionValue(CreatureVulnerabilityOID_S, CreatureVulnerability)
	
	; Magic Armor
	ElseIf (option == MagicArmorClothingOID_S)
		MagicArmorClothing = value
		SetSliderOptionValue(MagicArmorClothingOID_S, MagicArmorClothing)
	ElseIf (option == MagicArmorArmorOID_S)
		MagicArmorArmor = value
		SetSliderOptionValue(MagicArmorArmorOID_S, MagicArmorArmor)
	ElseIf (option == MagicArmorClothingDeltaOID_S)
		MagicArmorClothingDelta = value
		SetSliderOptionValue(MagicArmorClothingDeltaOID_S, MagicArmorClothingDelta)
	ElseIf (option == MagicArmorArmorDeltaOID_S)
		MagicArmorArmorDelta = value
		SetSliderOptionValue(MagicArmorArmorDeltaOID_S, MagicArmorArmorDelta)
	ElseIf (option == MagicArmorPattackOID_S)
		MagicArmorPattack = value
		SetSliderOptionValue(MagicArmorPattackOID_S, MagicArmorPattack)
		
	; Repair
	ElseIf (option == RepairCostMinOID_S)
		RepairCostMin = value as Int
		SetSliderOptionValue(RepairCostMinOID_S, RepairCostMin)
	ElseIf (option == RepairCostBaseOID_S)
		RepairCostBase = value
		SetSliderOptionValue(RepairCostBaseOID_S, RepairCostBase)
	ElseIf (option == RepairCostEnchantOID_S)
		RepairCostEnchant = value
		SetSliderOptionValue(RepairCostEnchantOID_S, RepairCostEnchant)
	ElseIf (option == DurRepairCostMinOID_S)
		DurRepairCostMin = value as Int
		SetSliderOptionValue(DurRepairCostMinOID_S, DurRepairCostMin)
	ElseIf (option == DurRepairCostBaseOID_S)
		DurRepairCostBase = value
		SetSliderOptionValue(DurRepairCostBaseOID_S, DurRepairCostBase)
	ElseIf (option == DurRepairCostEnchantOID_S)
		DurRepairCostEnchant = value
		SetSliderOptionValue(DurRepairCostEnchantOID_S, DurRepairCostEnchant)
		
	ElseIf (option == WeightAdjustCostMinOID_S)
		WeightAdjustCostMin = value as Int
		SetSliderOptionValue(WeightAdjustCostMinOID_S, WeightAdjustCostMin)
	ElseIf (option == WeightAdjustCostBaseOID_S)
		WeightAdjustCostBase = value
		SetSliderOptionValue(WeightAdjustCostBaseOID_S, WeightAdjustCostBase)
	ElseIf (option == WeightAdjustCostEnchantOID_S)
		WeightAdjustCostEnchant = value
		SetSliderOptionValue(WeightAdjustCostEnchantOID_S, WeightAdjustCostEnchant)
	ElseIf (option == GenderAdjustCostMinOID_S)
		GenderAdjustCostMin = value as Int
		SetSliderOptionValue(GenderAdjustCostMinOID_S, GenderAdjustCostMin)
	ElseIf (option == GenderAdjustCostBaseOID_S)
		GenderAdjustCostBase = value
		SetSliderOptionValue(GenderAdjustCostBaseOID_S, GenderAdjustCostBase)
	ElseIf (option == GenderAdjustCostEnchantOID_S)
		GenderAdjustCostEnchant = value
		SetSliderOptionValue(GenderAdjustCostEnchantOID_S, GenderAdjustCostEnchant)
		
	; Object Options
	ElseIf (option == OoDurabilityOID_S)
		OoDurability = value as Int
		SetSliderOptionValue(OoDurabilityOID_S, OoDurability)
		Util.SetDurability(OoSelectedObject, OoDurability)
	ElseIf (option == OoDurabilityMaxOID_S)
		OoDurabilityMax = value as Int
		SetSliderOptionValue(OoDurabilityMaxOID_S, OoDurabilityMax)
		Util.SetDurabilityMax(OoSelectedObject, OoDurabilityMax)
	ElseIf (option == OoTemperingOID_S)
		OoTemper = value
		SetSliderOptionValue(OoTemperingOID_S, OoTemper)
		Util.SetTempering(OoSelectedObject, OoSelectedObject.GetBaseObject(), OoTemper)
		
	; Cursed Objects
	ElseIf (option == CursedSanctifyCostOID_S)
		_MWA_SanctCost.SetValueInt(value as Int)
		SetSliderOptionValue(CursedSanctifyCostOID_S, value)
		_MWA_DialogueQuest.UpdateCurrentInstanceGlobal(_MWA_SanctCost)
	ElseIf (option == CursedChanceContainerOID_S)
		CursedChanceContainer = value
		SetSliderOptionValue(CursedChanceContainerOID_S, CursedChanceContainer)
	ElseIf (option == CursedChanceCorpseOID_S)
		CursedChanceCorpse = value
		SetSliderOptionValue(CursedChanceCorpseOID_S, CursedChanceCorpse)
	EndIf
	ForcePageReset()
EndEvent

Event OnOptionInputAccept(int option, string UserInput)
	If option == RenameObjectOID
		ObjectReference ObjRef = StorageUtil.FormListGet(None, "_MWA_WornDestructibles", ObjectSelect) as ObjectReference
		If ShowMessage("Are you sure you want to rename " + ObjRef.GetBaseObject().GetName() + " to " + UserInput + "?")
			StorageUtil.SetStringValue(ObjRef, "_MWA_OriginalName", StorageUtil.GetStringValue(ObjRef, "_MWA_ObjDisplayName"))
			StorageUtil.SetStringValue(ObjRef, "_MWA_ObjDisplayName", UserInput)
			StorageUtil.SetIntValue(ObjRef, "_MWA_NameModified", 1)
			Util.DispItemDurability (ObjRef, ObjRef.GetBaseObject(), 0.0)
			ForcePageReset()
		Endif
	Endif
EndEvent

Event OnConfigClose()
	IsInMcm = false
	InvScanned = false
EndEvent

Event OnConfigOpen()
	IsInMcm = true
	ObjectSelect = 0
EndEvent

; Functions Begin =======================================================

Function ResetObjectName()
	ObjectReference ObjRef = StorageUtil.FormListGet(None, "_MWA_WornDestructibles", ObjectSelect) as ObjectReference
	String OriginalName = StorageUtil.GetStringValue(ObjRef, "_MWA_OriginalName")
	If ShowMessage("Are you sure you want to reset " + StorageUtil.GetStringValue(ObjRef, "_MWA_ObjDisplayName") + " to " + OriginalName + "?\n\nIt's base form name is: " + ObjRef.GetBaseObject().GetName())
		StorageUtil.SetStringValue(ObjRef, "_MWA_ObjDisplayName", OriginalName)
		StorageUtil.UnsetStringValue(ObjRef, "_MWA_OriginalName")
		StorageUtil.UnsetIntValue(ObjRef, "_MWA_NameModified")
		Util.DispItemDurability (ObjRef, ObjRef.GetBaseObject(), 0.0)
		SetTextOptionValue(ResetObjectNameOID_T, "Done! ")
		Utility.WaitMenuMode(1.0)
		SetTextOptionValue(ResetObjectNameOID_T, "")
		ForcePageReset()
	Endif
EndFunction

Function AddImmunityUpdate(Int AliasIndex, Bool Match)
	If IsInMcm
		If AliasIndex > -1
			String S1 = ""
			If Match
				S1 = " - Hit"
			EndIf
			SetTextOptionValue(ModImmunityOID_T, "Alias: " + AliasIndex + S1, false)
		Else
			SetTextOptionValue(ModImmunityOID_T, "Done! ", false)
			Utility.WaitMenuMode(1.5)
			SetTextOptionValue(ModImmunityOID_T, "", false)
		EndIf
	EndIf
EndFunction

Function GatherObjects()
	Int i
	ObjectReference ObjRef
	
	StorageUtil.StringListClear(Self, "_MWA_WornListNames")
	StorageUtil.FormListClear(Self, "_MWA_WornListCopy")
	
	; Add equipped ObjRefs
	Form[] WornCopy = StorageUtil.FormListToArray(None, "_MWA_WornDestructibles")
	StorageUtil.FormListCopy(Self, "_MWA_WornListCopy", WornCopy)
	If ArmorDes.LeftWeapon
		StorageUtil.FormListAdd(Self, "_MWA_WornListCopy", ArmorDes.LeftWeapon)
	Endif
	If ArmorDes.RightWeapon
		StorageUtil.FormListAdd(Self, "_MWA_WornListCopy", ArmorDes.RightWeapon)
	Endif
	
	; Add immune list objects
	i = _MWA_ImmuneList.GetSize()
	While i > 0
		i -= 1
		StorageUtil.FormListAdd(Self, "_MWA_WornListCopy", _MWA_ImmuneList.GetAt(i))
	EndWhile
	
	; Set index 0 - None
	StorageUtil.FormListInsert(Self, "_MWA_WornListCopy", 0, None)
	StorageUtil.StringListAdd(Self, "_MWA_WornListNames", "None ", allowDuplicate = false)

	; Get a corresponding list of object names
	i = 1
	While i < StorageUtil.FormListCount(Self, "_MWA_WornListCopy")
		ObjRef = StorageUtil.FormListGet(Self, "_MWA_WornListCopy", i) as ObjectReference
		;StorageUtil.StringListAdd(Self, "_MWA_WornListNames", ObjRef.GetDisplayName(), allowDuplicate = false)
		If ObjRef
			StorageUtil.StringListAdd(Self, "_MWA_WornListNames", StorageUtil.GetStringValue(ObjRef, "_MWA_ObjDisplayName"), allowDuplicate = false)
		Else
			StorageUtil.StringListAdd(Self, "_MWA_WornListNames", StorageUtil.FormListGet(Self, "_MWA_WornListCopy", i).GetName(), allowDuplicate = false)
		Endif
		i += 1
	EndWhile
	EquipListNames = StorageUtil.StringListToArray(Self, "_MWA_WornListNames")
EndFunction

Function ScanAllInvObjects()
	Form akItem
	Int WasAdded
	Int i = PlayerRef.GetNumItems()
	While i > 0
		i -= 1
		akItem = PlayerRef.GetNthForm(i)
		If akItem as Weapon || akItem as Armor
			SetTextOptionValue(ScanInvOID_T, akItem.GetName(), false)
			If !Util.HasNoStripKeyword(akItem) && !Util.HasZadInvDeviceKeyword(akItem)
				WasAdded = StorageUtil.FormListAdd(Self, "_MWA_WornListCopy", akItem, allowDuplicate = false)
				If WasAdded >= 0
					StorageUtil.StringListAdd(Self, "_MWA_WornListNames", akItem.GetName(), allowDuplicate = true)
				Endif
			EndIf
		EndIf
	EndWhile
	EquipListNames = StorageUtil.StringListToArray(Self, "_MWA_WornListNames")
	SetTextOptionValue(ScanInvOID_T, "Scan Done!", false)
	InvScanned = true
	
	;/
	; Debugging to print lists to the log
	i = 0
	While i < StorageUtil.StringListCount(Self, "_MWA_WornListNames")
		Debug.Trace("_MWA_: " + i + ") Name: " + StorageUtil.StringListGet(Self, "_MWA_WornListNames", i) + ". Form: " + StorageUtil.FormListGet(Self, "_MWA_WornListCopy", i) + ". EquipListNames: " + EquipListNames[i])
		i += 1
	EndWhile
	/;
EndFunction

Function ToggleRemoveFoodCans()
	If RemoveFoodCANs > 0.0
		PlayerRef.AddPerk(_MWA_FoodRemovalPerk)
	Else
		PlayerRef.RemovePerk(_MWA_FoodRemovalPerk)
	EndIf
EndFunction

Function ToggleLockpickRemoval()
	If RemoveLockpicks > 0.0
		PlayerRef.AddPerk(_MWA_LockpickRemovalPerk)
	Else
		PlayerRef.RemovePerk(_MWA_LockpickRemovalPerk)
	EndIf
EndFunction

Function SaveSettings()

	; Ints
	JsonUtil.SetIntValue("MWA/Settings.json", "LostObjectSearchTime", LostObjectSearchTime)
	JsonUtil.SetIntValue("MWA/Settings.json", "ClothesDurability", ClothesDurability)
	JsonUtil.SetIntValue("MWA/Settings.json", "LightDurability", LightDurability)
	JsonUtil.SetIntValue("MWA/Settings.json", "HeavyDurability", HeavyDurability)
	JsonUtil.SetIntValue("MWA/Settings.json", "OneHDurability", OneHDurability)
	JsonUtil.SetIntValue("MWA/Settings.json", "TwoHDurability", TwoHDurability)
	JsonUtil.SetIntValue("MWA/Settings.json", "RangedDurability", RangedDurability)
	JsonUtil.SetIntValue("MWA/Settings.json", "DaggerDurability", DaggerDurability)
	JsonUtil.SetIntValue("MWA/Settings.json", "StaffDurability", StaffDurability)
	JsonUtil.SetIntValue("MWA/Settings.json", "ArmorHitsPerHit", ArmorHitsPerHit)
	JsonUtil.SetIntValue("MWA/Settings.json", "RepairCostMin", RepairCostMin)
	JsonUtil.SetIntValue("MWA/Settings.json", "DurRepairCostMin", DurRepairCostMin)
	JsonUtil.SetIntValue("MWA/Settings.json", "WeightAdjustCostMin", WeightAdjustCostMin)
	JsonUtil.SetIntValue("MWA/Settings.json", "GenderAdjustCostMin", GenderAdjustCostMin)
	JsonUtil.SetIntValue("MWA/Settings.json", "DestructableTypes", DestructableTypes)
	JsonUtil.SetIntValue("MWA/Settings.json", "ObjectSearchVisionType", ObjectSearchVisionType)
	JsonUtil.SetIntValue("MWA/Settings.json", "ContainerScanMaxItems", ContainerScanMaxItems)
	JsonUtil.SetIntValue("MWA/Settings.json", "RapeMinDamage", RapeMinDamage)
	JsonUtil.SetIntValue("MWA/Settings.json", "RapeMaxDamage", RapeMaxDamage)
	JsonUtil.SetIntValue("MWA/Settings.json", "LockpickValue", LockpickValue)
	JsonUtil.SetIntValue("MWA/Settings.json", "_MWA_SanctCost", _MWA_SanctCost.GetValueInt())

	; Floats
	JsonUtil.SetFloatValue("MWA/Settings.json", "DroppedTeleportDistance", DroppedTeleportDistance)
	JsonUtil.SetFloatValue("MWA/Settings.json", "ObjectLossChance", ObjectLossChance)
	JsonUtil.SetFloatValue("MWA/Settings.json", "SuitabilityWeight", SuitabilityWeight)
	JsonUtil.SetFloatValue("MWA/Settings.json", "SuitabilityBikini", SuitabilityBikini)
	JsonUtil.SetFloatValue("MWA/Settings.json", "DurabilityTolerance", DurabilityTolerance)
	JsonUtil.SetFloatValue("MWA/Settings.json", "ShieldDurabilityMod", ShieldDurabilityMod)
	JsonUtil.SetFloatValue("MWA/Settings.json", "MagicArmorClothing", MagicArmorClothing)
	JsonUtil.SetFloatValue("MWA/Settings.json", "MagicArmorArmor", MagicArmorArmor)
	JsonUtil.SetFloatValue("MWA/Settings.json", "MagicArmorPattack", MagicArmorPattack)
	JsonUtil.SetFloatValue("MWA/Settings.json", "MagicArmorClothingDelta", MagicArmorClothingDelta)
	JsonUtil.SetFloatValue("MWA/Settings.json", "MagicArmorArmorDelta", MagicArmorArmorDelta)
	JsonUtil.SetFloatValue("MWA/Settings.json", "RepairCostBase", RepairCostBase)
	JsonUtil.SetFloatValue("MWA/Settings.json", "RepairCostEnchant", RepairCostEnchant)
	JsonUtil.SetFloatValue("MWA/Settings.json", "DurRepairCostBase", DurRepairCostBase)
	JsonUtil.SetFloatValue("MWA/Settings.json", "DurRepairCostEnchant", DurRepairCostEnchant)
	JsonUtil.SetFloatValue("MWA/Settings.json", "WeightAdjustCostBase", WeightAdjustCostBase)
	JsonUtil.SetFloatValue("MWA/Settings.json", "WeightAdjustCostEnchant", WeightAdjustCostEnchant)
	JsonUtil.SetFloatValue("MWA/Settings.json", "GenderAdjustCostBase", GenderAdjustCostBase)
	JsonUtil.SetFloatValue("MWA/Settings.json", "GenderAdjustCostEnchant", GenderAdjustCostEnchant)
	JsonUtil.SetFloatValue("MWA/Settings.json", "TemperDegrade", TemperDegrade)
	JsonUtil.SetFloatValue("MWA/Settings.json", "TemperDegradePowerA", TemperDegradePowerA)
	JsonUtil.SetFloatValue("MWA/Settings.json", "WeaponDegrade", WeaponDegrade)
	JsonUtil.SetFloatValue("MWA/Settings.json", "WeaponDegradePower", WeaponDegradePower)
	JsonUtil.SetFloatValue("MWA/Settings.json", "TimeDegradeFreq", TimeDegradeFreq)
	JsonUtil.SetFloatValue("MWA/Settings.json", "TimeDegradeDamage", TimeDegradeDamage)	
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityMultDagger", VulnerabilityMultDagger)	
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityMultAxe", VulnerabilityMultAxe)	
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityMultSword", VulnerabilityMultSword)	
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityMultBattleAxe", VulnerabilityMultBattleAxe)	
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityMultGreatsword", VulnerabilityMultGreatsword)	
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityMultMace", VulnerabilityMultMace)	
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityMultWarhammer", VulnerabilityMultWarhammer)	
	JsonUtil.SetFloatValue("MWA/Settings.json", "ExtraDamageChanceAxe", ExtraDamageChanceAxe)
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityMultFire", VulnerabilityMultFire)
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityMultIce", VulnerabilityMultIce)
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityMultLightning", VulnerabilityMultLightning)
	JsonUtil.SetFloatValue("MWA/Settings.json", "ExtraDamageChanceLightning", ExtraDamageChanceLightning)	
	JsonUtil.SetFloatValue("MWA/Settings.json", "MagicDegradeCooldown", MagicDegradeCooldown)
	JsonUtil.SetFloatValue("MWA/Settings.json", "BreakSoundVolume", BreakSoundVolume)
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityShoutOne", VulnerabilityShoutOne)
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityShoutTwo", VulnerabilityShoutTwo)
	JsonUtil.SetFloatValue("MWA/Settings.json", "VulnerabilityShoutThree", VulnerabilityShoutThree)
	JsonUtil.SetFloatValue("MWA/Settings.json", "CreatureVulnerability", CreatureVulnerability)
	JsonUtil.SetFloatValue("MWA/Settings.json", "CombatEquipTime", CombatEquipTime)
	JsonUtil.SetFloatValue("MWA/Settings.json", "DurabilityMin", DurabilityMin)
	JsonUtil.SetFloatValue("MWA/Settings.json", "DurabilityMax", DurabilityMax)
	JsonUtil.SetFloatValue("MWA/Settings.json", "CorpseDurabilityMin", CorpseDurabilityMin)
	JsonUtil.SetFloatValue("MWA/Settings.json", "CorpseDurabilityMax", CorpseDurabilityMax)
	JsonUtil.SetFloatValue("MWA/Settings.json", "ItemFitsPcChance", ItemFitsPcChance)
	JsonUtil.SetFloatValue("MWA/Settings.json", "CursedChanceContainer", CursedChanceContainer)
	JsonUtil.SetFloatValue("MWA/Settings.json", "CursedChanceCorpse", CursedChanceCorpse)
	JsonUtil.SetFloatValue("MWA/Settings.json", "RemoveFoodCANs", RemoveFoodCANs)
	JsonUtil.SetFloatValue("MWA/Settings.json", "RemoveLockpicks", RemoveLockpicks)
	JsonUtil.SetFloatValue("MWA/Settings.json", "DestructStagger", DestructStagger)
	
	; Bools
	JsonUtil.SetIntValue("MWA/Settings.json", "NpcDegradationScanT", NpcDegradationScanT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "SuitabilityT", SuitabilityT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "SuitabilityBodyT", SuitabilityBodyT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AddSuitabilityDes", AddSuitabilityDes as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AddMaterialBonusT", AddMaterialBonusT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "ArmorHitsPerHitRandomT", ArmorHitsPerHitRandomT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "TimeDegradeDurDecT", TimeDegradeDurDecT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "ComplexDegradationT", ComplexDegradationT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "TemperingRefitT", TemperingRefitT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "SearchBoxNotifyT", SearchBoxNotifyT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "WorldObjectScanT", WorldObjectScanT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "ContainerScanT", ContainerScanT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "CombatEquipWaitPerItemT", CombatEquipWaitPerItemT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "CombatEquipT", CombatEquipT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "RemoveFoodWorldT", RemoveFoodWorldT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "RandomNpcFitT", RandomNpcFitT as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousCorsets", AllowDeviousCorsets as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousHarnesses", AllowDeviousHarnesses as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousBelts", AllowDeviousBelts as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousBras", AllowDeviousBras as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousPlugsAnal", AllowDeviousPlugsAnal as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousPlugsVag", AllowDeviousPlugsVag as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousSuits", AllowDeviousSuits as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousHobble", AllowDeviousHobble as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousPetSuits", AllowDeviousPetSuits as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousStraitJackets", AllowDeviousStraitJackets as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousBoots", AllowDeviousBoots as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousLegCuffs", AllowDeviousLegCuffs as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousGloves", AllowDeviousGloves as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousMittens", AllowDeviousMittens as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousArmCuffs", AllowDeviousArmCuffs as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousArmbinders", AllowDeviousArmbinders as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousElbowBinders", AllowDeviousElbowBinders as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousYokes", AllowDeviousYokes as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousBreastYokes", AllowDeviousBreastYokes as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousGags", AllowDeviousGags as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousBlindfolds", AllowDeviousBlindfolds as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousCollars", AllowDeviousCollars as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousNipples", AllowDeviousNipples as Int)
	JsonUtil.SetIntValue("MWA/Settings.json", "AllowDeviousClit", AllowDeviousClit as Int)

	JsonUtil.Save("MWA/Settings.json")
EndFunction

Function LoadSettings()

	; Ints
	LostObjectSearchTime = JsonUtil.GetIntValue("MWA/Settings.json", "LostObjectSearchTime")
	ClothesDurability = JsonUtil.GetIntValue("MWA/Settings.json", "ClothesDurability")
	LightDurability = JsonUtil.GetIntValue("MWA/Settings.json", "LightDurability")
	HeavyDurability = JsonUtil.GetIntValue("MWA/Settings.json", "HeavyDurability")
	OneHDurability = JsonUtil.GetIntValue("MWA/Settings.json", "OneHDurability")
	TwoHDurability = JsonUtil.GetIntValue("MWA/Settings.json", "TwoHDurability")
	RangedDurability = JsonUtil.GetIntValue("MWA/Settings.json", "RangedDurability")
	DaggerDurability = JsonUtil.GetIntValue("MWA/Settings.json", "DaggerDurability")
	StaffDurability = JsonUtil.GetIntValue("MWA/Settings.json", "StaffDurability")
	ArmorHitsPerHit = JsonUtil.GetIntValue("MWA/Settings.json", "ArmorHitsPerHit")
	RepairCostMin = JsonUtil.GetIntValue("MWA/Settings.json", "RepairCostMin")
	DurRepairCostMin = JsonUtil.GetIntValue("MWA/Settings.json", "DurRepairCostMin")
	WeightAdjustCostMin = JsonUtil.GetIntValue("MWA/Settings.json", "WeightAdjustCostMin")
	GenderAdjustCostMin = JsonUtil.GetIntValue("MWA/Settings.json", "GenderAdjustCostMin")
	DestructableTypes = JsonUtil.GetIntValue("MWA/Settings.json", "DestructableTypes")
	ObjectSearchVisionType = JsonUtil.GetIntValue("MWA/Settings.json", "ObjectSearchVisionType")
	ContainerScanMaxItems = JsonUtil.GetIntValue("MWA/Settings.json", "ContainerScanMaxItems")
	RapeMinDamage = JsonUtil.GetIntValue("MWA/Settings.json", "RapeMinDamage")
	RapeMaxDamage = JsonUtil.GetIntValue("MWA/Settings.json", "RapeMaxDamage")
	LockpickValue = JsonUtil.GetIntValue("MWA/Settings.json", "LockpickValue")
	_MWA_SanctCost.SetValueInt(JsonUtil.GetIntValue("MWA/Settings.json", "_MWA_SanctCost"))
	_MWA_DialogueQuest.UpdateCurrentInstanceGlobal(_MWA_SanctCost)
	
	; Floats
	DroppedTeleportDistance = JsonUtil.GetFloatValue("MWA/Settings.json", "DroppedTeleportDistance")
	ObjectLossChance = JsonUtil.GetFloatValue("MWA/Settings.json", "ObjectLossChance")
	SuitabilityWeight = JsonUtil.GetFloatValue("MWA/Settings.json", "SuitabilityWeight")
	SuitabilityBikini = JsonUtil.GetFloatValue("MWA/Settings.json", "SuitabilityBikini")
	RepairCostBase = JsonUtil.GetFloatValue("MWA/Settings.json", "RepairCostBase")
	RepairCostEnchant = JsonUtil.GetFloatValue("MWA/Settings.json", "RepairCostEnchant")
	DurabilityTolerance = JsonUtil.GetFloatValue("MWA/Settings.json", "DurabilityTolerance")
	ShieldDurabilityMod = JsonUtil.GetFloatValue("MWA/Settings.json", "ShieldDurabilityMod")
	MagicArmorClothing = JsonUtil.GetFloatValue("MWA/Settings.json", "MagicArmorClothing")
	MagicArmorArmor = JsonUtil.GetFloatValue("MWA/Settings.json", "MagicArmorArmor")
	MagicArmorPattack = JsonUtil.GetFloatValue("MWA/Settings.json", "MagicArmorPattack")
	MagicArmorClothingDelta = JsonUtil.GetFloatValue("MWA/Settings.json", "MagicArmorClothingDelta")
	MagicArmorArmorDelta = JsonUtil.GetFloatValue("MWA/Settings.json", "MagicArmorArmorDelta")
	DurRepairCostBase = JsonUtil.GetFloatValue("MWA/Settings.json", "DurRepairCostBase")
	DurRepairCostEnchant = JsonUtil.GetFloatValue("MWA/Settings.json", "DurRepairCostEnchant")
	WeightAdjustCostBase = JsonUtil.GetFloatValue("MWA/Settings.json", "WeightAdjustCostBase")
	WeightAdjustCostEnchant = JsonUtil.GetFloatValue("MWA/Settings.json", "WeightAdjustCostEnchant")
	GenderAdjustCostBase = JsonUtil.GetFloatValue("MWA/Settings.json", "GenderAdjustCostBase")
	GenderAdjustCostEnchant = JsonUtil.GetFloatValue("MWA/Settings.json", "GenderAdjustCostEnchant")
	TemperDegrade = JsonUtil.GetFloatValue("MWA/Settings.json", "TemperDegrade")
	TemperDegradePowerA = JsonUtil.GetFloatValue("MWA/Settings.json", "TemperDegradePowerA")
	WeaponDegrade = JsonUtil.GetFloatValue("MWA/Settings.json", "WeaponDegrade")
	WeaponDegradePower = JsonUtil.GetFloatValue("MWA/Settings.json", "WeaponDegradePower")
	TimeDegradeFreq = JsonUtil.GetFloatValue("MWA/Settings.json", "TimeDegradeFreq")
	TimeDegradeDamage = JsonUtil.GetFloatValue("MWA/Settings.json", "TimeDegradeDamage")
	VulnerabilityMultDagger = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityMultDagger")
	VulnerabilityMultAxe = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityMultAxe")
	VulnerabilityMultSword = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityMultSword")
	VulnerabilityMultBattleAxe = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityMultBattleAxe")
	VulnerabilityMultGreatsword = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityMultGreatsword")
	VulnerabilityMultMace = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityMultMace")
	VulnerabilityMultWarhammer = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityMultWarhammer")
	ExtraDamageChanceAxe = JsonUtil.GetFloatValue("MWA/Settings.json", "ExtraDamageChanceAxe")
	VulnerabilityMultFire = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityMultFire")
	VulnerabilityMultIce = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityMultIce")
	VulnerabilityMultLightning = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityMultLightning")
	ExtraDamageChanceLightning = JsonUtil.GetFloatValue("MWA/Settings.json", "ExtraDamageChanceLightning")
	MagicDegradeCooldown = JsonUtil.GetFloatValue("MWA/Settings.json", "MagicDegradeCooldown")
	BreakSoundVolume = JsonUtil.GetFloatValue("MWA/Settings.json", "BreakSoundVolume")
	VulnerabilityShoutOne = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityShoutOne")
	VulnerabilityShoutTwo = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityShoutTwo")
	VulnerabilityShoutThree = JsonUtil.GetFloatValue("MWA/Settings.json", "VulnerabilityShoutThree")
	CreatureVulnerability = JsonUtil.GetFloatValue("MWA/Settings.json", "CreatureVulnerability")
	CombatEquipTime = JsonUtil.GetFloatValue("MWA/Settings.json", "CombatEquipTime")
	DurabilityMin = JsonUtil.GetFloatValue("MWA/Settings.json", "DurabilityMin")
	DurabilityMax = JsonUtil.GetFloatValue("MWA/Settings.json", "DurabilityMax")
	CorpseDurabilityMin = JsonUtil.GetFloatValue("MWA/Settings.json", "CorpseDurabilityMin")
	CorpseDurabilityMax = JsonUtil.GetFloatValue("MWA/Settings.json", "CorpseDurabilityMax")
	ItemFitsPcChance = JsonUtil.GetFloatValue("MWA/Settings.json", "ItemFitsPcChance")
	CursedChanceContainer = JsonUtil.GetFloatValue("MWA/Settings.json", "CursedChanceContainer")
	CursedChanceCorpse = JsonUtil.GetFloatValue("MWA/Settings.json", "CursedChanceCorpse")
	RemoveFoodCANs = JsonUtil.GetFloatValue("MWA/Settings.json", "RemoveFoodCANs")
	RemoveLockpicks = JsonUtil.GetFloatValue("MWA/Settings.json", "RemoveLockpicks")
	DestructStagger = JsonUtil.GetFloatValue("MWA/Settings.json", "DestructStagger")
	
	; Bools
	NpcDegradationScanT = JsonUtil.GetIntValue("MWA/Settings.json", "NpcDegradationScanT")
	SuitabilityT = JsonUtil.GetIntValue("MWA/Settings.json", "SuitabilityT")
	SuitabilityBodyT = JsonUtil.GetIntValue("MWA/Settings.json", "SuitabilityBodyT")
	AddSuitabilityDes = JsonUtil.GetIntValue("MWA/Settings.json", "AddSuitabilityDes")
	AddMaterialBonusT = JsonUtil.GetIntValue("MWA/Settings.json", "AddMaterialBonusT")
	ArmorHitsPerHitRandomT = JsonUtil.GetIntValue("MWA/Settings.json", "ArmorHitsPerHitRandomT")
	TimeDegradeDurDecT = JsonUtil.GetIntValue("MWA/Settings.json", "TimeDegradeDurDecT")
	ComplexDegradationT = JsonUtil.GetIntValue("MWA/Settings.json", "ComplexDegradationT")
	TemperingRefitT = JsonUtil.GetIntValue("MWA/Settings.json", "TemperingRefitT")
	SearchBoxNotifyT = JsonUtil.GetIntValue("MWA/Settings.json", "SearchBoxNotifyT")
	WorldObjectScanT = JsonUtil.GetIntValue("MWA/Settings.json", "WorldObjectScanT")
	ContainerScanT = JsonUtil.GetIntValue("MWA/Settings.json", "ContainerScanT")
	CombatEquipT = JsonUtil.GetIntValue("MWA/Settings.json", "CombatEquipT")
	CombatEquipWaitPerItemT = JsonUtil.GetIntValue("MWA/Settings.json", "CombatEquipWaitPerItemT")
	RemoveFoodWorldT = JsonUtil.GetIntValue("MWA/Settings.json", "RemoveFoodWorldT")
	RandomNpcFitT = JsonUtil.GetIntValue("MWA/Settings.json", "RandomNpcFitT")
	AllowDeviousCorsets = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousCorsets")
	AllowDeviousHarnesses = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousHarnesses")
	AllowDeviousBelts = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousBelts")
	AllowDeviousBras = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousBras")
	AllowDeviousPlugsAnal = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousPlugsAnal")
	AllowDeviousPlugsVag = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousPlugsVag")
	AllowDeviousSuits = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousSuits")
	AllowDeviousHobble = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousHobble")
	AllowDeviousPetSuits = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousPetSuits")
	AllowDeviousStraitJackets = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousStraitJackets")
	AllowDeviousBoots = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousBoots")
	AllowDeviousLegCuffs = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousLegCuffs")
	AllowDeviousGloves = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousGloves")
	AllowDeviousMittens = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousMittens")
	AllowDeviousArmCuffs = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousArmCuffs")
	AllowDeviousArmbinders = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousArmbinders")
	AllowDeviousElbowBinders = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousElbowBinders")
	AllowDeviousYokes = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousYokes")
	AllowDeviousBreastYokes = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousBreastYokes")
	AllowDeviousGags = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousGags")
	AllowDeviousBlindfolds = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousBlindfolds")
	AllowDeviousCollars = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousCollars")
	AllowDeviousNipples = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousNipples")
	AllowDeviousClit = JsonUtil.GetIntValue("MWA/Settings.json", "AllowDeviousClit")

	ToggleRemoveFoodCans()
	ToggleLockpickRemoval()
	Util.SetLockpickValue()
EndFunction

Function SkipLine()
	AddEmptyOption()
	AddEmptyOption()
EndFunction

; MCM Begin ===================================================

; Text Input Box
Int RenameObjectOID

; Text
Int AliasCleanupOID_T
Int ExportSettingsOID_T
Int ImportSettingsOID_T
Int ModImmunityOID_T
Int ClearImmuneListOID_T
Int Property ResetWornDursOID_T Auto Hidden
Int Property ResetDurCacheOID_T Auto Hidden
Int TemperDegradeHitsOID_T
Int TemperDegradePowerHitsOID_T
Int ArmorHitsPerHitRandomTOID
Int WeaponDegradeHitsOID_T
Int WeaponDegradePowerHitsOID_T
Int ScanInvOID_T
Int OoAddFittedObjectOID_T
Int ResetObjectNameOID_T
Int OoDurabilityOID_S
Int OoDurabilityMaxOID_S
Int OoTemperingOID_S
Int OoCursedTOID
Int CleanWornListOID_T

; Toggles
Int MasterSwitchTOID
Int DegradationTOID
Int DestructStaggerOID_S
Int SearchBoxNotifyTOID
Int NpcDegradationScanTOID
Int WorldObjectScanTOID
Int ContainerScanTOID
Int SuitabilityTOID
Int SuitabilityBodyTOID
Int SuitabilityDescripOID
Int EverythingFitsTOID
Int RandomNpcFitTOID
Int AddMaterialBonusTOID
Int TimeDegradeDurDecTOID
Int TemperingRefitTOID
Int CombatEquipTOID
Int CombatEquipWaitPerItemTOID
Int RemoveFoodWorldTOID
Int SexlabIntOIDT
Int CurseUnequipTOID
Int CurseDestroyTOID
Int CurseForceTOID
Int AllowDeviousBeltsTOID
Int AllowDeviousBrasTOID
Int AllowDeviousCorsetsTOID
Int AllowDeviousHarnessesTOID
Int AllowDeviousArmCuffsTOID
Int AllowDeviousLegCuffsTOID
Int AllowDeviousBootsTOID
Int AllowDeviousGlovesTOID
Int AllowDeviousMittensTOID
Int AllowDeviousCollarsTOID
Int AllowDeviousGagsTOID
Int AllowDeviousBlindfoldsTOID
Int AllowDeviousNipplesTOID
Int AllowDeviousClitTOID
Int AllowDeviousArmbindersTOID
Int AllowDeviousElbowBindersTOID
Int AllowDeviousSuitsTOID
Int AllowDeviousHobbleTOID
Int AllowDeviousStraitJacketsTOID
Int AllowDeviousPetSuitsTOID
Int AllowDeviousPlugsAnalTOID
Int AllowDeviousPlugsVagTOID
Int AllowDeviousYokesTOID
Int AllowDeviousBreastYokesTOID

; Sliders
Int BreakSoundVolumeOID_S
Int ContainerScanMaxItemsOID_S
Int LostObjectSearchTimeOID_S
Int DroppedTeleportDistanceOID_S
Int ObjectLossChanceOID_S
Int SuitabilityWeightOID_S
Int SuitabilityBikiniOID_S
Int ItemFitsPcChanceOID_S
Int ClothesDurabilityOID_S
Int LightDurabilityOID_S
Int HeavyDurabilityOID_S
Int DurabilityToleranceOID_S
Int ShieldDurabilityModOID_S
Int OneHDurabilityOID_S
Int TwoHDurabilityOID_S
Int RangedDurabilityOID_S
Int DaggerDurabilityOID_S
Int StaffDurabilityOID_S
Int DurabilityMinOID_S
Int DurabilityMaxOID_S
Int CorpseDurabilityMinOID_S
Int CorpseDurabilityMaxOID_S
Int RapeMinDamageOID_S
Int RapeMaxDamageOID_S
Int CombatEquipTimeOID_S
Int RemoveFoodCANsOID_S
Int RemoveLockpicksOID_S
Int LockpickValueOID_S

Int TemperDegradeOID_S
Int TemperDegradePowerAOID_S
Int ArmorHitsPerHitOID_S
Int WeaponDegradeOID_S
Int WeaponDegradePowerOID_S
Int TimeDegradeFreqOID_S
Int TimeDegradeDamageOID_S
Int ComplexDegradationOID
Int VulnerabilityMultDaggerOID_S
Int VulnerabilityMultSwordOID_S
Int VulnerabilityMultGreatswordOID_S
Int VulnerabilityMultAxeOID_S
Int VulnerabilityMultBattleAxeOID_S
Int ExtraDamageChanceAxeOID_S
Int VulnerabilityMultMaceOID_S
Int VulnerabilityMultWarhammerOID_S
Int VulnerabilityMultFireOID_S
Int VulnerabilityMultIceOID_S
Int VulnerabilityMultLightningOID_S
Int VulnerabilityShoutOneOID_S
Int VulnerabilityShoutTwoOID_S
Int VulnerabilityShoutThreeOID_S
Int ExtraDamageChanceLightningOID_S
Int MagicDegradeCooldownOID_S
Int CreatureVulnerabilityOID_S

Int MagicArmorClothingOID_S
Int MagicArmorArmorOID_S
Int MagicArmorClothingDeltaOID_S
Int MagicArmorArmorDeltaOID_S
Int MagicArmorPattackOID_S

Int RepairCostMinOID_S
Int RepairCostBaseOID_S
Int RepairCostEnchantOID_S
Int DurRepairCostMinOID_S
Int DurRepairCostBaseOID_S
Int DurRepairCostEnchantOID_S
Int WeightAdjustCostMinOID_S
Int WeightAdjustCostBaseOID_S
Int WeightAdjustCostEnchantOID_S
Int GenderAdjustCostMinOID_S
Int GenderAdjustCostBaseOID_S
Int GenderAdjustCostEnchantOID_S

Int CursedSanctifyCostOID_S
Int CursedChanceContainerOID_S
Int CursedChanceCorpseOID_S

; DialogBox
Int DropTypeDB
Int DestructableTypesDB
Int ObjectSearchVisionTypeDB
Int ObjectSelectDB

; Menu Variables Begin =======================================================

String[] DropTypeList
String[] DestructableTypesList
String[] ObjectSearchVisionTypeList
String[] EquipListNames

Bool InvScanned = false
Bool Property IsInMcm = false Auto Hidden
Bool Property DdsInstalled = false Auto Hidden
Float Property ItemHealthPerTier = 0.1 Auto Hidden
Int ObjectSelect = 0

Int OoDurability
Int OoDurabilityMax
Float OoTemper
Float Property OoTemperMax = 1.7 Auto Hidden
Bool OoCursed
ObjectReference OoSelectedObject
Form SelectedObjectForm

; Properties ============================================================

Int Property DestructableTypes = 0 Auto Hidden
Int Property ObjectSearchVisionType = 1 Auto Hidden

Bool Property MasterSwitchT = true Auto Hidden
Bool Property DegradationT = true Auto Hidden
Bool Property NpcDegradationScanT = true Auto Hidden
Bool Property WorldObjectScanT = true Auto Hidden
Bool Property ContainerScanT = true Auto Hidden
Int Property ContainerScanMaxItems = 20 Auto Hidden
Float Property DestructStagger = 65.0 Auto Hidden
Int Property DropType = 1 Auto Hidden
Float Property BreakSoundVolume = 0.6 Auto Hidden
Int Property LostObjectSearchTime = 20 Auto Hidden
Float Property DroppedTeleportDistance = 512.0 Auto Hidden
Bool Property SearchBoxNotifyT = false Auto Hidden
Float Property ObjectLossChance = 0.0 Auto Hidden
Bool Property SuitabilityT = true Auto Hidden
Bool Property SuitabilityBodyT = false Auto Hidden
Float Property SuitabilityWeight = 5.0 Auto Hidden
Float Property SuitabilityBikini = 20.0 Auto Hidden
Float Property ItemFitsPcChance = 5.0 Auto Hidden
Int Property RapeMinDamage = 4 Auto Hidden
Int Property RapeMaxDamage = 10 Auto Hidden
Bool Property CombatEquipT = true Auto Hidden
Bool Property CombatEquipWaitPerItemT = true Auto Hidden
Float Property CombatEquipTime = 2.5 Auto Hidden
Float Property RemoveFoodCANs = 90.0 Auto Hidden
Bool Property RemoveFoodWorldT = True Auto Hidden
Float Property RemoveLockpicks = 90.0 Auto Hidden
Int Property LockpickValue = 50 Auto Hidden

Bool Property AddSuitabilityDes = true Auto Hidden
Bool Property EverythingFits = false Auto Hidden
Bool Property RandomNpcFitT = false Auto Hidden
Bool Property AddMaterialBonusT = true Auto Hidden
Float Property ShieldDurabilityMod = 1.5 Auto Hidden
Int Property HeavyDurability = 16 Auto Hidden
Int Property LightDurability = 12 Auto Hidden
Int Property ClothesDurability = 8 Auto Hidden
Float Property DurabilityTolerance = 25.0 Auto Hidden
Int Property OneHDurability = 25 Auto Hidden
Int Property TwoHDurability = 35 Auto Hidden
Int Property RangedDurability = 40 Auto Hidden
Int Property DaggerDurability = 20 Auto Hidden
Int Property StaffDurability = 25 Auto Hidden
Float Property DurabilityMin = 0.05 Auto Hidden
Float Property DurabilityMax = 1.00 Auto Hidden
Float Property CorpseDurabilityMin = 0.00 Auto Hidden
Float Property CorpseDurabilityMax = 0.30 Auto Hidden

Float Property TemperDegrade = 0.0025 Auto Hidden
Float Property TemperDegradePowerA = 0.0050 Auto Hidden
Int Property ArmorHitsPerHit = 1 Auto Hidden
Bool Property ArmorHitsPerHitRandomT = true Auto Hidden
Float Property WeaponDegrade = 0.0005 Auto Hidden
Float Property WeaponDegradePower = 0.0010 Auto Hidden
Float Property TimeDegradeFreq = 12.0 Auto Hidden
Float Property TimeDegradeDamage = 0.005 Auto Hidden
Bool Property TimeDegradeDurDecT = true Auto Hidden

Bool Property ComplexDegradationT = true Auto Hidden
Float Property VulnerabilityMultDagger = 1.5 Auto Hidden
Float Property VulnerabilityMultSword = 2.0 Auto Hidden
Float Property VulnerabilityMultGreatsword = 3.0 Auto Hidden
Float Property VulnerabilityMultAxe = 2.0 Auto Hidden
Float Property VulnerabilityMultBattleAxe = 3.0 Auto Hidden
Float Property ExtraDamageChanceAxe = 30.0 Auto Hidden
Float Property VulnerabilityMultMace = 2.0 Auto Hidden
Float Property VulnerabilityMultWarhammer = 3.0 Auto Hidden
Float Property VulnerabilityMultFire = 2.5 Auto Hidden
Float Property VulnerabilityMultIce = 2.5 Auto Hidden
Float Property VulnerabilityMultLightning = 2.5 Auto Hidden
Float Property VulnerabilityShoutOne = 3.0 Auto Hidden
Float Property VulnerabilityShoutTwo = 5.0 Auto Hidden
Float Property VulnerabilityShoutThree = 10.0 Auto Hidden
Float Property ExtraDamageChanceLightning = 30.0 Auto Hidden
Float Property MagicDegradeCooldown = 0.2 Auto Hidden
Float Property CreatureVulnerability = 110.0 Auto Hidden

Float Property MagicArmorClothing = 50.0 Auto Hidden
Float Property MagicArmorArmor = 10.0 Auto Hidden
Float Property MagicArmorClothingDelta = 25.0 Auto Hidden
Float Property MagicArmorArmorDelta = 10.0 Auto Hidden
Float Property MagicArmorPattack = 50.0 Auto Hidden

Bool Property TemperingRefitT = false Auto Hidden
Int Property RepairCostMin = 25 Auto Hidden
Float Property RepairCostBase = 0.20 Auto Hidden
Float Property RepairCostEnchant = 0.20 Auto Hidden
Int Property DurRepairCostMin = 5 Auto Hidden
Float Property DurRepairCostBase = 0.05 Auto Hidden
Float Property DurRepairCostEnchant = 0.05 Auto Hidden

Int Property WeightAdjustCostMin = 25 Auto Hidden
Float Property WeightAdjustCostBase = 1.5 Auto Hidden
Float Property WeightAdjustCostEnchant = 1.25 Auto Hidden
Int Property GenderAdjustCostMin = 50 Auto Hidden
Float Property GenderAdjustCostBase = 1.75 Auto Hidden
Float Property GenderAdjustCostEnchant = 1.25 Auto Hidden

Float Property CursedChanceContainer = 5.0 Auto Hidden
Float Property CursedChanceCorpse = 5.0 Auto Hidden
Bool Property AllowDeviousCorsets = true Auto Hidden
Bool Property AllowDeviousHarnesses = true Auto Hidden
Bool Property AllowDeviousBelts = true Auto Hidden
Bool Property AllowDeviousBras = true Auto Hidden
Bool Property AllowDeviousPlugsAnal = true Auto Hidden
Bool Property AllowDeviousPlugsVag = true Auto Hidden
Bool Property AllowDeviousSuits = true Auto Hidden
Bool Property AllowDeviousHobble = true Auto Hidden
Bool Property AllowDeviousPetSuits = true Auto Hidden
Bool Property AllowDeviousStraitJackets = true Auto Hidden
Bool Property AllowDeviousBoots = true Auto Hidden
Bool Property AllowDeviousLegCuffs = true Auto Hidden
Bool Property AllowDeviousGloves = true Auto Hidden
Bool Property AllowDeviousMittens = true Auto Hidden
Bool Property AllowDeviousArmCuffs = true Auto Hidden
Bool Property AllowDeviousArmbinders = true Auto Hidden
Bool Property AllowDeviousElbowBinders = true Auto Hidden
Bool Property AllowDeviousYokes = true Auto Hidden
Bool Property AllowDeviousBreastYokes = true Auto Hidden
Bool Property AllowDeviousGags = true Auto Hidden
Bool Property AllowDeviousBlindfolds = true Auto Hidden
Bool Property AllowDeviousCollars = true Auto Hidden
Bool Property AllowDeviousNipples = true Auto Hidden
Bool Property AllowDeviousClit = true Auto Hidden

GlobalVariable Property _MWA_SanctCost Auto

Formlist Property _MWA_ImmuneList Auto

Actor Property PlayerRef Auto

Perk Property _MWA_FoodRemovalPerk Auto
Perk Property _MWA_LockpickRemovalPerk Auto

Quest Property _MWA_DialogueQuest Auto

_MWA_PlayerInventoryUtil Property InvUtil Auto
_MWA_DestructionTypes Property DestTypes Auto
_MWA_ArmorDestruction Property ArmorDes Auto
_MWA_DegradeOverTime Property DegradeOverTime Auto
_MWA_Utility Property Util Auto
_MWA_Main Property Main Auto
_MWA_Init Property Init Auto
_MWA_Api Property Api Auto

_MWA_InterfaceSexlab Property SexlabInterface Auto
_MWA_InterfaceDeviousDevices Property Devious Auto
