Scriptname _MWA_ObjectSearch extends ObjectReference  

Event OnTriggerEnter(ObjectReference akActionRef)
	If akActionRef == PlayerRef
		InTrigger += 1
		ClothesFound = false
		If Count != 0 && !PlayerRef.IsInCombat() ; Not first time in trigger
			If SearchObject
				If PlayerRef.GetItemCount(SearchObject) == 0
					If Menu.SearchBoxNotifyT
						Debug.Notification("I'm certain my " + SearchObject.GetDisplayName() + " is around here somewhere")
					EndIf
					If SearchObject.GetDistance(Self) > Menu.DroppedTeleportDistance
						SearchObject.MoveTo(Self, afZOffset = 64.0)
						Utility.WaitMenuMode(0.1)
						SearchObject.ApplyHavokImpulse(0.0, 0.0, -1.0, 0.1) ; Otherwise floats
					EndIf
				Else
					ClothesFound = true
					ShutdownTrigger()
				EndIf
			EndIf
		EndIf
		IsGlowing = false
		BeginGlow()
		
		Count += 1
		
		While PlayerRef.IsInCombat()
			Utility.Wait(2.0)
		EndWhile
		Timer = Menu.LostObjectSearchTime
		While Timer > 0 && InTrigger > 0 && !ClothesFound && Menu.MasterSwitchT
			Timer -=1
			If PlayerRef.IsInCombat() || SexlabInterface.GetIsAnimating(PlayerRef)
				Timer = Menu.LostObjectSearchTime
			Else
				If !IsGlowing
					BeginGlow()
				EndIf				
			EndIf
			Utility.Wait(1.0)
			If SearchObject
				If PlayerRef.GetItemCount(SearchObject) > 0
					ClothesFound = true
				EndIf
			Else
				ClothesFound = true
				ShutdownTrigger()
			EndIf
		EndWhile
		If SearchObject
			If InTrigger && Menu.MasterSwitchT && !ClothesFound
				ClothesFound = true
				PlayerRef.AddItem(SearchObject, 1, true)
				Debug.Notification("There's my " + SearchObject.GetDisplayName())
				ShutdownTrigger()
			EndIf
		Else
			InTrigger -= 1 ; SearchObject == None - Player changed cell while standing in search box
			Timer = Menu.LostObjectSearchTime
		EndIf
		If ClothesFound
			ShutdownTrigger()
		EndIf
	EndIf
EndEvent

Event OnTriggerLeave(ObjectReference akActionRef)
	If akActionRef == PlayerRef
		InTrigger -= 1
		StopGlow()
		If SearchObject
			If PlayerRef.GetItemCount(SearchObject) > 0
				ClothesFound = true
				ShutdownTrigger()
			EndIf
		Else
			ClothesFound = true
			ShutdownTrigger()
		EndIf
		If !ClothesFound && !PlayerRef.IsInCombat()
			If Menu.SearchBoxNotifyT
				Debug.Notification(SearchObject.GetDisplayName() + " isn't worth the trouble")
			EndIf
			Timer = Menu.LostObjectSearchTime
		EndIf
	EndIf
EndEvent

Function BeginGlow()
	If Menu.ObjectSearchVisionType > 0
		If !PlayerRef.IsInCombat() && SearchObject != None	
			Form akBaseObject = SearchObject.GetBaseObject()
			If Aura != None
				Aura.Disable()
				Aura.Delete()
			EndIf
			IsGlowing = true
			If akBaseObject as Armor
				_MWA_VisionArmor.Play(SearchObject)
				If Menu.ObjectSearchVisionType == 2
					Aura = SearchObject.PlaceAtMe(_MWA_Ed_AuraArmor)
					Aura.MoveTo(SearchObject, afZOffset = 24)
				EndIf
			Else
				_MWA_VisionWeapon.Play(SearchObject)
				If Menu.ObjectSearchVisionType == 2
					Aura = SearchObject.PlaceAtMe(_MWA_Ed_AuraWeapon)
					Aura.MoveTo(SearchObject, afZOffset = 24)
				EndIf
			EndIf
			If Menu.ObjectSearchVisionType == 2
				RegisterForSingleUpdate(2.0)
			EndIf
		EndIf
	EndIf
EndFunction

Function StopGlow()
	UnRegisterForUpdate()
	If SearchObject != None
		Form akBaseObject = SearchObject.GetBaseObject()
		If Aura != None
			Aura.Disable()
			Aura.Delete()
		EndIf
		If akBaseObject as Armor
			_MWA_VisionArmor.Stop(SearchObject)
		Else
			_MWA_VisionWeapon.Stop(SearchObject)
		EndIf
	EndIf
EndFunction

Event OnUpdate() ; Check if object is falling or sliding, if so move aura
	If SearchObject != None && Aura != None
		If SearchObject.GetDistance(Aura) > 50.0
			Aura.MoveTo(SearchObject, afZOffset = 24)
			RegisterForSingleUpdate(1.0)
		EndIf
	Else
		UnRegisterForUpdate()
	EndIf
EndEvent

Function ShutdownTrigger()
	StopGlow()
	SearchObject = None
	Self.MoveTo(_MWA_SearchBoxDumpMarker)
	Self.Disable()
EndFunction

Function InitTrigger(ObjectReference ObjRef)
	ShutdownTrigger()
	SearchObject = ObjRef
	Count = 0
	InTrigger = 0
	ClothesFound = false
	Self.MoveTo(PlayerRef)
	Self.Enable()
EndFunction

_MWA_Mcm Property Menu Auto
_MWA_InterfaceSexlab Property SexlabInterface Auto

Actor Property PlayerRef Auto

ObjectReference Property _MWA_SearchBoxDumpMarker Auto

EffectShader Property _MWA_VisionArmor Auto
EffectShader Property _MWA_VisionWeapon Auto

Activator Property _MWA_Ed_AuraArmor Auto
Activator Property _MWA_Ed_AuraWeapon Auto

ObjectReference SearchObject
ObjectReference Aura

Bool IsGlowing = false
Bool ClothesFound = false
Int Timer
Int InTrigger = 0
Int Count = 0