Scriptname _MWA_PlayerInventoryTrackAdded extends ReferenceAlias  

_MWA_PlayerInventoryUtil Property InvUtil Auto
_MWA_DestructionTypes Property DestTypes Auto
_MWA_SanityChecker Property SanityChecker Auto
_MWA_Utility Property Util Auto

Quest Property _MWA_PlayerInventoryAliases Auto
Actor Property PlayerRef Auto

Event OnInit()
	
EndEvent

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	If (akBaseItem as Armor || akBaseItem as Weapon) ; Is Armor or Weapon
		If DestTypes.IsDestructible(akBaseItem)
			Debug.Trace("_MWA_: New: OnItemAdded: " + akBaseItem.GetName() + ". Ref: " + akItemReference)
			;Debug.Messagebox("_MWA_: New: OnItemAdded: " + akBaseItem.GetName() + ". Ref: " + akItemReference)
			If akItemReference == None || StringUtil.Find(akItemReference, "in container") != -1 ; Is not persistent
				; Get a reference
				InvUtil.RelayRefRequest(akBaseItem)
			Else
				
				Int AliasIndex = StorageUtil.GetIntValue(akItemReference, "_MWA_InvAliasIndex", missing = -1)
				If AliasIndex == -1
					;Debug.Trace("_MWA_: OnItemAdded ERROR for " + akBaseItem.GetName())
					;InvUtil.RelayRefRequest(akBaseItem)
					While !InvUtil.MakePersistent(akItemReference, akBaseItem)
						Utility.WaitMenuMode(0.05)
					EndWhile
					
				Else
					((_MWA_PlayerInventoryAliases.GetNthAlias(AliasIndex) as ReferenceAlias) as _MWA_PlayerInvAlias).AddToContainer(PlayerRef) ; For. The. Love. Of. Fuck. Bethesda - http://forums.bethsoft.com/topic/1349382-event-in-script-attached-to-misc-item-only-firing-once/
				EndIf
				Utility.WaitMenuMode(1.0)
				If akBaseItem as Armor && PlayerRef.IsEquipped(akBaseItem)
					;Debug.Trace("_MWA_: FFFFFSSSSSSSSSSS!!!!!!: akItemReference: " + akItemReference)
					If SanityChecker.IsObjRefEquipped(akBaseItem, akItemReference)
						;While !StorageUtil.HasFloatValue(akItemReference, "_MWA_ArmorFit")
						;	Utility.WaitMenuMode(0.5)
						;	Debug.Trace("_MWA_: fit looping")
						;EndWhile
						If !Util.IsSuitable(akItemReference, akBaseItem)
							PlayerRef.UnequipItem(akBaseItem, abPreventEquip = false,abSilent = true)
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
EndEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	If (akBaseItem as Armor || akBaseItem as Weapon) && !Util.HasNoStripKeyword(akBaseItem) ; Is Armor or Weapon
		If akItemReference != None || StringUtil.Find(akItemReference, "in container") == -1 ; Is not persistent
			Int AliasIndex = StorageUtil.GetIntValue(akItemReference, "_MWA_InvAliasIndex", missing = -1)
			If AliasIndex != -1
				((_MWA_PlayerInventoryAliases.GetNthAlias(AliasIndex) as ReferenceAlias) as _MWA_PlayerInvAlias).AddToContainer(akDestContainer)
			EndIf
		EndIf
	EndIf
EndEvent

State Paused
	Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	
	EndEvent
	
	Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	
	EndEvent
EndState

Function PauseTracking()
	GoToState("Paused")
EndFunction

Function ResumeTracking()
	GoToState("")
EndFunction


;/
Event OnObjectEquipped(Form akBaseObject, ObjectReference akReference)
	If !akBaseObject.HasKeyword(SexlabNoStrip)
		If akReference == None || StringUtil.Find(akReference, "in container") != -1
			Debug.Messagebox(akBaseObject.GetName() + " does not have a reference")
		Else
			Debug.notification("Ref ok for " + akBaseObject.GetName())
		EndIf
	EndIf
EndEvent
/;