Scriptname _MWA_PlayerInventoryTrackRemoved extends ReferenceAlias  

_MWA_PlayerInventoryUtil Property InventoryUtil Auto
_MWA_Utility Property Util Auto

Actor Property PlayerRef Auto
Formlist Property _MWA_EmptyFormlist Auto

ObjectReference WhatIDropped

Int AliasCounter = 0

Event OnInit()
	AddInventoryEventFilter(_MWA_EmptyFormlist)
EndEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	akItemReference.Disable()
	If StorageUtil.FormListFind(akBaseItem, "_MWA_Inv_ObjRefs", akItemReference) == -1
		StorageUtil.FormListAdd(akBaseItem, "_MWA_Inv_ObjRefs", akItemReference)
		While !InventoryUtil.MakePersistent(akItemReference, akBaseItem)
			Debug.Trace("_MWA_: New: LOOPING LIKE A MOFO")
		EndWhile
		;InventoryUtil.PrintBlockUsage()
		
	EndIf
	;If PlayerRef.GetItemCount(akBaseItem) == 0
	If StorageUtil.GetIntValue(akBaseItem, "_MWA_MakePersistMultipleProc") == 1
		StorageUtil.UnSetIntValue(akBaseItem, "_MWA_MakePersistMultipleProc")
		RemoveInventoryEventFilter(akBaseItem)
		
		; Pick up
		ObjectReference ObjRef
		Int i = StorageUtil.FormListCount(akBaseItem, "_MWA_Inv_ObjRefs")
		While i > 0
			i -= 1
			ObjRef = StorageUtil.FormListGet(akBaseItem, "_MWA_Inv_ObjRefs", i) as ObjectReference
			If ObjRef != None
				Int Timer = 30
				While !StorageUtil.HasIntValue(ObjRef, "_MWA_Durability") && Timer > 0; Wait for object durability & fit to be set before adding back to inventory, otherwise weirdness
					Debug.Trace("_MWA_: Waiting on fit. ItemCount: " + PlayerRef.GetItemCount(akBaseItem))
					Utility.WaitMenuMode(0.2)
					Timer -= 1
				EndWhile
				ObjRef.Enable()
				Debug.Trace("_MWA_: AddItem: " + ObjRef)
				PlayerRef.AddItem(ObjRef, abSilent = true)
			Else
				StorageUtil.FormListRemoveAt(akBaseItem, "_MWA_Inv_ObjRefs", i)
			EndIf
		EndWhile
		_MWA_PlayerInvInProc.RemoveAddedForm(akBaseItem)
		
		;Utility.Wait(5)
		If StorageUtil.GetIntValue(akBaseItem, "_MWA_GetObjectRefWasEquipped") > 0
			StorageUtil.UnSetIntValue(akBaseItem, "_MWA_GetObjectRefWasEquipped")
			If Util.IsSuitable(ObjRef, akBaseItem)
				PlayerRef.EquipItemEx(akBaseItem)
			EndIf
		EndIf
	Else
		StorageUtil.AdjustIntValue(akBaseItem, "_MWA_MakePersistMultipleProc", -1)
	EndIf
EndEvent

State Paused
	Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	
	EndEvent
EndState

Formlist Property _MWA_PlayerInvInProc Auto
Bool Function GetObjectRef(Form akBaseItem)
	If !_MWA_PlayerInvInProc.HasForm(akBaseItem)
		_MWA_PlayerInvInProc.AddForm(akBaseItem)
		Int i = PlayerRef.GetItemCount(akBaseItem)
		;If i > 1
			StorageUtil.SetIntValue(akBaseItem, "_MWA_MakePersistMultipleProc", i)
		;EndIf
		If PlayerRef.IsEquipped(akBaseItem)
			StorageUtil.SetIntValue(akBaseItem, "_MWA_GetObjectRefWasEquipped", 1)
		EndIf
		AddInventoryEventFilter(akBaseItem)
		While PlayerRef.GetItemCount(akBaseItem) > 0
			Debug.Trace("_MWA_: Dropping " + akBaseItem)
			WhatIDropped = PlayerRef.DropObject(akBaseItem)
			;WhatIDropped.Disable()
			;Debug.Trace("_MWA_: New: WhatIDropped: " + WhatIDropped + ". Base: " + akBaseItem)
			;i -= 1
		EndWhile
		_MWA_PlayerInvInProc.RemoveAddedForm(akBaseItem)
		Return true
		
	Else
		Debug.Trace("_MWA_: New: GetObjectRef is too busy to proc: " + akBaseItem.GetName() + " - Waiting")
		Utility.WaitMenuMode(0.05)
		Return false
	EndIf
EndFunction

Function PauseTracking()
	GoToState("Paused")
EndFunction

Function ResumeTracking()
	GoToState("")
EndFunction
