Scriptname _MWA_SanityChecker extends Quest  

; Script to stop jumbled/out of order equip/unequip events from corrupting the wornlist

_MWA_Init Property Init Auto
_MWA_Utility Property Util Auto
_MWA_ArmorDestruction Property ArmorDest Auto
_MWA_DestructionTypes Property DestructTypes Auto

Int[] Property SlotMasks Auto Hidden
ObjectReference[] Property WornList Auto Hidden

Actor Property PlayerRef Auto

Quest Property _MWA_PlayerInventoryAliases Auto

Bool Property WornListUpdateInProgress = false Auto Hidden
Bool EventRecieved = false

Event OnInit()
	SetupArrays()
EndEvent

; NEEDS review vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
Function PlayerLoadsGame()
	;RegisterForKey(21)
	UnRegisterForAllKeys()
EndFunction

Event OnKeyDown(Int KeyCode)
	Int i = 0
	Int AliasCount
	Form akArmor
	;Debug.Trace("_MWA_: SLOTS ACTUAL: =================================================================")
	While i < SlotMasks.Length
		
			akArmor = PlayerRef.GetWornForm(SlotMasks[i])
			If akArmor != None
				AliasCount = WornObject.GetNumReferenceAliases(PlayerRef, 0, SlotMasks[(i)])
				;Debug.Trace("_MWA_: Slot " + (i+30) + ") " + akArmor.GetName() + " - " + akArmor + ". AliasCount = " + AliasCount + ". WornObject.GetDisplayName: " + WornObject.GetDisplayName(PlayerRef, 0, SlotMasks[(i)]) + ". SlotMask: " + SlotMasks[(i)] + " = slot " + (i+30))
				While AliasCount > 0
					AliasCount -= 1
					;Debug.Trace("_MWA_: OwningQuest: " + WornObject.GetNthReferenceAlias(PlayerRef, 0, SlotMasks[(i)], AliasCount).GetOwningQuest())
				EndWhile
				;Debug.Trace("_MWA_: Slot " + (i+30) + " = " + (WornObject.GetNthReferenceAlias(PlayerRef, 0, (i+31), 0) as ReferenceAlias).GetReference())
			EndIf
			i += 1
	EndWhile
	;Debug.Trace("_MWA_: Wornlist: =================================================================")
	i = 0
	ObjectReference ObjRef
	While i < WornList.Length
		ObjRef = WornList[i]
		If ObjRef != None
			akArmor = ObjRef.GetBaseObject()
			AliasCount = WornList[i].GetNumReferenceAliases()
			;Debug.Trace("_MWA_: Slot " + (i+30) + ") " + akArmor.GetName() + " - " + akArmor + ". AliasCount = " + AliasCount)
		EndIf
		i += 1
	EndWhile
EndEvent

; NEEDS review ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

Function SetupArrays()
	SetupSlotMasks()
	WornList = new ObjectReference[34] ; i + 30 = Armor slot mask. WornList[32] = Left hand weapon. WornList[33] = Right hand weapon. 
EndFunction

Function SetupSlotMasks()
	SlotMasks = new Int[32]
	SlotMasks[0] = 1 ; kSlotMask30
	SlotMasks[1] = 2 ; kSlotMask31
	SlotMasks[2] = 4 ; kSlotMask32
	SlotMasks[3] = 8 ; kSlotMask33
	SlotMasks[4] = 16 ; kSlotMask34
	SlotMasks[5] = 32 ; kSlotMask35
	SlotMasks[6] = 64 ; kSlotMask36
	SlotMasks[7] = 128 ; kSlotMask37
	SlotMasks[8] = 256 ; kSlotMask38
	;SlotMasks[9] = 512 ; kSlotMask39 ; Process shield slot separately
	SlotMasks[10] = 1024 ; kSlotMask40
	SlotMasks[11] = 2048 ; kSlotMask41
	SlotMasks[12] = 4096 ; kSlotMask42
	SlotMasks[13] = 8192 ; kSlotMask43
	SlotMasks[14] = 16384 ; kSlotMask44
	SlotMasks[15] = 32768 ; kSlotMask45
	SlotMasks[16] = 65536 ; kSlotMask46
	SlotMasks[17] = 131072 ; kSlotMask47
	SlotMasks[18] = 262144 ; kSlotMask48
	SlotMasks[19] = 524288 ; kSlotMask49
	SlotMasks[20] = 1048576 ; kSlotMask50
	SlotMasks[21] = 2097152 ; kSlotMask51
	SlotMasks[22] = 4194304 ; kSlotMask52
	SlotMasks[23] = 8388608 ; kSlotMask53
	SlotMasks[24] = 16777216 ; kSlotMask54
	SlotMasks[25] = 33554432 ; kSlotMask55
	SlotMasks[26] = 67108864 ; kSlotMask56
	SlotMasks[27] = 134217728 ; kSlotMask57
	SlotMasks[28] = 268435456 ; kSlotMask58
	SlotMasks[29] = 536870912 ; kSlotMask59
	SlotMasks[30] = 1073741824 ; kSlotMask60
	SlotMasks[31] = 2147483648 ; kSlotMask61
EndFunction

Function CheckAllSlots() ; Checks every slot and adds the Equipped ObjRef to the wornlist if missing
	Int i = SlotMasks.Length
	ReferenceAlias AliasSelect
	ObjectReference ObjRef
	Form akBaseObject

	; Weapons
	AliasSelect = WornObject.GetNthReferenceAlias(PlayerRef, 1, 0, 0) as ReferenceAlias
	If AliasSelect
		ObjRef = AliasSelect.GetReference()
		If ObjRef
			If DestructTypes.IsDestructible(akBaseObject)
				ArmorDest.RightWeapon = ObjRef
			Else
				ArmorDest.RightWeapon = None
			EndIf
		Else
			ArmorDest.RightWeapon = None
		EndIf
	EndIf
	AliasSelect = WornObject.GetNthReferenceAlias(PlayerRef, 0, 0, 0) as ReferenceAlias
	If AliasSelect
		ObjRef = AliasSelect.GetReference()
		If ObjRef
			If DestructTypes.IsDestructible(akBaseObject)
				ArmorDest.LeftWeapon = ObjRef
			Else
				ArmorDest.LeftWeapon = None
			EndIf
		Else
			ArmorDest.LeftWeapon = None
		EndIf
	EndIf
	
	; Shield
	AliasSelect = WornObject.GetNthReferenceAlias(PlayerRef, 0, 512, 0) as ReferenceAlias
	If AliasSelect
		ObjRef = AliasSelect.GetReference()
		If ObjRef
			If DestructTypes.IsDestructible(ObjRef.GetBaseObject())
				ArmorDest.EquippedShield = ObjRef
				Util.WornListAdd(ObjRef, "CheckAllSlots()")
			Else
				ArmorDest.EquippedShield = None
			EndIf
		Else
			ArmorDest.EquippedShield = None
		EndIf
	EndIf
	
	; Armors
	While i > 0
		i -= 1
		AliasSelect = WornObject.GetNthReferenceAlias(PlayerRef, 0, SlotMasks[i], 0) as ReferenceAlias
		If AliasSelect
			ObjRef = AliasSelect.GetReference()
			If ObjRef
				If DestructTypes.IsDestructible(ObjRef.GetBaseObject())
					;If i == 9
					;	ArmorDest.EquippedShield = ObjRef
					;EndIf
					Util.WornListAdd(ObjRef, "CheckAllSlots()")
				EndIf
			EndIf
		EndIf
	EndWhile
EndFunction

Event OnUpdate()
	If GetState() == ""
		;Debug.MessageBox("Beginning cleanup")
		Util.CheckWornList()
		CheckAllSlots()
		;Debug.MessageBox("Finished cleanup")
	Else
		RegisterForSingleUpdate(2.0)
	EndIf
EndEvent

Event OnBeginState()
    ;Debug.Trace("_MWA_: Sanity: Entered EMPTY state")
EndEvent

Function BeginSanityCheck(ObjectReference ObjRef)
	GoToState("Queueing")
	WornListUpdateInProgress = true	; pause degradation
	AddToSanityCheck(ObjRef)
	Sanitize()
EndFunction

State Queueing
	Event OnBeginState()
		;Debug.Trace("_MWA_: Sanity: Entered QUEUING state")
	EndEvent

	Function BeginSanityCheck(ObjectReference ObjRef)
		EventRecieved = true
		AddToSanityCheck(ObjRef)
	EndFunction
EndState

State Updating
	Event OnBeginState()
		;Debug.Trace("_MWA_: Sanity: Entered UPDATING state")
	EndEvent
	
	Function BeginSanityCheck(ObjectReference ObjRef)
		AddToSanityCheckQueue(ObjRef)
	EndFunction
EndState

Function Sanitize()
	While EventRecieved ; While Equip/Unequip events keep firing, wait.
		EventRecieved = false
		Utility.Wait(0.2)
	EndWhile
	GoToState("Updating")
	UpdateWornList()
EndFunction

Function AddToSanityCheck(ObjectReference ObjRef)
	StorageUtil.FormListAdd(Self, "_MWA_SanityCheckList", ObjRef, allowDuplicate = false)
EndFunction

Function AddToSanityCheckQueue(ObjectReference ObjRef)
	StorageUtil.FormListAdd(Self, "_MWA_SanityCheckListQueue", ObjRef, allowDuplicate = false)
EndFunction

Function UpdateWornList()
	ObjectReference ObjRef
	Form akBaseObject
	Int i = StorageUtil.FormListCount(Self, "_MWA_SanityCheckList")
	While i > 0
		i -= 1
		ObjRef = StorageUtil.FormListGet(Self, "_MWA_SanityCheckList", i) as ObjectReference
		akBaseObject = ObjRef.GetBaseObject()
		If IsObjRefEquipped(akBaseObject, ObjRef)
			ListObjRef(akBaseObject, ObjRef)
		Else
			UnListObjRef(akBaseObject, ObjRef)
		EndIf
	EndWhile
	StorageUtil.FormListClear(Self, "_MWA_SanityCheckList")
	RegisterForSingleUpdate(2.0)
	
	; Check if additional ObjRefs have been queued during update and begin another update if needed
	If StorageUtil.FormListCount(self, "_MWA_SanityCheckListQueue") > 0
	
		GoToState("Queueing")
		AddQueuedObjects()

	Else ; Nothing left to do, reset state
		WornListUpdateInProgress = false
		GoToState("")
	EndIf
EndFunction

Function AddQueuedObjects()
	ObjectReference ObjRef
	Int i = StorageUtil.FormListCount(self, "_MWA_SanityCheckListQueue")
	While i > 0
		i -= 1
		ObjRef = StorageUtil.FormListGet(Self, "_MWA_SanityCheckListQueue", i) as ObjectReference ; casting necessary?
		StorageUtil.FormListAdd(Self, "_MWA_SanityCheckList", ObjRef, allowDuplicate = false)
	EndWhile
	StorageUtil.FormListClear(Self, "_MWA_SanityCheckListQueue")
	Sanitize()
EndFunction

; ================================================================================================================================================================

Function ListObjRef(Form akBaseObject, ObjectReference ObjRef)
	
	;float ftimeStart = Utility.GetCurrentRealTime()
	;Debug.Trace("_MWA_: New: ListObjRef: BEGIN for " + akBaseObject.GetName() + ". Ref: " + ObjRef + "vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv")
	If akBaseObject as Armor
		Int i = 0
		Int Mask = (akBaseObject as Armor).GetSlotMask()
		;Debug.Trace("_MWA_: New: Mask = " + Mask)
		;Bool IsShield = false
		While Mask > 0 && i < SlotMasks.Length
			If Math.LogicalAnd(Mask, SlotMasks[i])
				Mask -= SlotMasks[i]
				WornList[i] = ObjRef
				If i == 9
					Util.SetShield(ObjRef, "ListObjRef()")
					;IsShield = true
				EndIf
				If i == 2
					SendEquippedCuirassEvent(akBaseObject, ObjRef)
				EndIf
				;Debug.Trace("_MWA_: New: ListObjRef: " + akBaseObject.GetName() + " fits slot " + (i + 30) + ". New Mask = " + Mask)
			EndIf
			i += 1
		EndWhile
		Util.WornListAdd(ObjRef, "ListObjRef()")
		
	Else ; Weapons
	
		If IsRightHandWeapon(akBaseObject, ObjRef, "ListObjRef")
			WornList[33] = ObjRef
			Util.SetRightWeapon(ObjRef, "ListObjRef()")
		ElseIf IsLeftHandWeapon(akBaseObject, ObjRef, "ListObjRef")
			WornList[32] = ObjRef
			Util.SetLeftWeapon(ObjRef, "ListObjRef()")
		Else
			Debug.Trace("_MWA_: Error: ListObjRef: Weapon not equipped: " + akBaseObject.GetName() + ". Ref: " + ObjRef)
		EndIf
	EndIf
	;Util.CheckWornList()
	;float ftimeEnd = Utility.GetCurrentRealTime()
	;Debug.Trace("_MWA_: New: ListObjRef: END. Duration: " + (ftimeEnd - ftimeStart) + " seconds. ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^")
EndFunction

Function UnListObjRef(Form akBaseObject, ObjectReference ObjRef)
	Int Index = WornList.Find(ObjRef)
	While Index > -1
		WornList[Index] = None
		If Index == 33
			Util.SetRightWeapon(none, "UnListObjRef()")
		ElseIf Index == 9
			Util.SetShield(none, "UnListObjRef()")
			Util.WornListRemove(ObjRef, "UnListObjRef()")
		ElseIf Index == 32
			Util.SetLeftWeapon(none, "UnListObjRef()")
		Else
			Util.WornListRemove(ObjRef, "UnListObjRef()")
		EndIf
		Index = WornList.Find(ObjRef)
	EndWhile
	;Util.CheckWornList()
EndFunction

Bool Function IsObjRefEquipped(Form akBaseObject, ObjectReference ObjRef)
	Bool Result = false
	;Debug.Trace("_MWA_: Sanity: IsObjRefEquipped: " + akBaseObject.GetName() + ". Ref: " + ObjRef)
	If akBaseObject as Armor
		
		
		
		If IsArmorEquipped(akBaseObject, ObjRef)
			;Debug.Trace("_MWA_: IsObjRefEquipped: TRUE for " + akBaseObject.GetName() + ". ObjRef: " + ObjRef)
			Result = true
			
		Else
			;Debug.Trace("_MWA_: IsObjRefEquipped: FALSE for " + akBaseObject.GetName() + ". ObjRef: " + ObjRef)
			Result = false
		EndIf
	
	Else ; Weapons

		; Get matching weapon, check right hand first - used more
		If IsRightHandWeapon(akBaseObject, ObjRef, "IsObjRefEquipped")
			;ListObjRef(akBaseObject, ObjRef)
			Result = true
		ElseIf IsLeftHandWeapon(akBaseObject, ObjRef, "IsObjRefEquipped")
			;ListObjRef(akBaseObject, ObjRef)
			Result = true
		Else
			Result = false
		EndIf
		
	EndIf
;/
	If Result
		ListObjRef(akBaseObject, ObjRef)
	Else
		UnListObjRef(akBaseObject, ObjRef)
	EndIf
	/;
	Return Result
EndFunction

Bool Function IsArmorEquipped(Form akBaseObject, ObjectReference ObjRef)
	Bool Result = false
	ReferenceAlias AliasSelect
	;While ObjRef != None && StorageUtil.GetIntValue(ObjRef, "_MWA_InvAliasIndex", -1) == -1
	;	Debug.Trace("_MWA_: IsArmorEquipped looping for " + akBaseObject.GetName() + ". Ref: " + ObjRef)
	;	Utility.Wait(0.1)
	;EndWhile
	
	Int SlotMask = (akBaseObject as Armor).GetSlotMask()
	;Debug.Trace("_MWA_: SLOTMASK for " + akBaseObject.GetName() + " = " + SlotMask)
	Int i = WornObject.GetNumReferenceAliases(PlayerRef, 0, SlotMask)
	;Debug.Trace("_MWA_: " + akBaseObject.GetName() + ". AliasCount: " + i)
	;Debug.Trace("_MWA_: IsArmorEquipped aliasIndex = " + StorageUtil.GetIntValue(ObjRef, "_MWA_InvAliasIndex" ) + ". Base: " + akBaseObject.GetName() + ". ObjRef: " + ObjRef + ". AliasCount: " + i + ". SlotMask: " + SlotMask + ". IsEquipped: " + PlayerRef.IsEquipped(akBaseObject))
	AliasSelect = WornObject.GetNthReferenceAlias(PlayerRef, 0, SlotMask, 0)
	If AliasSelect == None
		Result = false
	ElseIf AliasSelect.GetReference() == ObjRef
		Result = true
	Else
		Result = false
	EndIf
	
	; Failsafe - This is not great. The chances of names actually matching is low but still possible. But I'm out of options :/
	If !Result && PlayerRef.IsEquipped(akBaseObject) ; ObjRef was not detected but it's base form is equipped - double check for WornObject.GetNumReferenceAliases() not being reliable
		String WornObjectDisplayName = WornObject.GetDisplayName(PlayerRef, 0, SlotMask)
		String ObjRefDisplayName = ObjRef.GetDisplayName()
		;Debug.Trace("_MWA_: IsArmorEquipped. WornObjectDisplayName: " + WornObjectDisplayName + ". ObjRefDisplayName: " + ObjRefDisplayName)
		If WornObjectDisplayName == ObjRefDisplayName
			Result = true
		EndIf
	EndIf
	Return Result
EndFunction

Bool Function IsRightHandWeapon(Form akBaseObject, ObjectReference ObjRef, String CallingFunction)
	Bool Result = false
	ReferenceAlias AliasSelect
	;While ObjRef != None && StorageUtil.GetIntValue(ObjRef, "_MWA_InvAliasIndex", -1) == -1
	;	Debug.Trace("_MWA_: IsRightHandWeapon looping")
	;	Utility.Wait(0.1)
	;EndWhile
	Bool IsWeaponEquipped = (PlayerRef.GetEquippedWeapon() == akBaseObject) || (PlayerRef.GetEquippedWeapon(true) == akBaseObject)
	Int i = WornObject.GetNumReferenceAliases(PlayerRef, 1, 0)
	;If IsWeaponEquipped && i > 0 && ObjRef
		;Debug.Trace("_MWA_: IsRightHandWeapon: " + akBaseObject.GetName() + ". ObjRef: " + ObjRef + ". AliasCount: " + i + ". AliasContains: " + (WornObject.GetNthReferenceAlias(PlayerRef, 1, 0, 0)).GetReference() + ". IsEquipped: " + IsWeaponEquipped)
	;Else
		;Debug.Trace("_MWA_: IsRightHandWeapon: Is NOT equipped")
	;EndIf
	;Debug.MessageBox("Right hand - AliasCount: " + i)
	If i > 0
		While i > 0
			i -= 1
			AliasSelect = WornObject.GetNthReferenceAlias(PlayerRef, 1, 0, i)
			If AliasSelect.GetReference() == ObjRef
				;Debug.Messagebox("Is right Equipped")
				Result = true
			EndIf
		EndWhile
	EndIf
	
	;/
	If Result
		Debug.MessageBox(akBaseObject.GetName() + " is Right equipped. ObjRef: " + ObjRef + ". CallingFunction: " + CallingFunction)
	EndIf
	/;
	
	If !Result && IsWeaponEquipped
		String WornObjectDisplayName = WornObject.GetDisplayName(PlayerRef, 1, 0)
		String ObjRefDisplayName = ObjRef.GetDisplayName()
		;Debug.Trace("_MWA_: IsRightHandWeapon. WornObjectDisplayName: " + WornObjectDisplayName + ". ObjRefDisplayName: " + ObjRefDisplayName)
		If WornObjectDisplayName == ObjRefDisplayName
			Result = true
		EndIf
	EndIf
	Return Result
EndFunction

Bool Function IsLeftHandWeapon(Form akBaseObject, ObjectReference ObjRef, String CallingFunction)
	Bool Result = false
	ReferenceAlias AliasSelect
	;While ObjRef != None && StorageUtil.GetIntValue(ObjRef, "_MWA_InvAliasIndex", -1) == -1
	;	Debug.Trace("_MWA_: IsLeftHandWeapon looping")
	;	Utility.Wait(0.1)
	;EndWhile
	Bool IsWeaponEquipped = (PlayerRef.GetEquippedWeapon() == akBaseObject) || (PlayerRef.GetEquippedWeapon(true) == akBaseObject)
	Int i = WornObject.GetNumReferenceAliases(PlayerRef, 0, 0)
	;If IsWeaponEquipped && i > 0 && ObjRef
	;	Debug.Trace("_MWA_: IsLeftHandWeapon: " + akBaseObject.GetName() + ". ObjRef: " + ObjRef + ". AliasCount: " + i + ". AliasContains: " + (WornObject.GetNthReferenceAlias(PlayerRef, 0, 0, 0)).GetReference() + ". IsEquipped: " + IsWeaponEquipped)
	;Else
	;	Debug.Trace("_MWA_: IsLeftHandWeapon: Is NOT equipped")
	;EndIf
	;Debug.MessageBox("Left hand - AliasCount: " + i)
	If i > 0
		While i > 0
			i -= 1
			AliasSelect = WornObject.GetNthReferenceAlias(PlayerRef, 0, 0, i)
			If AliasSelect.GetReference() == ObjRef
				;Debug.Messagebox("Is left Equipped")
				Result = true
			EndIf
		EndWhile
	EndIf

;/
	If Result
		Debug.MessageBox(akBaseObject.GetName() + " is Left equipped. ObjRef: " + ObjRef + ". CallingFunction: " + CallingFunction)
	EndIf
/;
	
	If !Result && IsWeaponEquipped
		String WornObjectDisplayName = WornObject.GetDisplayName(PlayerRef, 0, 0)
		String ObjRefDisplayName = ObjRef.GetDisplayName()
		;Debug.Trace("_MWA_: IsLeftHandWeapon. WornObjectDisplayName: " + WornObjectDisplayName + ". ObjRefDisplayName: " + ObjRefDisplayName)
		If WornObjectDisplayName == ObjRefDisplayName
			Result = true
		EndIf
	EndIf
	Return Result
EndFunction

Function SendEquippedCuirassEvent(Form akBaseObject, ObjectReference ObjRef)
	Int CuirassEquipEvent = ModEvent.Create("_MWA_CuirassEquipEvent")
	If (CuirassEquipEvent)
		ModEvent.PushForm(CuirassEquipEvent, akBaseObject)
		ModEvent.PushForm(CuirassEquipEvent, ObjRef)
		ModEvent.Send(CuirassEquipEvent)
	EndIf
EndFunction

ObjectReference Function GetObjRefInSlot(Int Slot)
	Return WornList[(Slot - 30)]
EndFunction
