Scriptname _MWA_ScanContainersAlias extends ReferenceAlias  

Event OnInit()
	GoToState("")
	If Menu.RemoveFoodCANs > 0.0
		GoToState("ObjectsAndFood")
	EndIf
	DoScan()
EndEvent

Function DoScan()
	ObjectReference ContainerRef = Self.GetReference()
	If ContainerRef
		ContainerRef.AddItem(_MWA_DegradedToken)			
		Int i = ContainerRef.GetNumItems()
		If i < Menu.ContainerScanMaxItems
			;ActorBase Owner
			Form kForm
			ObjectReference DroppedObj
			ReferenceAlias AliasSelect
			
			;Debug.Trace("_MWA_: ContainerScan: starting on " + ContainerRef.GetName() + " - " + ContainerRef + ". NumItems: " + i)
			While i > 0
				i -= 1
				kForm = ContainerRef.GetNthForm(i)
				If DestTypes.IsDestructible(kForm)
					While ContainerRef.GetItemCount(kForm) > 0
						Debug.Trace("_MWA_: Dropping: " + kForm)
						DroppedObj = ContainerRef.DropObject(kForm)
						If DroppedObj != None
							DroppedObj.Disable()
							;Owner = DroppedObj.GetActorOwner()
							;Owner = GetInheritedOwner(DroppedObj, Self.GetReference())
							;Debug.Trace("_MWA_: Owner: " + Owner)
							
							AliasSelect = (_MWA_AliasesContainers.GetNthAlias(Util.ContainerObjectAliasIndex) as ReferenceAlias).ForceRefTo(DroppedObj)
							Util.ContainerObjectAliasIndex += 1
							If Util.ContainerObjectAliasIndex >= _MWA_AliasesContainers.GetNumAliases() ; Reset index counter
								Util.ContainerObjectAliasIndex = 0
							EndIf
							String Name = Util.GetDynamicName(DroppedObj, "_MWA_ScanContainersAlias")
							DroppedObj.SetDisplayName(Name)
							If StorageUtil.GetIntValue(DroppedObj, "_MWA_IsCursedObject", Missing = -1) < 0 && Menu.CursedChanceContainer > Utility.RandomFloat(0.0, 100.0)
								StorageUtil.SetIntValue(DroppedObj, "_MWA_IsCursedObject", 1)
								Util.FitToPlayer(DroppedObj, kForm, FitLoosely = true)
								;FitToActor(ObjectReference ObjRef, Actor SrcActor, Form akBaseObject, ActorBase SrcActorBase = None, Bool FitLoosely = false)
							Else
								StorageUtil.SetIntValue(DroppedObj, "_MWA_IsCursedObject", 0)
								Util.FitToRandom(DroppedObj, kForm)
							EndIf
							;If Owner
							;	Util.FitToActor(DroppedObj, None, kForm, Owner)
							;Else
								;Util.FitToRandom(DroppedObj, kForm)
							;EndIf
							Util.GetDurability(DroppedObj, kForm, ForceUpdate = false, IsWorn = true)
							DroppedObj.SetActorOwner(None)
							StorageUtil.FormListAdd(ContainerRef, "_MWA_ContainerScan", DroppedObj)
						EndIf
					EndWhile
					Int j = StorageUtil.FormListCount(ContainerRef, "_MWA_ContainerScan")
					While j > 0
						j -= 1
						DroppedObj = StorageUtil.FormListGet(ContainerRef, "_MWA_ContainerScan", j) as ObjectReference
						ContainerRef.AddItem(DroppedObj)
						DroppedObj.Enable()
					EndWhile
					StorageUtil.FormListClear(ContainerRef, "_MWA_ContainerScan")
				EndIf
			EndWhile
		;Else
		;	Debug.Trace("_MWA_: ContainerScan: Not scanning. Considered as shop container - Too many objects: " + i + ". " + ContainerRef.GetName() + " - " + ContainerRef)
		EndIf
	EndIf
EndFunction

State ObjectsAndFood
	Function DoScan()
		ObjectReference ContainerRef = Self.GetReference()
		If ContainerRef
			ContainerRef.AddItem(_MWA_DegradedToken)			
			Int i = ContainerRef.GetNumItems()
			If i < Menu.ContainerScanMaxItems
				;ActorBase Owner
				Form kForm
				ObjectReference DroppedObj
				ReferenceAlias AliasSelect
				
				;Debug.Trace("_MWA_: ContainerScan: starting on " + ContainerRef.GetName() + " - " + ContainerRef + ". NumItems: " + i)
				While i > 0
					i -= 1
					kForm = ContainerRef.GetNthForm(i)
					If DestTypes.IsDestructible(kForm)
						While ContainerRef.GetItemCount(kForm) > 0
							Debug.Trace("_MWA_: Dropping: " + kForm)
							DroppedObj = ContainerRef.DropObject(kForm)
							If DroppedObj != None
								DroppedObj.Disable()
								;Owner = DroppedObj.GetActorOwner()
								;Owner = GetInheritedOwner(DroppedObj, Self.GetReference())
								;Debug.Trace("_MWA_: Owner: " + Owner)
								
								AliasSelect = (_MWA_AliasesContainers.GetNthAlias(Util.ContainerObjectAliasIndex) as ReferenceAlias).ForceRefTo(DroppedObj)
								Util.ContainerObjectAliasIndex += 1
								If Util.ContainerObjectAliasIndex >= _MWA_AliasesContainers.GetNumAliases() ; Reset index counter
									Util.ContainerObjectAliasIndex = 0
								EndIf
								String Name = Util.GetDynamicName(DroppedObj, "_MWA_ScanContainersAlias")
								DroppedObj.SetDisplayName(Name)
								If StorageUtil.GetIntValue(DroppedObj, "_MWA_IsCursedObject", Missing = -1) < 0 && Menu.CursedChanceContainer > Utility.RandomFloat(0.0, 100.0)
									StorageUtil.SetIntValue(DroppedObj, "_MWA_IsCursedObject", 1)
									Util.FitToPlayer(DroppedObj, kForm, FitLoosely = true)
									;FitToActor(ObjectReference ObjRef, Actor SrcActor, Form akBaseObject, ActorBase SrcActorBase = None, Bool FitLoosely = false)
								Else
									Util.FitToRandom(DroppedObj, kForm)
								EndIf
								;If Owner
								;	Util.FitToActor(DroppedObj, None, kForm, Owner)
								;Else
									;Util.FitToRandom(DroppedObj, kForm)
								;EndIf
								Util.GetDurability(DroppedObj, kForm, ForceUpdate = false, IsWorn = true)
								DroppedObj.SetActorOwner(None)
								StorageUtil.FormListAdd(ContainerRef, "_MWA_ContainerScan", DroppedObj)
							EndIf
						EndWhile
						Int j = StorageUtil.FormListCount(ContainerRef, "_MWA_ContainerScan")
						While j > 0
							j -= 1
							DroppedObj = StorageUtil.FormListGet(ContainerRef, "_MWA_ContainerScan", j) as ObjectReference
							ContainerRef.AddItem(DroppedObj)
							DroppedObj.Enable()
						EndWhile
						StorageUtil.FormListClear(ContainerRef, "_MWA_ContainerScan")
						
					ElseIf kForm as Potion && (kForm.HasKeyword(VendorItemFood) || kForm.HasKeyword(VendorItemFoodRaw))
						If Menu.RemoveFoodCANs >= Utility.RandomFloat(0.0, 100.0)
							ContainerRef.RemoveItem(kForm, ContainerRef.GetItemCount(kForm))
						EndIf
					EndIf
				EndWhile
			;Else
			;	Debug.Trace("_MWA_: ContainerScan: Not scanning. Considered as shop container - Too many objects: " + i + ". " + ContainerRef.GetName() + " - " + ContainerRef)
			EndIf
		EndIf
	EndFunction
EndState

ActorBase Function GetInheritedOwner(ObjectReference aObj, ObjectReference aContainer)
	ActorBase actorOwner
 
	; if the object exists
	; try to get the object's explicit owner
	If aObj
		actorOwner = aObj.GetActorOwner()
 
		; if the object does not have an explicit owner
		; and if the container exists
		; try to get the container's explicit owner
		If !actorOwner
			If aContainer
				actorOwner = aContainer.GetActorOwner()
 
				; but if the container also does not have an explicit owner
				; try to get the parent cell of the container's explicit owner
				If !actorOwner
					actorOwner = aContainer.GetParentCell().GetActorOwner()
				EndIf
			EndIf
 
			; if even the parent cell of the container does not have an explicit owner
			; try one last time to get the parent cell of the object's explicit owner
			If !actorOwner
				actorOwner = aObj.GetParentCell().GetActorOwner()
			EndIf
		EndIf
	EndIf
 
	; returns an explicit owner, inherited owner, or none
	Return actorOwner
EndFunction

Quest Property _MWA_AliasesContainers Auto

Armor Property _MWA_DegradedToken Auto

Keyword Property VendorItemFood Auto
Keyword Property VendorItemFoodRaw Auto

_MWA_Utility Property Util Auto
_MWA_DestructionTypes Property DestTypes Auto
_MWA_Mcm Property Menu Auto
