Scriptname _MWA_SurvivalFitTrackAlias extends ReferenceAlias  

Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	CheckObject(akBaseItem)
EndEvent

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	CheckObject(akBaseItem)
EndEvent

;/
State InProc
	Event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
		
	EndEvent

	Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)

	EndEvent
EndState
/;

Function CheckObject(Form akBaseItem)
	If akBaseItem as Armor
		If Math.LogicalAnd((akBaseItem as Armor).GetSlotMask(), 4) == 4
			AddInventoryEventFilter(_MWA_NeverAddedItem)
			DoInvCheck()
			RemoveAllInventoryEventFilters()
		EndIf
	EndIf
EndFunction

Function DoInvCheck()
	Int i = _MWA_PlayerInventoryAliases.GetNumAliases()
	ObjectReference ObjRef
	Armor ArmorObj
	Int FittingArmorCount = 0
	While i > 0
		i -= 1
		ObjRef = (_MWA_PlayerInventoryAliases.GetNthAlias(i) as ReferenceAlias).GetReference()
		If ObjRef
			ArmorObj = ObjRef.GetBaseObject() as Armor
			If ArmorObj
				If Math.LogicalAnd(ArmorObj.GetSlotMask(), 4) == 4
					If PlayerRef.GetItemCount(ObjRef)
						If Util.IsSuitable(ObjRef, ArmorObj, abSilent = true)
							FittingArmorCount += 1
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	EndWhile
	_MWA_FittingArmorCount.SetValueInt(FittingArmorCount)
	;Debug.Messagebox("FittingArmorCount: " + FittingArmorCount)
EndFunction

Actor Property PlayerRef Auto

Quest Property _MWA_PlayerInventoryAliases Auto

GlobalVariable Property _MWA_FittingArmorCount Auto

MiscObject Property _MWA_NeverAddedItem Auto

_MWA_Utility Property Util Auto
