Scriptname _MWA_Tempering extends ReferenceAlias  

; How much simplier this would have been if OnStoryCraftItem actually worked and didn't crash the game...............................!

Int FurnitureUsed = 0 ; 0 - Don't care, 1 - workbench, 2 - grindstone
Bool DidTemper = false

Event OnSit(ObjectReference akFurniture)
	FurnitureUsed = 0
	PlayerRef.AddSpell(_MWA_FurnitureDetect, false)
	If PlayerRef.HasMagicEffect(_MWA_IsInGrindstone)
		FurnitureUsed = 2
	ElseIf PlayerRef.HasMagicEffect(_MWA_IsInWorkbench)
		FurnitureUsed = 1
	EndIf
	If FurnitureUsed > 0
		RemoveAllInventoryEventFilters()
		GoToState("TrackCraft")
	EndIf
EndEvent

Event OnGetUp(ObjectReference akFurniture)
	If DidTemper && FurnitureUsed != 0
		PlayerRef.RemoveSpell(_MWA_FurnitureDetect)

		ObjectReference ObjRef
		Form akBaseObject
		Int i = 0
		While i < SanityChecker.WornList.Length
			ObjRef = SanityChecker.WornList[i]
			If Objref
				akBaseObject = ObjRef.GetBaseObject()
				Float CurrentHealth = Util.GetWornObjectHealth(ObjRef, akBaseObject)
				Float RecordedHealth = StorageUtil.GetFloatValue(ObjRef, "_MWA_LastHealth", -1.0)
				If RecordedHealth != -1.0
					If CurrentHealth > StorageUtil.GetFloatValue(ObjRef, "_MWA_LastHealth")
						Util.BumpTempering(ObjRef, akBaseObject, CurrentHealth)
						If Menu.TemperingRefitT
							Util.FitToPlayer(ObjRef, akBaseObject)
						EndIf
						Util.RestoreDurability(ObjRef, akBaseObject, CurrentHealth)
						StorageUtil.SetFloatValue(ObjRef, "_MWA_LastHealth", Util.GetWornObjectHealth(ObjRef, akBaseObject))
						;Debug.Notification("Item was tempered: " + CurrentHealth)
						;Debug.Messagebox("OldHealth: " + CurrentHealth + ". RecordedHealth: " + RecordedHealth + "NewHealth: " + Util.GetWornObjectHealth(ObjRef, akBaseObject))
					EndIf
				Else
					StorageUtil.SetFloatValue(ObjRef, "_MWA_LastHealth", CurrentHealth)
				EndIf
			EndIf
			i += 1
		EndWhile	
		FurnitureUsed = 0
		
		GoToState("")
		DidTemper = false
	EndIf
EndEvent

State TrackCraft
	Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
		DidTemper = true
		AddInventoryEventFilter(_MWA_DummyArmor)		
		GoToState("")
	EndEvent
EndState

Event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)

EndEvent

Quest Property _MWA_PlayerInventoryAliases Auto

Spell Property _MWA_FurnitureDetect Auto

Armor Property _MWA_DummyArmor Auto

MagicEffect Property _MWA_IsInGrindstone Auto
MagicEffect Property _MWA_IsInWorkbench Auto

Actor Property PlayerRef Auto

_MWA_Utility Property Util Auto
_MWA_DestructionTypes Property DestructTypes Auto
_MWA_SanityChecker Property SanityChecker Auto
_MWA_Mcm Property Menu Auto
