Scriptname _MWA_Utility extends Quest

String[] LowerCaseAlpha
String[] UpperCaseAlpha

Int Property ContainerObjectAliasIndex = 0 Auto Hidden

Bool Property IsCutLoose = false Auto Hidden; Set to true 20 seconds after MQ101 reached stage 240. Fix for alternate start armors not fitting player

Event OnInit()
	InventTheAlphabet()
	StorageUtil.FormListResize(none, "_MWA_ArmorTrackAliasList", 100, filler = none)
	StorageUtil.FormListResize(none, "_MWA_BrokenTrackAliasList", 100, filler = none)
	RegisterForModEvent("_MWA_Internal_GetDurability", "On_MWA_Internal_GetDurability")
	InitBikiniKeyword()
EndEvent

Function PlayerLoadsGame()
	RegisterForModEvent("_MWA_Internal_GetDurability", "On_MWA_Internal_GetDurability")
	InitBikiniKeyword()
	InitMmeMilkKeyword()
	SetLockpickValue()
	;Debug.Trace("_MWA_: WornList: PLAYER LOADS GAME =====================================================================")
EndFunction

Function InitBikiniKeyword()
	If Game.GetModByName("SL Survival.esp") != 255
		_SLS_BikiniArmor = Game.GetFormFromFile(0x049867, "SL Survival.esp") as Keyword
	Else
		_SLS_BikiniArmor = _MWA_DummyNeverUsedKw
	Endif
EndFunction

Function InitMmeMilkKeyword()
	If Game.GetModByName("MilkModNEW.esp") !=  255
		MME_Milk = Game.GetFormFromFile(0x06D61F, "MilkModNEW.esp") as Keyword
	Else
		MME_Milk = _MWA_DummyNeverUsedKw
	EndIf
EndFunction

Event On_MWA_Internal_GetDurability(Form ObjRefAsForm, Form akBaseObject, Bool IsInBarterMenu)
	ObjectReference ObjRef = ObjRefAsForm as ObjectReference
	If ObjRef != None
		ObjectReference SrcContainer = Game.GetCurrentCrosshairRef()
		Bool IsFitted = false
		If StorageUtil.HasFloatValue(ObjRef, "_MWA_ArmorFit")
			IsFitted = true
		EndIf
		GetDurability(ObjRef, akBaseObject, ForceUpdate = false, IsWorn = !IsInBarterMenu)
		If IsInBarterMenu || !IsCutLoose
			FitToPlayer(ObjRef, akBaseObject)
			StorageUtil.SetIntValue(ObjRef, "_MWA_Durability", StorageUtil.GetIntValue(ObjRef, "_MWA_DurabilityMax", 1))
		Else
			If SrcContainer as Actor
				Actor SrcActor = SrcContainer as Actor
				If SrcActor.GetRace().IsRaceFlagSet(0) ; Is source 'container' a playable race
					FitToActor(ObjRef, SrcActor, akBaseObject)
				Else
					FitToRandom(ObjRef, akBaseObject)
				EndIf
			Else
				FitToRandom(ObjRef, akBaseObject)
			EndIf
		EndIf
		If !IsFitted || IsInBarterMenu ; Wasnt previously fitted -> update displayed name, checked is equipped and if it fits
			DispItemDurability (ObjRef, akBaseObject, 0.0)
			If 	SanityChecker.IsObjRefEquipped(akBaseObject, ObjRef)
				If !IsSuitable(ObjRef, akBaseObject)
					PlayerRef.UnequipItem(akBaseObject, abPreventEquip = false,abSilent = true)
				EndIf
			EndIf
		EndIf
	Else
		Debug.Trace("_MWA_: Error: On_MWA_Internal_GetDurability received a None")
	EndIf
EndEvent

Function InventTheAlphabet()

	; tHiS iS FanTaStiC bEthESda, i'M nOt wOrRiED fOR eSVi aT aLL!!11!1
	LowerCaseAlpha = new String[26]
	LowerCaseAlpha[0] = "a"
	LowerCaseAlpha[1] = "b"
	LowerCaseAlpha[2] = "c"
	LowerCaseAlpha[3] = "d"
	LowerCaseAlpha[4] = "e"
	LowerCaseAlpha[5] = "f"
	LowerCaseAlpha[6] = "g"
	LowerCaseAlpha[7] = "h"
	LowerCaseAlpha[8] = "i"
	LowerCaseAlpha[9] = "j"
	LowerCaseAlpha[10] = "k"
	LowerCaseAlpha[11] = "l"
	LowerCaseAlpha[12] = "m"
	LowerCaseAlpha[13] = "n"
	LowerCaseAlpha[14] = "o"
	LowerCaseAlpha[15] = "p"
	LowerCaseAlpha[16] = "q"
	LowerCaseAlpha[17] = "r"
	LowerCaseAlpha[18] = "s"
	LowerCaseAlpha[19] = "t"
	LowerCaseAlpha[20] = "u"
	LowerCaseAlpha[21] = "v"
	LowerCaseAlpha[22] = "w"
	LowerCaseAlpha[23] = "x"
	LowerCaseAlpha[24] = "y"
	LowerCaseAlpha[25] = "z"	
	
	UpperCaseAlpha = new String[26]
	UpperCaseAlpha[0] = "A"
	UpperCaseAlpha[1] = "B"
	UpperCaseAlpha[2] = "C"
	UpperCaseAlpha[3] = "D"
	UpperCaseAlpha[4] = "E"
	UpperCaseAlpha[5] = "F"
	UpperCaseAlpha[6] = "G"
	UpperCaseAlpha[7] = "H"
	UpperCaseAlpha[8] = "I"
	UpperCaseAlpha[9] = "J"
	UpperCaseAlpha[10] = "K"
	UpperCaseAlpha[11] = "L"
	UpperCaseAlpha[12] = "M"
	UpperCaseAlpha[13] = "N"
	UpperCaseAlpha[14] = "O"
	UpperCaseAlpha[15] = "P"
	UpperCaseAlpha[16] = "Q"
	UpperCaseAlpha[17] = "R"
	UpperCaseAlpha[18] = "S"
	UpperCaseAlpha[19] = "T"
	UpperCaseAlpha[20] = "U"
	UpperCaseAlpha[21] = "V"
	UpperCaseAlpha[22] = "W"
	UpperCaseAlpha[23] = "X"
	UpperCaseAlpha[24] = "Y"
	UpperCaseAlpha[25] = "Z"
EndFunction

Function WornListAdd(ObjectReference ObjRef, String CallingFunction)
	;Debug.Trace("_MWA_: WornList: Adding: " + akBaseObject.GetName() + ". ObjRef: " + ObjRef + ". Function: " + CallingFunction)
	StorageUtil.FormListAdd(none, "_MWA_WornDestructibles", ObjRef, allowDuplicate = false)
EndFunction

Function WornListRemove(ObjectReference ObjRef, String CallingFunction, Int Index = -1)
	;Debug.Trace("_MWA_: WornList: Removing: " + akBaseObject.GetName() + ". ObjRef: " + ObjRef + ". Function: " + CallingFunction + ". Index: " + Index)
	If Index == -1
		StorageUtil.FormListRemove(none, "_MWA_WornDestructibles", ObjRef, allInstances = true)
	Else
		StorageUtil.FormListRemoveAt(none, "_MWA_WornDestructibles", Index)
	EndIf
EndFunction

Function SetRightWeapon(ObjectReference ObjRef, String CallingFunction)
;/
	If ObjRef != None
		Debug.Trace("_MWA_: Setting Right Weapon to: " + ObjRef + ". Base: " + ObjRef.GetBaseObject() + ". CallingFunction: " + CallingFunction)
	Else
		Debug.Trace("_MWA_: Setting Right Weapon to: None. CallingFunction: " + CallingFunction)
	EndIf
/;
	If ArmorDes.LeftWeapon == ObjRef
		ArmorDes.LeftWeapon = None
	EndIf
	ArmorDes.RightWeapon = ObjRef
EndFunction

Function SetLeftWeapon(ObjectReference ObjRef, String CallingFunction)
;/
	If ObjRef != None
		Debug.Trace("_MWA_: Setting Left Weapon to: " + ObjRef + ". Base: " + ObjRef.GetBaseObject() + ". CallingFunction: " + CallingFunction)
	Else
		Debug.Trace("_MWA_: Setting Left Weapon to: None. CallingFunction: " + CallingFunction)
	EndIf
/;
	If ArmorDes.RightWeapon == ObjRef
		ArmorDes.RightWeapon = None
	EndIf
	ArmorDes.LeftWeapon = ObjRef
EndFunction

Function SetShield(ObjectReference ObjRef, String CallingFunction)
;/
	If ObjRef != None
		Debug.Trace("_MWA_: Setting Shield to: " + ObjRef + ". Base: " + ObjRef.GetBaseObject() + ". CallingFunction: " + CallingFunction)
	Else
		Debug.Trace("_MWA_: Setting Shield to: None. CallingFunction: " + CallingFunction)
	EndIf
/;
	ArmorDes.EquippedShield = ObjRef
EndFunction

Float Function GetWornObjectHealth(ObjectReference ObjRef, Form akBaseObject)
	;Debug.Trace("_MWA_: GetWornObjectHealth called on " + akBaseObject.GetName() + " - " + ObjRef)
	;If StorageUtil.FormListFind(none, "_MWA_WornDestructibles", ObjRef) != -1
		If akBaseObject as Armor
			Int SlotMask = (akBaseObject as Armor).GetSlotMask()
			Return WornObject.GetItemHealthPercent(PlayerRef, 0, SlotMask)
		Else
			Int HandSlot = 1
			If ObjRef == ArmorDes.LeftWeapon
				HandSlot = 0
			EndIf
			Float ObjectHealth = WornObject.GetItemHealthPercent(PlayerRef, HandSlot, 0)
			;Debug.Trace("_MWA_: GetWornObjectHealth: Returning: " + ObjectHealth)
			Return ObjectHealth
		EndIf
	;Else
	;	Debug.Trace("_MWA_: GetWornObjectHealth called on " + akBaseObject.GetName() + " - " + ObjRef + ". But object is not in worn list")
	;	Return -1.0
	;EndIf
EndFunction

Function RestoreDurability(ObjectReference ObjRef, Form akBaseObject, Float Health = 0.0)
	StorageUtil.SetIntValue(ObjRef, "_MWA_Durability", StorageUtil.GetIntValue(ObjRef, "_MWA_DurabilityMax"))
	DispItemDurability (ObjRef, akBaseObject, Health)
EndFunction

Function BumpTempering(ObjectReference ObjRef, Form akBaseObject, Float Health)
	If !Init.IsRequiemInstalled
		Float BumpedTempering = Init.GetBumpedTemperValue(Health)
		If akBaseObject as Armor
			Int SlotMask = (akBaseObject as Armor).GetSlotMask()
			WornObject.SetItemHealthPercent(PlayerRef, 0, SlotMask, BumpedTempering)
		Else
			Int HandSlot = 1
			If ObjRef == ArmorDes.LeftWeapon
				HandSlot = 0
			EndIf
			WornObject.SetItemHealthPercent(PlayerRef, HandSlot, 0, BumpedTempering)
		EndIf
	EndIf
EndFunction

Function SetTempering(ObjectReference ObjRef, Form akBaseObject, Float Health)
	;Float BumpedTempering = Init.GetBumpedTemperValue(Health)
	If akBaseObject as Armor
		Int SlotMask = (akBaseObject as Armor).GetSlotMask()
		WornObject.SetItemHealthPercent(PlayerRef, 0, SlotMask, Health)
	Else
		Int HandSlot = 1
		If ObjRef == ArmorDes.LeftWeapon
			HandSlot = 0
		EndIf
		WornObject.SetItemHealthPercent(PlayerRef, HandSlot, 0, Health)
	EndIf
EndFunction

Function SetDurability(ObjectReference ObjRef, Int Durability)
	If ObjRef
		StorageUtil.SetIntValue(ObjRef, "_MWA_Durability", Durability)
		DispItemDurability (ObjRef, ObjRef.GetBaseObject(), 0.0)
	EndIf
EndFunction

Function SetDurabilityMax(ObjectReference ObjRef, Int DurabilityMax)
	If ObjRef
		StorageUtil.SetIntValue(ObjRef, "_MWA_DurabilityMax", DurabilityMax)
		DispItemDurability (ObjRef, ObjRef.GetBaseObject(), 0.0)
	EndIf
EndFunction

Function RefreshInventory() ; Tried QueueNiNodeUpdate which correctly updates the worn model but the inventory item does not show as equipped - Hurray for Bethesda!
	If Utility.IsInMenuMode()
		PlayerRef.AddItem(_MWA_InvRefreshObject, 1, true)
		PlayerRef.RemoveItem(_MWA_InvRefreshObject, 1, true)
	EndIf
EndFunction

Function ToggleCurse(ObjectReference ObjRef, Bool IsCursed)
	If ObjRef
		If IsCursed
			StorageUtil.SetIntValue(ObjRef, "_MWA_IsCursedObject", 1)
		Else
			StorageUtil.SetIntValue(ObjRef, "_MWA_IsCursedObject", 0)
		EndIf
		
	Else
		Debug.Trace("_MWA_: ToggleCurse received a none ObjRef")
	EndIf
EndFunction

Function DispItemDurability (ObjectReference ObjRef, Form akBaseObject, Float ObjectHealth)
	;If Menu.AddDurabilityDes
	;Debug.Trace("_MWA_: DispItemDurability: ObjRef: " + ObjRef + ". akBaseObject: " + akBaseObject + ". ObjectHealth: " + ObjectHealth)
	Int Durability = StorageUtil.GetIntValue(ObjRef, "_MWA_Durability")
	Int DurabilityMax = StorageUtil.GetIntValue(ObjRef, "_MWA_DurabilityMax")
	If ObjectHealth == 0.0 ; Health was not 'known' by calling function
		ObjectHealth = ObjRef.GetItemHealthPercent()
	EndIf
	String ObjName = GetDynamicName(ObjRef, "DispItemDurability")
	;String ObjName = akBaseObject.GetName()
	If StringUtil.Find(ObjName, " ", 0) == -1
		;Debug.Trace("_MWA_: Passing in: " + ObjName)
		ObjName = CapitalizeCharZero(ObjName)
	Else
		ObjName += " "
	EndIf
	If ObjectHealth <= 1.0 ; Skyrim handles Legendary -> Fine but not basic or untempered
		ObjRef.SetDisplayName(ObjName + "(" + Durability + "/" + DurabilityMax + GetFitString(ObjRef, akBaseObject) + ")")
	;ElseIf ObjectHealth < Init.TemperFloatFine
	;	ObjRef.SetDisplayName(ObjName + "(" + Durability + "/" + DurabilityMax + GetFitString(ObjRef, akBaseObject) + ") (" + GetTemperString(ObjectHealth) + ")")
	Else
		ObjRef.SetDisplayName(ObjName + "(" + Durability + "/" + DurabilityMax + GetFitString(ObjRef, akBaseObject) + ")")
	EndIf
	RefreshInventory()
	;EndIf
EndFunction

String Function GetFitString(ObjectReference ObjRef, Form akBaseObject)
	If Menu.AddSuitabilityDes && !(akBaseObject as Weapon) && !akBaseObject.HasKeyword(ArmorShield)
		Float Fit = StorageUtil.GetFloatValue(ObjRef, "_MWA_ArmorFit", 101.0)
		If Fit == 101
			Return ""
		Else
			String FitString
			FitString = Math.Abs(Fit) as Int
			If Fit > 0.0
				FitString = " F" + FitString
				;FitString = "-" + " F" + FitString
			Else
				FitString = " M" + FitString
			EndIf
			Return FitString
		EndIf
	Else
		Return ""
	EndIf
EndFunction

;/
Function SetDynamicName(String Name, Bool ForceIt = false)
	String ObjName = StorageUtil.GetStringValue(ObjRef, "_MWA_ObjDisplayName")
	If ObjName == "" || ForceIt
		StorageUtil.SetStringValue(ObjRef, "_MWA_ObjDisplayName", ObjName)
	EndIf
EndFunction
/;

String Function GetDynamicName(ObjectReference ObjRef, String CallingFunction)
	;Debug.Trace("_MWA_: GetDynamicName - CallingFunction: " + CallingFunction + ". ObjRef: " + ObjRef + ". Base: " + ObjRef.GetBaseObject())
	String ObjName = StorageUtil.GetStringValue(ObjRef, "_MWA_ObjDisplayName")
	If ObjName == ""
		ObjName = ObjRef.GetDisplayName()
		Int index = StringUtil.Find(ObjName, " (", 0)
		If Index > -1 ; remove tempering from name
			ObjName = StringUtil.Substring(ObjName, 0, Index)
		EndIf
		StorageUtil.SetStringValue(ObjRef, "_MWA_ObjDisplayName", ObjName)
		
	Else
		; Debugging ---------------
		If StringUtil.Find(ObjName, ObjRef.GetBaseObject().GetName(), 0) == -1 && StorageUtil.GetIntValue(ObjRef, "_MWA_NameModified", Missing = 0) == 0 ; At least a subportion of ObjName should be found in the base object name otherwise name bug
			;Debug.Messagebox("String names don't match\nObjName: " + ObjName + "\nBaseName: " + ObjRef.GetBaseObject().GetName() + "\nObjRef: " + ObjRef + "\nakBAseObject: " + ObjRef.GetBaseObject())
			;Debug.Trace("_MWA_: GetDynamicName - Error on: " + CallingFunction + ". ObjRef: " + ObjRef + ". Base: " + ObjRef.GetBaseObject() + ". DisplayName: " + ObjRef.GetDisplayName() + ". ObjName: " + ObjName + ". Base Name: " + ObjRef.GetBaseObject().GetName())
			
			ObjName = GetFixedDyanamicName(ObjRef)			
		EndIf
		; Debugging ---------------
	EndIf
	;Debug.Messagebox("Returning " + ObjName)
	Return ObjName
EndFunction

String Function GetFixedDyanamicName(ObjectReference ObjRef)
	String ObjName = ObjRef.GetDisplayName()
	Int index = StringUtil.Find(ObjName, " (", 0)
	If Index > -1 ; remove tempering from name
		ObjName = StringUtil.Substring(ObjName, 0, Index)
	EndIf
	StorageUtil.SetStringValue(ObjRef, "_MWA_ObjDisplayName", ObjName)
	Debug.Trace("_MWA_: GetDynamicName - Error on: GetFixedDyanamicName. Object: " + ObjRef + ". BaseName: " + ObjRef.GetBaseObject().GetName() + ". Renamed to " + ObjName)
	Return ObjName
EndFunction

String Function CapitalizeCharZero(String ObjName) ; workaround for stupid skyrim lower case bug
	Int Index = LowerCaseAlpha.Find(StringUtil.GetNthChar(ObjName, 0))
	If Index > -1
		String Blah = StringUtil.SubString(ObjName, 1)
		If StringUtil.SubString(ObjName, 0, 2) == "gl" ; Skyrims handling of strings is an utter mystery - fix for Gloves coming out as GLoves. Yeah...
			blah = UpperCaseAlpha[Index] + blah + " "
		Else
			blah = blah + " "
			blah = UpperCaseAlpha[Index] + blah
		EndIf
		;Debug.Trace("_MWA_: CapitalizeCharZero(): Returning: " + Blah)
		Return blah
	Else
		Return ObjName
	EndIf
EndFunction

String Function GetTemperString(Float ObjectHealth) ; Redundant
	If ObjectHealth < TemperFloor
		Return "Untempered"
	ElseIf ObjectHealth >= Init.TemperFloatLegendary
		Return Init.TemperStringLegendary	
	ElseIf ObjectHealth >= Init.TemperFloatEpic
		Return Init.TemperStringEpic
	ElseIf ObjectHealth >= Init.TemperFloatFlawless
		Return Init.TemperStringFlawless
	ElseIf ObjectHealth >= Init.TemperFloatExquisite
		Return Init.TemperStringExquisite
	ElseIf ObjectHealth >= Init.TemperFloatSuperior
		Return Init.TemperStringSuperior
	ElseIf ObjectHealth >= Init.TemperFloatFine
		Return Init.TemperStringFine
	Else
		Return "Basic"
	EndIf
EndFunction

Function CheckTemperLevelChange(Form ObjectBase, Float CurrentHealth, Float Damage)
		;/
		Float Calc = CurrentHealth - Math.Floor(CurrentHealth)
		Calc = Calc * 10.0
		Debug.Trace("_MWA_: Health: " + CurrentHealth + ". Damage: " + Damage + ". Calc: " + ((Calc - Math.Floor(Calc)) - (Damage * 10.0)))
		If (Calc - Math.Floor(Calc)) - (Damage * 10.0) < 0.0
			Debug.Notification(ObjectBase.GetName() + " has degraded to " + GetTemperString(CurrentHealth-Damage))
		EndIf
		/;
		If CurrentHealth - Damage < Init.GetNextTemperDegrade(CurrentHealth)
			Debug.Notification(ObjectBase.GetName() + " has degraded to " + GetTemperString(CurrentHealth-Damage))
		EndIf
EndFunction

ReferenceAlias Function GetNextEmptyAlias(Quest QuestToCheck)
	Int AliasCount = QuestToCheck.GetNumAliases()
	Int i = 0
	ReferenceAlias NextEmptyAlias
	
	While i < AliasCount && NextEmptyAlias == None
		If (QuestToCheck.GetNthAlias(i) as ReferenceAlias).GetReference() == None
			NextEmptyAlias = QuestToCheck.GetNthAlias(i) as ReferenceAlias
			Return NextEmptyAlias
		EndIf
		i += 1
	EndWhile
	Return NextEmptyAlias
EndFunction

Int Function GetNextEmptyAliasIndex(Quest QuestToCheck)
	Int AliasCount = QuestToCheck.GetNumAliases()
	Int i = 0
	ReferenceAlias NextEmptyAlias
	
	While i < AliasCount && NextEmptyAlias == None
		If (QuestToCheck.GetNthAlias(i) as ReferenceAlias).GetReference() == None
			NextEmptyAlias = QuestToCheck.GetNthAlias(i) as ReferenceAlias
			Return i
		EndIf
		i += 1
	EndWhile
	Return -1
EndFunction

Int Function GetOldestAliasIndex(Quest QuestToCheck)
	Int AliasCount = QuestToCheck.GetNumAliases()
	Int i = 0
	Int RefAliasSelect
	Float LowestValue
	ReferenceAlias NextAlias
	
	While i < AliasCount
		NextAlias = QuestToCheck.GetNthAlias(i) as ReferenceAlias
		If i == 0
			LowestValue = (NextAlias as _MWA_ArmorAlias).LastUpdate
			RefAliasSelect = 0
		ElseIf (NextAlias as _MWA_ArmorAlias).LastUpdate < LowestValue
			LowestValue = (NextAlias as _MWA_ArmorAlias).LastUpdate
			RefAliasSelect = i
		EndIf
		i += 1
	EndWhile
	Return RefAliasSelect
EndFunction

Function CheckWornList()
	Int i = StorageUtil.FormListCount(none, "_MWA_WornDestructibles") - 1
	;Debug.Trace("_MWA_: Worn List - Total: " + (i + 1))
	ObjectReference ObjRef
	Form akBaseObject
	While i >= 0
		ObjRef = StorageUtil.FormListGet(none, "_MWA_WornDestructibles", i) as ObjectReference
		If ObjRef == None
			;Debug.Trace("_MWA_: Worn List - Removing empty index " + i)
			WornListRemove(ObjRef, "CheckWornList() 1", i)
		Else
			akBaseObject = ObjRef.GetBaseObject()
			If StringUtil.Find(ObjRef, "container") != -1
				;Debug.MessageBox("Removed: " + ObjRef.GetBaseObject() + ". Ref: " + ObjRef)
				WornListRemove(ObjRef, "CheckWornList() 2", i)
				
			Else
				If !SanityChecker.IsObjRefEquipped(akBaseObject, ObjRef)
					WornListRemove(ObjRef, "CheckWornList() 3", i)
					;Debug.MessageBox("Removed: " + ObjRef.GetBaseObject() + ". Ref: " + ObjRef)
				EndIf
				;Debug.Trace("_MWA_: Worn List - Index " + i + ": ObjRef: " + ObjRef + ". Base: " + ObjRef.GetBaseObject())
			EndIf
		EndIf
		i -= 1
	EndWhile
	ObjRef = ArmorDes.RightWeapon
	If ObjRef != None
		If !SanityChecker.IsObjRefEquipped(ObjRef.GetBaseObject(), ObjRef)
			ArmorDes.RightWeapon = None
		EndIf
	EndIf
	ObjRef = ArmorDes.LeftWeapon
	If ObjRef != None
		If !SanityChecker.IsObjRefEquipped(ObjRef.GetBaseObject(), ObjRef)
			ArmorDes.LeftWeapon = None
		EndIf
	EndIf
EndFunction

Function UnPersist(ObjectReference ObjRef, Quest QuestToCheck, String CheckList, Int NumOfAliases)
	Int ListIndex = StorageUtil.FormListFind(None, CheckList, ObjRef)
	If ListIndex != -1
		ReferenceAlias AliasSelect = QuestToCheck.GetNthAlias(ListIndex) as ReferenceAlias
		If ListIndex < NumOfAliases ; Avoid operations on non existent aliases. Data can still be stored to the object reference but persistence is at the mercy of skyrim (which has none)
			If AliasSelect.GetReference() == StorageUtil.FormListGet(None, CheckList, ListIndex) as ObjectReference
				;Debug.Trace("_MWA_: UnPersist - Matched: " + (ObjRef as String) + ". Quest: " + QuestToCheck + ". List: " + CheckList)
				
				(AliasSelect as _MWA_ArmorAlias).LastUpdate = 0.0
				AliasSelect.Clear()
			Else
				Debug.Trace("_MWA_: Error: UnPersist - NOT Matched: " + (ObjRef as String) + ". Quest: " + QuestToCheck + ". List: " + CheckList)
			EndIf
		Else
			StorageUtil.FormListSet(none, CheckList, ListIndex, none)
		EndIf
	Else
		Debug.Trace("_MWA_: Error: UnPersist - Not FOUND - Quest: " + QuestToCheck + ". List: " + CheckList)
	EndIf
EndFunction

Int Function CostRepairDurabilityWorn()
	Int i = StorageUtil.FormListCount(none, "_MWA_WornDestructibles") - 1
	Int TotalCost = 0
	Int BaseValue
	Int EnchantValue
	Int ItemCost
	Float Condition
	ObjectReference akReference
	Form akBaseObject
	While i >= 0
		akReference = StorageUtil.FormListGet(none, "_MWA_WornDestructibles", i) as ObjectReference
		akBaseObject = akReference.GetBaseObject()
		If IsCorrectCraftsman(akReference)
			BaseValue = akBaseObject.GetGoldValue()
			EnchantValue = GetEnchantedGoldValue(GetItemEnchantment(akReference, 0, PlayerRef), akBaseObject, akReference, StorageUtil.GetFloatValue(akReference, "_MWA_OriginalChargeMax"))
			ItemCost = Math.Ceiling((BaseValue * Menu.DurRepairCostBase) + (EnchantValue * Menu.DurRepairCostEnchant))
			Condition = (StorageUtil.GetIntValue(akReference, "_MWA_Durability") / StorageUtil.GetIntValue(akReference, "_MWA_DurabilityMax"))
			If Condition < 1.0
				TotalCost += Menu.DurRepairCostMin + Math.Ceiling((1 - Condition) * ItemCost)
				StorageUtil.FormListAdd(none, "_MWA_ForRepairList",  akReference, allowDuplicate = false)
				;Debug.Trace("_MWA_: CostRepairDurabilityWorn(): Added: " + akBaseObject.GetName())
			EndIf
		Endif

		akReference = None
		i -= 1
	EndWhile
	
	; Weapons
	If ArmorDes.LeftWeapon != None
		If IsCorrectCraftsman(ArmorDes.LeftWeapon)
			akBaseObject = ArmorDes.LeftWeapon.GetBaseObject()
			BaseValue = akBaseObject.GetGoldValue()
			EnchantValue = GetEnchantedGoldValue(GetItemEnchantment(ArmorDes.LeftWeapon, 2, PlayerRef), akBaseObject, ArmorDes.LeftWeapon, StorageUtil.GetFloatValue(ArmorDes.LeftWeapon, "_MWA_OriginalChargeMax"))
			ItemCost = Math.Ceiling((BaseValue * Menu.DurRepairCostBase) + (EnchantValue * Menu.DurRepairCostEnchant))
			Condition = (StorageUtil.GetIntValue(ArmorDes.LeftWeapon, "_MWA_Durability") / StorageUtil.GetIntValue(ArmorDes.LeftWeapon, "_MWA_DurabilityMax"))
			If Condition < 1.0
				TotalCost += Math.Ceiling((1 - Condition) * ItemCost)
				StorageUtil.FormListAdd(none, "_MWA_ForRepairList",  ArmorDes.LeftWeapon, allowDuplicate = false)
				;Debug.Trace("_MWA_: CostRepairDurabilityWorn(): Added: " + akBaseObject.GetName())
			EndIf
		Endif
	EndIf
	If ArmorDes.RightWeapon != None
		If IsCorrectCraftsman(ArmorDes.RightWeapon)
			akBaseObject = ArmorDes.RightWeapon.GetBaseObject()
			BaseValue = akBaseObject.GetGoldValue()
			EnchantValue = GetEnchantedGoldValue(GetItemEnchantment(ArmorDes.RightWeapon, 1, PlayerRef), akBaseObject, ArmorDes.RightWeapon, StorageUtil.GetFloatValue(ArmorDes.RightWeapon, "_MWA_OriginalChargeMax"))
			ItemCost = Math.Ceiling((BaseValue * Menu.DurRepairCostBase) + (EnchantValue * Menu.DurRepairCostEnchant))
			Condition = (StorageUtil.GetIntValue(ArmorDes.RightWeapon, "_MWA_Durability") / StorageUtil.GetIntValue(ArmorDes.RightWeapon, "_MWA_DurabilityMax"))
			If Condition < 1.0
				TotalCost += Math.Ceiling((1 - Condition) * ItemCost)
				StorageUtil.FormListAdd(none, "_MWA_ForRepairList",  ArmorDes.RightWeapon, allowDuplicate = false)
				;Debug.Trace("_MWA_: CostRepairDurabilityWorn(): Added: " + akBaseObject.GetName())
			EndIf
		Endif
	EndIf
	Return TotalCost
EndFunction

Int Function CostDurRepairSpecific(Form akBaseObject, ObjectReference akReference)
	Float Condition = (StorageUtil.GetIntValue(akReference, "_MWA_Durability") / StorageUtil.GetIntValue(akReference, "_MWA_DurabilityMax"))
	If Condition < 1.0
		Int BaseValue = akBaseObject.GetGoldValue()
		Int EnchantValue = GetEnchantedGoldValue(GetItemEnchantment(akReference, 0, PlayerRef), akBaseObject, akReference, StorageUtil.GetFloatValue(akReference, "_MWA_OriginalChargeMax"))
		Int ItemCost = Math.Ceiling((BaseValue * Menu.DurRepairCostBase) + (EnchantValue * Menu.DurRepairCostEnchant))
		Return Menu.DurRepairCostMin + Math.Ceiling((1 - Condition) * ItemCost)
		;Debug.Trace("_MWA_: CostDurRepairSpecific(): Added: " + akBaseObject.GetName())
	Else
		;Debug.Trace("_MWA_: CostDurRepairSpecific(): " + akBaseObject.GetName() + " doesn't need Durability repair")
		Return 0
	EndIf
EndFunction

Int Function CostDurReinforce(Form akBaseObject, ObjectReference akReference, Float UpgradeCount)
	Int BaseValue = akBaseObject.GetGoldValue()
	Int EnchantValue = GetEnchantedGoldValue(GetItemEnchantment(akReference, 0, PlayerRef), akBaseObject, akReference, StorageUtil.GetFloatValue(akReference, "_MWA_OriginalChargeMax"))
	Int ItemCost = Math.Ceiling((BaseValue * Menu.DurRepairCostBase) + (EnchantValue * Menu.DurRepairCostEnchant))	
	;Int Cost =  (Menu.DurRepairCostMin + ItemCost) + Math.Ceiling((1000 * UpgradeCount * ((UpgradeCount/3) * (UpgradeCount/3) * (UpgradeCount/3))))
	;Debug.Messagebox(((StorageUtil.GetIntValue(akReference, "_MWA_DurabilityMax") - GetBaseDurability(akBaseObject)) as Float))
	Float Cost =  (((StorageUtil.GetIntValue(akReference, "_MWA_DurabilityMax") - GetBaseDurability(akBaseObject)) as Float) / 8.0)
	If Cost <= 0.0
		Cost = 0.01
	EndIf
	Int MinCost = 25
	Cost = (700 * (Cost *Cost * Cost)) + ItemCost + MinCost
	;Debug.Messagebox("Cost: " + Cost + ". ItemCost: " + ItemCost)
	Return Math.Ceiling(Cost)
EndFunction

Bool Function IsCorrectCraftsman(ObjectReference akReference)
	Form akBaseObject = akReference.GetBaseObject()
	If akBaseObject as Armor
		If (Init.RepairActor.IsInFaction(_MWA_TailorFaction) && (akBaseObject as Armor).GetWeightClass() == 2) || (Init.RepairActor.IsInFaction(JobBlacksmithFaction) && (akBaseObject as Armor).GetWeightClass() != 2)
			Return True
		Else
			Return false
		EndIf
	ElseIf akBaseObject as Weapon
		If Init.RepairActor.IsInFaction(_MWA_TailorFaction)
			Return false
		Else
			Return true
		EndIf
	Else
		Return False
	Endif
EndFunction

Function DoRepairDurability()
	Int i = StorageUtil.FormListCount(none, "_MWA_ForRepairList") - 1
	ObjectReference akReference
	While i >= 0
		akReference = StorageUtil.FormListGet(none, "_MWA_ForRepairList", i) as ObjectReference
		StorageUtil.SetIntValue(akReference, "_MWA_Durability", (StorageUtil.GetIntValue(akReference, "_MWA_DurabilityMax")))
		DispItemDurability(akReference, akReference.GetBaseObject(), 0.0)
		i -= 1
	EndWhile
	If ArmorDes.LeftWeapon != None
		StorageUtil.SetIntValue(ArmorDes.LeftWeapon, "_MWA_Durability", (StorageUtil.GetIntValue(ArmorDes.LeftWeapon, "_MWA_DurabilityMax")))
	EndIf
	If ArmorDes.RightWeapon != None
		StorageUtil.SetIntValue(ArmorDes.RightWeapon, "_MWA_Durability", (StorageUtil.GetIntValue(ArmorDes.RightWeapon, "_MWA_DurabilityMax")))
	EndIf
EndFunction

Function TryRepairDurability()
	_MWA_FixCost.SetValueInt(CostRepairDurabilityWorn())
	If _MWA_FixCost.GetValueInt() > 0
		If PlayerRef.GetItemCount(Gold001) >= _MWA_FixCost.GetValueInt()
			Int Button = _MWA_RepairConfirm.Show(afArg1 = _MWA_FixCost.GetValue())
			If Button == 0 ; Proceed
				PlayerRef.RemoveItem(akItemToRemove = Gold001, aiCount = _MWA_FixCost.GetValueInt(), abSilent = false, akOtherContainer = Init.RepairActor)
				DoRepairDurability()
			Endif
		Else
			Debug.Notification("You can not afford that - " + _MWA_FixCost.GetValueInt() + " septims")
		Endif
	Else
		Debug.Notification("You have nothing that needs to be fixed")
	EndIf
	_MWA_FixCost.SetValueInt(0)
	StorageUtil.FormListClear(none, "_MWA_ForRepairList")
EndFunction

Function BeginDurRepairSpecific(Actor akSpeaker)
	PauseInventoryTracking()
	RegisterForMenu("ContainerMenu")
	Init.RepairActor = akSpeaker
	_MWA_DurRepairSpecificContainer.Activate(PlayerRef)
	
	; Kill OnItemAdded/Removed inventory tracking
EndFunction

Function BeginSanctify(Actor akSpeaker)
	PauseInventoryTracking()
	RegisterForMenu("ContainerMenu")
	Init.RepairActor = akSpeaker
	_MWA_SanctifyBarrelRef.Activate(PlayerRef)
EndFunction

Event OnMenuClose(String MenuName)
	ResumeInventoryTracking()
EndEvent

Function PauseInventoryTracking() ; Disable ObjectReference inventory tracking. Items added to repair containers will always end up back in player inventory -> do nothing
	InvTrackAdd.PauseTracking()
	InvTrackRemove.PauseTracking()
EndFunction

Function ResumeInventoryTracking()
	InvTrackAdd.ResumeTracking()
	InvTrackRemove.ResumeTracking()
EndFunction

Enchantment Function GetItemEnchantment(ObjectReference ObjRef, Int HandSlot, Actor Who) ; Item must be worn
	Form BaseObject = ObjRef.GetBaseObject()
	Enchantment E
	If BaseObject as Armor
		E = (BaseObject as Armor).GetEnchantment()
	Else
		E = (BaseObject as Weapon).GetEnchantment()
	Endif
	If	E != None
		Return E
	Else
		If BaseObject as Armor
			E = WornObject.GetEnchantment(Who, HandSlot, (BaseObject as Armor).GetSlotMask())
		Else
			E = WornObject.GetEnchantment(Who, HandSlot, 0)
		Endif
		If E != None
			Return E
		Else
			Return None
		EndIf
	EndIf
EndFunction

Int Function GetEnchantedGoldValue(Enchantment E, Form ObjectBase, ObjectReference ObjRef, Float MaxCharge)
	If E != None
		If ObjectBase.GetType() == 26
			Return E.GetGoldValue()
		ElseIf ObjectBase.GetType() == 41
			Return (e.getGoldValue() * 8) + (MaxCharge * 0.12) as Int ; Formula stolen from breezehome shop
		EndIf
	Else 
		Return 0
	EndIf
EndFunction

Function CreateWeaponEnchantment(Enchantment E, Int HandSlot, Float MaxCharge)
	Int i = E.GetNumEffects()
	MagicEffect[] Effects
	Float[] Magnitudes
	Int[] Areas
	Int[] Durations
	
	If i == 1 ; Taking the piss now
		Effects = new MagicEffect[1]
		Magnitudes = new Float[1]
		Areas = new Int[1]
		Durations = new Int[1]
	ElseIf i == 2
		Effects = new MagicEffect[2]
		Magnitudes = new Float[2]
		Areas = new Int[2]
		Durations = new Int[2]
	ElseIf i == 3
		Effects = new MagicEffect[3]
		Magnitudes = new Float[3]
		Areas = new Int[3]
		Durations = new Int[3]
	ElseIf i == 4
		Effects = new MagicEffect[4]
		Magnitudes = new Float[4]
		Areas = new Int[4]
		Durations = new Int[4]
	Else
		Debug.Trace("_MWA_: Error - CreateWeaponEnchantment() - Too many effects")
		Return
	EndIf
	While i > 0
		i -= 1
		Effects[i] = E.GetNthEffectMagicEffect(i)
		Magnitudes[i] = E.GetNthEffectMagnitude(i)
		Areas[i] = E.GetNthEffectArea(i)
		Durations[i] = E.GetNthEffectDuration(i)
	EndWhile
	WornObject.CreateEnchantment(PlayerRef, handSlot, 0, MaxCharge, Effects, Magnitudes, Areas, Durations)
EndFunction

Int Function GetCachedDurability(Form akBaseObject)
	If akBaseObject.HasKeyword(DaedricArtifact)
		Return -1
	EndIf
	If akBaseObject as Armor
		ArmorAddon SelectAA = (akBaseObject as Armor).GetNthArmorAddon(0)
		If SelectAA != None
			Return StorageUtil.GetIntValue(SelectAA, "_MWA_StandardDurability", -1)
		Else
			Return StorageUtil.GetIntValue(akBaseObject, "_MWA_StandardDurability", -1)
		EndIf
		
	Else
		Static WeaponModel = (akBaseObject as Weapon).GetEquippedModel()
		If WeaponModel != None
			Return StorageUtil.GetIntValue(WeaponModel, "_MWA_StandardDurability", -1)
		Else
			Return StorageUtil.GetIntValue(akBaseObject, "_MWA_StandardDurability", -1)
		EndIf
	EndIf
EndFunction

Function SetCachedDurability(Form akBaseObject, Int Durability)
	If akBaseObject.HasKeyword(DaedricArtifact)
		Return
	EndIf
	If akBaseObject as Armor
		ArmorAddon SelectAA = (akBaseObject as Armor).GetNthArmorAddon(0)
		If SelectAA != None
			StorageUtil.SetIntValue(SelectAA, "_MWA_StandardDurability", Durability)
		Else
			StorageUtil.SetIntValue(akBaseObject, "_MWA_StandardDurability", Durability)
		EndIf
		
	Else
		Static WeaponModel = (akBaseObject as Weapon).GetEquippedModel()
		If WeaponModel != None
			StorageUtil.SetIntValue(WeaponModel, "_MWA_StandardDurability", Durability)
		Else
			StorageUtil.SetIntValue(akBaseObject, "_MWA_StandardDurability", Durability)
		EndIf
	EndIf
EndFunction

Float Function GetCachedDurabilityBonus(Form akBaseObject)
	If akBaseObject.HasKeyword(DaedricArtifact)
		Return -1.0
	EndIf
	If akBaseObject as Armor
		ArmorAddon SelectAA = (akBaseObject as Armor).GetNthArmorAddon(0)
		If SelectAA != None
			Return StorageUtil.GetFloatValue(SelectAA, "_MWA_MaterialDurabilityBonus", -1.0)
		Else
			Return StorageUtil.GetFloatValue(akBaseObject, "_MWA_MaterialDurabilityBonus", -1.0)
		EndIf
		
	Else
		Static WeaponModel = (akBaseObject as Weapon).GetEquippedModel()
		If WeaponModel != None
			Return StorageUtil.GetFloatValue(WeaponModel, "_MWA_MaterialDurabilityBonus", -1.0)
		Else
			Return StorageUtil.GetFloatValue(akBaseObject, "_MWA_MaterialDurabilityBonus", -1.0)
		EndIf
	EndIf
EndFunction

Function SetCachedDurabilityBonus(Form akBaseObject, Float Durability)
	If akBaseObject.HasKeyword(DaedricArtifact)
		Return
	EndIf
	If akBaseObject as Armor
		ArmorAddon SelectAA = (akBaseObject as Armor).GetNthArmorAddon(0)
		If SelectAA != None
			StorageUtil.SetFloatValue(SelectAA, "_MWA_MaterialDurabilityBonus", Durability)
		Else
			StorageUtil.SetFloatValue(akBaseObject, "_MWA_MaterialDurabilityBonus", Durability)
		EndIf
		
	Else
		Static WeaponModel = (akBaseObject as Weapon).GetEquippedModel()
		If WeaponModel != None
			StorageUtil.SetFloatValue(WeaponModel, "_MWA_MaterialDurabilityBonus", Durability)
		Else
			StorageUtil.SetFloatValue(akBaseObject, "_MWA_MaterialDurabilityBonus", Durability)
		EndIf
	EndIf
EndFunction

Function ClearCachedDurabilityData(Form akBaseObject)
	If akBaseObject as Armor
		ArmorAddon SelectAA = (akBaseObject as Armor).GetNthArmorAddon(0)
		If SelectAA != None
			StorageUtil.UnSetIntValue(SelectAA, "_MWA_StandardDurability")
			StorageUtil.UnSetFloatValue(SelectAA, "_MWA_MaterialDurabilityBonus")
		Else
			StorageUtil.UnSetIntValue(akBaseObject, "_MWA_StandardDurability")
			StorageUtil.UnSetFloatValue(akBaseObject, "_MWA_MaterialDurabilityBonus")
		EndIf
		
	Else
		StorageUtil.UnSetIntValue(akBaseObject, "_MWA_StandardDurability")
		StorageUtil.UnSetFloatValue(akBaseObject, "_MWA_MaterialDurabilityBonus")
	EndIf
EndFunction

Int Function GetBaseDurability(Form akBaseObject)
	Int Durability
	If akBaseObject as Armor
		Armor akArmorObject = akBaseObject as Armor
		If akArmorObject.GetWeightClass() == 1
			Durability = Menu.HeavyDurability
		ElseIf akArmorObject.GetWeightClass() == 0
			Durability = Menu.LightDurability
		Else ; We'll just assume everything else is clothing
			Durability = Menu.ClothesDurability
		EndIf

	Else ; Weapon
		Int WeaponType = (akBaseObject as Weapon).GetWeaponType()
		If WeaponType == 1 || WeaponType == 3 || WeaponType == 4 ; sword, axe, mace
			Durability = Menu.OneHDurability
		ElseIf WeaponType == 5 || WeaponType == 6 ; Greatswords, Battleaxes AND warhammers.... :S
			Durability = Menu.TwoHDurability
		ElseIf WeaponType == 7 || WeaponType == 9 ; Bows, crossbows
			Durability = Menu.RangedDurability
		ElseIf WeaponType == 2 ; Daggers
			Durability = Menu.DaggerDurability
		ElseIf WeaponType == 8 ; Staves
			Durability = Menu.StaffDurability
		EndIf
	EndIf
	Return Durability
EndFunction

Int Function GetDurability(ObjectReference ObjRef, Form akBaseObject, Bool ForceUpdate = false, Bool IsWorn = false) ; Returns items durability. Also sets up the durability if it hasn't already been set up
	;float ftimeStart = Utility.GetCurrentRealTime()
	Int Durability = StorageUtil.GetIntValue(ObjRef, "_MWA_Durability", missing = -1)
	If Durability == -1 || ForceUpdate
		
		
		Int StandardDurability = GetCachedDurability(akBaseObject)
		If StandardDurability == -1 ; If not cached then calculate durability
			;Debug.Trace("_MWA_: Cache Miss: GetDurability: Name: " + akBaseObject.GetName())
			
			Float JunkFactor = 1.0
			If _MWA_JunkObjects.HasForm(akBaseObject)
				JunkFactor = 0.20
			EndIf
			
			If akBaseObject as Armor
				Armor akArmorObject = akBaseObject as Armor
				If akArmorObject.GetWeightClass() == 1
					Durability = Menu.HeavyDurability
				ElseIf akArmorObject.GetWeightClass() == 0
					Durability = Menu.LightDurability
				Else ; We'll just assume everything else is clothing
					Durability = Menu.ClothesDurability
				EndIf
			
			Else ; Weapon
				Int WeaponType = (akBaseObject as Weapon).GetWeaponType()
				If WeaponType == 1 || WeaponType == 3 || WeaponType == 4 ; sword, axe, mace
					Durability = Menu.OneHDurability
				ElseIf WeaponType == 5 || WeaponType == 6 ; Greatswords, Battleaxes AND warhammers.... :S
					Durability = Menu.TwoHDurability
				ElseIf WeaponType == 7 || WeaponType == 9 ; Bows, crossbows
					Durability = Menu.RangedDurability
				ElseIf WeaponType == 2 ; Daggers
					Durability = Menu.DaggerDurability
				ElseIf WeaponType == 8 ; Staves
					Durability = Menu.StaffDurability
				EndIf
				
			EndIf
			Durability = Math.Ceiling(Durability * JunkFactor)
			SetCachedDurability(akBaseObject, Durability)
			_MWA_DurInitializedForms.AddForm(akBaseObject)
		
		Else
			Durability = StandardDurability ; Else use 'cached' Durability
			;Debug.Trace("_MWA_: Cache Hit: GetDurability: Name: " + akBaseObject.GetName() + " - " + Durability)
		EndIf
		
		Durability = Durability + Utility.RandomInt(-(Math.Floor(Durability * (Menu.DurabilityTolerance/100.0))), Math.Floor(Durability * (Menu.DurabilityTolerance/100.0)))
		If akBaseObject.HasKeyword(ArmorShield) && Math.LogicalAnd((akBaseObject as Armor).GetSlotMask(), 512) == 512; Increase the durability of shields
			Durability = Math.Ceiling(Durability * Menu.ShieldDurabilityMod)
		EndIf
		
		;float ftimeStart2 = Utility.GetCurrentRealTime()
		Float DurabilityBonus = GetMaterialDurabilityBonus(akBaseObject)
		;float ftimeEnd2 = Utility.GetCurrentRealTime()
		;Debug.Trace("_MWA_: GetMaterialDurabilityBonus() for " + akBaseObject.GetName() + " took " + (ftimeEnd2 - ftimeStart2) + " seconds to run")
		Durability += Math.Ceiling(Durability * DurabilityBonus)
		If IsWorn && !Menu.EverythingFits
			StorageUtil.SetIntValue(ObjRef, "_MWA_Durability", Utility.RandomInt(Math.Ceiling(Durability * Menu.DurabilityMin), Math.Ceiling(Durability * Menu.DurabilityMax)))
		Else
			StorageUtil.SetIntValue(ObjRef, "_MWA_Durability", Durability)
		EndIf
		If akBaseObject.HasKeyword(DaedricArtifact)
			StorageUtil.SetIntValue(ObjRef, "_MWA_DurabilityMax", Math.Ceiling(Durability * 2.5))
		Else
			StorageUtil.SetIntValue(ObjRef, "_MWA_DurabilityMax", Durability)
		EndIf
		If akBaseObject.HasKeyword(ArmorShield) ; Add increased degrade resistance to shields
			StorageUtil.SetFloatValue(ObjRef, "_MWA_DurabilityBonus", (DurabilityBonus + 0.25))
		Else
			StorageUtil.SetFloatValue(ObjRef, "_MWA_DurabilityBonus", DurabilityBonus)
		EndIf
		StorageUtil.SetFloatValue(ObjRef, "_MWA_LastHealth", ObjRef.GetItemHealthPercent())
	EndIf
	DispItemDurability(ObjRef, akBaseObject, 0.0)
	;float ftimeEnd = Utility.GetCurrentRealTime()
	;Debug.Trace("_MWA_: GetDurability() for " + akBaseObject.GetName() + " took " + (ftimeEnd - ftimeStart) + " seconds to run")
	Return Durability
EndFunction

; So many keywords... Need a better method...
; Interestingly, placing vanilla keywords locally (rather than bunched together in Init) reduced average function processing time by an average of 0.1 - 0.15 seconds.
Float Function GetMaterialDurabilityBonus(Form akBaseObject)
	If Menu.AddMaterialBonusT
		Float CachedDurabilityBonus = GetCachedDurabilityBonus(akBaseObject)
		If CachedDurabilityBonus == -1.0
			;Debug.Trace("_MWA_: Cache Miss: GetMaterialDurabilityBonus: Name: " + akBaseObject.GetName())
			; Vanilla
			If !Init.IsRequiemInstalled
				
				If akBaseObject as Armor
					; Tier 0 - Iron, Fur, forsworn, hide
						; Returned last 
					
					; Tier 0.5 - Banded Iron, Leather, studded
					If akBaseObject.HasKeyword(ArmorMaterialIronBanded) || akBaseObject.HasKeyword(ArmorMaterialLeather) || akBaseObject.HasKeyword(ArmorMaterialStudded)
						SetCachedDurabilityBonus(akBaseObject, 0.05)
						Return 0.05
					
					; Tier 1 - Steel, Bonemold, Falmer, Imperial
					ElseIf akBaseObject.HasKeyword(ArmorMaterialSteel) || akBaseObject.HasKeyword(DLC2ArmorMaterialBonemoldHeavy) || akBaseObject.HasKeyword(DLC1ArmorMaterielFalmerHeavyOriginal) || akBaseObject.HasKeyword(ArmorMaterialImperialHeavy) || akBaseObject.HasKeyword(ArmorMaterialImperialLight) || akBaseObject.HasKeyword(ArmorMaterialStormcloak) || akBaseObject.HasKeyword(ArmorMaterialBearStormcloak)
						SetCachedDurabilityBonus(akBaseObject, 0.1)
						Return 0.1
						
					; Tier 2 - Dwarven, Elven, chitin
					ElseIf akBaseObject.HasKeyword(ArmorMaterialElven) || akBaseObject.HasKeyword(ArmorMaterialDwarven) || akBaseObject.HasKeyword(DLC2ArmorMaterialChitinLight) || akBaseObject.HasKeyword(DLC2ArmorMaterialChitinHeavy)
						SetCachedDurabilityBonus(akBaseObject, 0.2)
						Return 0.2
						
					; Tier 2.5 - Elven gilded
					ElseIf akBaseObject.HasKeyword(ArmorMaterialElvenGilded) || akBaseObject.HasKeyword(DLC1ArmorMaterialFalmerHardened)
						SetCachedDurabilityBonus(akBaseObject, 0.25)
						Return 0.25
						
					; Tier 3 - Orcish, Vampire, scaled, Steel plate, Nordic, Dawnguard, blades
					ElseIf akBaseObject.HasKeyword(ArmorMaterialOrcish) || akBaseObject.HasKeyword(DLC1ArmorMaterialVampire) || akBaseObject.HasKeyword(ArmorMaterialScaled) || akBaseObject.HasKeyword(ArmorMaterialSteelPlate) || akBaseObject.HasKeyword(DLC2ArmorMaterialNordicHeavy) || akBaseObject.HasKeyword(DLC1ArmorMaterialDawnguard) || akBaseObject.HasKeyword(ArmorMaterialBlades)
						SetCachedDurabilityBonus(akBaseObject, 0.3)
						Return 0.3
						
					; Tier 4 - Ebony, Glass, Falmer Heavy 
					ElseIf akBaseObject.HasKeyword(ArmorMaterialEbony) || akBaseObject.HasKeyword(ArmorMaterialGlass) || akBaseObject.HasKeyword(DLC2ArmorMaterialStalhrimLight) || akBaseObject.HasKeyword(DLC1ArmorMaterielFalmerHeavy)
						SetCachedDurabilityBonus(akBaseObject, 0.4)
						Return 0.4
						
					; Tier 5 - Daedric, Dragonscale, dragonplate, nightingale
					ElseIf akBaseObject.HasKeyword(ArmorMaterialDaedric) || akBaseObject.HasKeyword(ArmorMaterialDragonplate) || akBaseObject.HasKeyword(ArmorMaterialDragonscale) || akBaseObject.HasKeyword(ArmorNightingale)
						SetCachedDurabilityBonus(akBaseObject, 0.5)
						Return 0.5
						
					Else
						SetCachedDurabilityBonus(akBaseObject, 0.0)
						Return 0.0
					EndIf
				
				Else ; Weapons
				
					; Tier 0 - Iron
					
					; Tier 1 - Steel, Silver, Draugr
					If akBaseObject.HasKeyword(WeapMaterialSteel) || akBaseObject.HasKeyword(WeapMaterialSilver) || akBaseObject.HasKeyword(WeapMaterialImperial) || akBaseObject.HasKeyword(WeapMaterialDraugr)
						SetCachedDurabilityBonus(akBaseObject, 0.1)
						Return 0.1
						
					; Tier 2 - Dwarven, Elven, Draugr Honed
					ElseIf akBaseObject.HasKeyword(WeapMaterialDwarven) || akBaseObject.HasKeyword(WeapMaterialElven) || akBaseObject.HasKeyword(WeapMaterialDraugrHoned)
						SetCachedDurabilityBonus(akBaseObject, 0.2)
						Return 0.2
						
					; Tier 3 - Orcish, Nordic, Dawnguard, Falmer
					ElseIf akBaseObject.HasKeyword(WeapMaterialOrcish) || akBaseObject.HasKeyword(DLC2WeaponMaterialNordic) || akBaseObject.HasKeyword(DLC1DawnguardItem) || akBaseObject.HasKeyword(WeapMaterialFalmer)
						SetCachedDurabilityBonus(akBaseObject, 0.3)
						Return 0.3
						
					; Tier 4 - Ebony, Glass, Falmer Honed, Stalhrim
					ElseIf akBaseObject.HasKeyword(WeapMaterialEbony) || akBaseObject.HasKeyword(WeapMaterialGlass) || akBaseObject.HasKeyword(WeapMaterialFalmerHoned) || akBaseObject.HasKeyword(DLC2WeaponMaterialStalhrim)
						SetCachedDurabilityBonus(akBaseObject, 0.4)
						Return 0.4
						
					; Tier 5 - Daedric, Dragon
					ElseIf akBaseObject.HasKeyword(WeapMaterialDaedric) || akBaseObject.HasKeyword(DLC1WeapMaterialDragonbone)
						SetCachedDurabilityBonus(akBaseObject, 0.5)
						Return 0.5
						
					Else
						SetCachedDurabilityBonus(akBaseObject, 0.0)
						Return 0.0
					EndIf
				EndIf
				
			Else ; Requiem 
			
				If akBaseObject as Armor
				
					; Tier 0 IRON - Iron, Fur, forsworn, hide
						; Returned last 
					
					; Tier 0.5 IRON+ - Banded Iron, Leather, studded
					If akBaseObject.HasKeyword(ArmorMaterialIronBanded) || akBaseObject.HasKeyword(ArmorMaterialLeather) || akBaseObject.HasKeyword(ArmorMaterialStudded)
						SetCachedDurabilityBonus(akBaseObject, 0.05)
						Return 0.05
					
					; Tier 1 STEEL - Steel, Bonemold, Falmer, Imperial
					ElseIf akBaseObject.HasKeyword(ArmorMaterialSteel) || akBaseObject.HasKeyword(DLC2ArmorMaterialBonemoldHeavy) || akBaseObject.HasKeyword(DLC1ArmorMaterielFalmerHeavyOriginal) || akBaseObject.HasKeyword(ArmorMaterialImperialHeavy) || akBaseObject.HasKeyword(ArmorMaterialImperialLight) || akBaseObject.HasKeyword(ArmorMaterialStormcloak) || akBaseObject.HasKeyword(ArmorMaterialBearStormcloak)
						SetCachedDurabilityBonus(akBaseObject, 0.1)
						Return 0.1
						
					; Tier 2 ADVANCED/DWARVEN - Dwarven, Elven, chitin
					ElseIf akBaseObject.HasKeyword(ArmorMaterialElven) || akBaseObject.HasKeyword(ArmorMaterialDwarven) || akBaseObject.HasKeyword(DLC2ArmorMaterialChitinLight) || akBaseObject.HasKeyword(DLC2ArmorMaterialChitinHeavy)
						SetCachedDurabilityBonus(akBaseObject, 0.2)
						Return 0.2
						
					; Tier 2.5 ELVEN/ORCISH 
					ElseIf akBaseObject.HasKeyword(ArmorMaterialOrcish) || akBaseObject.HasKeyword(DLC1ArmorMaterialVampire) || akBaseObject.HasKeyword(ArmorMaterialScaled) || akBaseObject.HasKeyword(ArmorMaterialSteelPlate) || akBaseObject.HasKeyword(DLC2ArmorMaterialNordicHeavy) || akBaseObject.HasKeyword(DLC1ArmorMaterialDawnguard) || akBaseObject.HasKeyword(ArmorMaterialBlades)
						SetCachedDurabilityBonus(akBaseObject, 0.3)
						Return 0.3
						
					; Tier 3 ELVEN+
					ElseIf akBaseObject.HasKeyword(ArmorMaterialElvenGilded) || akBaseObject.HasKeyword(DLC1ArmorMaterialFalmerHardened)
						SetCachedDurabilityBonus(akBaseObject, 0.35)
						Return 0.35
						
					; Tier 4 - Ebony, Glass, Falmer Heavy 
					ElseIf akBaseObject.HasKeyword(ArmorMaterialEbony) || akBaseObject.HasKeyword(ArmorMaterialGlass) || akBaseObject.HasKeyword(DLC2ArmorMaterialStalhrimLight) || akBaseObject.HasKeyword(DLC1ArmorMaterielFalmerHeavy)
						SetCachedDurabilityBonus(akBaseObject, 0.4)
						Return 0.4
						
					; Tier 5 - Daedric, Dragonscale, dragonplate, nightingale
					ElseIf akBaseObject.HasKeyword(ArmorMaterialDaedric) || akBaseObject.HasKeyword(ArmorMaterialDragonplate) || akBaseObject.HasKeyword(ArmorMaterialDragonscale) || akBaseObject.HasKeyword(ArmorNightingale)
						SetCachedDurabilityBonus(akBaseObject, 0.5)
						Return 0.5
						
					Else
						SetCachedDurabilityBonus(akBaseObject, 0.0)
						Return 0.0
					EndIf
					
				Else ; Weapons
				
					; Tier 0 - Iron
					
					; Tier 1 - Steel, Silver, Draugr
					If akBaseObject.HasKeyword(WeapMaterialSteel) || akBaseObject.HasKeyword(WeapMaterialSilver) || akBaseObject.HasKeyword(WeapMaterialImperial) || akBaseObject.HasKeyword(WeapMaterialDraugr)
						SetCachedDurabilityBonus(akBaseObject, 0.1)
						Return 0.1
						
					; Tier 2 - Dwarven, Nordic, Draugr Honed
					ElseIf akBaseObject.HasKeyword(WeapMaterialDwarven) || akBaseObject.HasKeyword(DLC2WeaponMaterialNordic) || akBaseObject.HasKeyword(WeapMaterialDraugrHoned)
						SetCachedDurabilityBonus(akBaseObject, 0.2)
						Return 0.2
						
					; Tier 3 - Orcish, Elven, Dawnguard, Falmer
					ElseIf akBaseObject.HasKeyword(WeapMaterialOrcish) || akBaseObject.HasKeyword(WeapMaterialElven) || akBaseObject.HasKeyword(DLC1DawnguardItem) || akBaseObject.HasKeyword(WeapMaterialFalmer)
						SetCachedDurabilityBonus(akBaseObject, 0.3)
						Return 0.3
						
					; Tier 4 - Ebony, Glass, Falmer Honed, Stalhrim
					ElseIf akBaseObject.HasKeyword(WeapMaterialEbony) || akBaseObject.HasKeyword(WeapMaterialGlass) || akBaseObject.HasKeyword(WeapMaterialFalmerHoned) || akBaseObject.HasKeyword(DLC2WeaponMaterialStalhrim)
						SetCachedDurabilityBonus(akBaseObject, 0.4)
						Return 0.4
						
					; Tier 5 - Daedric, Dragon
					ElseIf akBaseObject.HasKeyword(WeapMaterialDaedric) || akBaseObject.HasKeyword(DLC1WeapMaterialDragonbone)
						SetCachedDurabilityBonus(akBaseObject, 0.5)
						Return 0.5
						
					Else
						SetCachedDurabilityBonus(akBaseObject, 0.0)
						Return 0.0
					EndIf
				EndIf
			EndIf
		
		Else
			;Debug.Trace("_MWA_: Cache Hit: GetMaterialDurabilityBonus: Name: " + akBaseObject.GetName() + " - " + CachedDurabilityBonus)
			Return CachedDurabilityBonus
		EndIf
	Else
		Return 0.0
	EndIf
EndFunction

Function ResetWornDurabilities(Bool ResetToFullDurability = false)
	Debug.Messagebox("This make take a while. Wait for the option to turn from 'Resetting' to 'Done'")
	;Debug.Notification("_MWA_: Resetting worn object durabilities")
	Int i = StorageUtil.FormListCount(none, "_MWA_WornDestructibles") - 1
	Int Durability
	ObjectReference ObjRef
	Form akBaseObject
	While i >= 0
		ObjRef = StorageUtil.FormListGet(none, "_MWA_WornDestructibles", i) as ObjectReference
		akBaseObject = ObjRef.GetBaseObject()
		Durability = StorageUtil.GetIntValue(ObjRef, "_MWA_Durability")
		GetDurability(ObjRef, akBaseObject, ForceUpdate = true)
		If !ResetToFullDurability
			StorageUtil.SetIntValue(ObjRef, "_MWA_Durability", Durability)
		EndIf
		DispItemDurability (ObjRef, akBaseObject, 0.0)
		i -= 1
	EndWhile
	If ArmorDes.RightWeapon != None
		akBaseObject = ArmorDes.RightWeapon.GetBaseObject()
		Durability = StorageUtil.GetIntValue(ArmorDes.RightWeapon, "_MWA_Durability")
		GetDurability(ArmorDes.RightWeapon, ArmorDes.RightWeapon.GetBaseObject(), ForceUpdate = true)
		If !ResetToFullDurability
			StorageUtil.SetIntValue(ArmorDes.RightWeapon, "_MWA_Durability", Durability)
		EndIf
		DispItemDurability (ArmorDes.RightWeapon, akBaseObject, 0.0)
	EndIf
	If ArmorDes.LeftWeapon != None
		akBaseObject = ArmorDes.LeftWeapon.GetBaseObject()
		Durability = StorageUtil.GetIntValue(ArmorDes.LeftWeapon, "_MWA_Durability")
		GetDurability(ArmorDes.LeftWeapon, ArmorDes.LeftWeapon.GetBaseObject(), ForceUpdate = true)
		If !ResetToFullDurability
			StorageUtil.SetIntValue(ArmorDes.LeftWeapon, "_MWA_Durability", Durability)
		EndIf
		DispItemDurability (ArmorDes.LeftWeapon, akBaseObject, 0.0)
	EndIf
	;Debug.Notification("_MWA_: Reset worn object durabilities complete")
EndFunction

Function ClearImmuneList()
	JsonUtil.FormListClear("MWA/ImmuneObjects.json", "ImmuneList")
	JsonUtil.Save("MWA/ImmuneObjects.json")
	_MWA_ImmuneList.Revert()
EndFunction

Bool Function IsSuitable(ObjectReference ObjRef, Form akBaseObject, Bool abSilent = false)
	If Menu.SuitabilityT && !_MWA_ImmuneList.HasForm(akBaseObject)
		If akBaseObject as Weapon || akBaseObject.HasKeyword(ArmorShield)
			Return true
		
		Else
			Float Fit = StorageUtil.GetFloatValue(ObjRef, "_MWA_ArmorFit", 101.0)
			If Fit != 101.0
				If !Menu.SuitabilityBodyT
					If IsGenderMatch(ObjRef, Fit, abSilent)
						Return IsWeightMatch(akBaseObject, ObjRef, Fit, abSilent)
					Else
						Return false
					EndIf
					
				ElseIf Math.LogicalAnd((akBaseObject as armor).GetSlotMask(), 4) == 4
					If IsGenderMatch(ObjRef, Fit, abSilent)
						Return IsWeightMatch(akBaseObject, ObjRef, Fit, abSilent)				
					Else
						Return false
					EndIf
					
				Else
					Return true				
				EndIf
				
			Else ; Set fit to current weight
				Int PlayerGender = PlayerRef.GetActorBase().GetSex()
				If PlayerGender == 0
					PlayerGender = -1
				EndIf
				;StorageUtil.SetFloatValue(ObjRef, "_MWA_ArmorFit", (PlayerGender * (PlayerRef.GetActorBase().GetWeight() + 0.1)))
				;FitToPlayer(ObjRef, akBaseObject)
				Return true
			EndIf
		EndIf
	Else
		Return true
	EndIf
EndFunction

Function FitToPlayer(ObjectReference ObjRef, Form akBaseObject, Bool FitLoosely = false) ; Forces fit to fit player. Doesn't check if already fitted
	;Debug.Trace("_MWA_: FitToPlayer: " + akBaseObject.GetName())
	If akBaseObject as Armor && !akBaseObject.HasKeyword(ArmorShield)
		Int PlayerGender = PlayerRef.GetActorBase().GetSex()
		If PlayerGender == 0
			PlayerGender = -1
		EndIf
		Float Fit = PlayerRef.GetActorBase().GetWeight()
		If FitLoosely
			Fit += Utility.RandomFloat(-(Menu.SuitabilityWeight), Menu.SuitabilityWeight)
			Fit = PapyrusUtil.ClampFloat(Fit, 0.0, 100.0)
		EndIf
		StorageUtil.SetFloatValue(ObjRef, "_MWA_ArmorFit", (PlayerGender * (Fit + 0.1)))
	EndIf
EndFunction

Function FitToActor(ObjectReference ObjRef, Actor SrcActor, Form akBaseObject, ActorBase SrcActorBase = None, Bool FitLoosely = false)
	;Debug.Trace("_MWA_: FitToActor: " + akBaseObject.GetName())
	If akBaseObject as Armor && !StorageUtil.HasFloatValue(ObjRef, "_MWA_ArmorFit")
		If akBaseObject.HasKeyword(_MWA_AlwaysFits) || Menu.EverythingFits
			FitToPlayer(ObjRef, akBaseObject)
			Return
		EndIf
		If SrcActorBase == None
			SrcActorBase = SrcActor.GetLeveledActorBase()
		EndIf
		;ActorBase SrcActorBase = SrcActor.GetActorBase()
		Int Gender = SrcActorBase.GetSex()
		Float SrcActorWeight = SrcActorBase.GetWeight()
		If FitLoosely
			SrcActorWeight += Utility.RandomFloat(-(Menu.SuitabilityWeight), Menu.SuitabilityWeight)
			SrcActorWeight = PapyrusUtil.ClampFloat(SrcActorWeight, 0.0, 100.0)
		EndIf
		
		If Gender == 0
			Gender = -1
		EndIf
		StorageUtil.SetFloatValue(ObjRef, "_MWA_ArmorFit", (Gender * (SrcActorWeight + 0.1))) ; + 0.1 because otherwise weight could be 0.0 for both genders
	EndIf
EndFunction

Function FitToRandom(ObjectReference ObjRef, Form akBaseObject)
	;Debug.Trace("_MWA_: FitToRandom: " + akBaseObject.GetName())
	If akBaseObject as Armor && !StorageUtil.HasFloatValue(ObjRef, "_MWA_ArmorFit")

		Int Gender = 1 ; Fit to female by default
		Float RandFit
		If akBaseObject.HasKeyword(_MWA_AlwaysFits) || Menu.EverythingFits || Menu.ItemFitsPcChance > Utility.RandomFloat(0.0, 100) || StorageUtil.GetIntValue(ObjRef, "_MWA_IsCursedObject", Missing = -1) == 1
			FitToPlayer(ObjRef, akBaseObject)
			Return
			
		ElseIf !akBaseObject.HasKeyword(_MWA_FemaleFitOnly) && !akBaseObject.HasKeyword(_SLS_BikiniArmor) ; If doesn't have female only keyword - fit to random gender
			Debug.Trace("_MWA_: FitToRandomGender: " + akBaseObject.GetName())
			Gender = Utility.RandomInt(0, 1)
			If Gender == 0
				Gender = -1
			EndIf
			RandFit = Utility.RandomFloat(-100.0, 100.0)
			
		Else
			Debug.Trace("_MWA_: FitToFemale: " + akBaseObject.GetName())
			RandFit = Utility.RandomFloat(0.0, 100.0)
		EndIf
		RandFit = RandFit * Gender + (0.1 * Gender)
		
		;Debug.Trace("_MWA_: New: RandFit for " + ObjRef.GetBaseObject().GetName() + " = " + RandFit)
		StorageUtil.SetFloatValue(ObjRef, "_MWA_ArmorFit", RandFit)
		
	Else
		Debug.Trace("_MWA_: Already fitted: " + akBaseObject.GetName())
	EndIf
EndFunction

Bool Function IsGenderMatch(ObjectReference ObjRef, Float Fit, Bool abSilent = false)
	Int PlayerGender = PlayerRef.GetActorBase().GetSex()
	If PlayerGender == 1 ; Female
		If Fit >= 0.0
			Return True
		Else
			If !abSilent
				Debug.Notification(ObjRef.GetBaseObject().GetName() + " was made to fit men")
			EndIf
			Return False
		EndIf
	ElseIf PlayerGender == 0 ; Male
		If Fit <= 0.0
			Return True
		Else
			If !abSilent
				Debug.Notification(ObjRef.GetBaseObject().GetName() + " was made to fit women")
			EndIf
			Return False
		EndIf
	Else
		Debug.Trace("_MWA_: Error: Gender could not be determined")
	EndIf
EndFunction

Bool Function IsWeightMatch(Form akBaseObject, ObjectReference ObjRef, Float Fit, Bool abSilent = false)
	If Menu.SuitabilityWeight >= 0
		Float PlayerWeight = PlayerRef.GetActorBase().GetWeight()
		Float Tolerance

		If akBaseObject.HasKeyword(_SLS_BikiniArmor)
			Tolerance = Menu.SuitabilityBikini
		Else
			Tolerance = Menu.SuitabilityWeight
		Endif
		
		Fit = Math.Abs(Fit) ; IsGenderMatch handles that
		If ((PlayerWeight <= ((Fit - 0.1) + Tolerance)) && (PlayerWeight >= ((Fit - 0.1) - Tolerance))) ; Then good fit
			Return True
		ElseIf PlayerWeight > (Fit + 0.1)
			If !abSilent
				Debug.Notification("You are too big to fit into " + ObjRef.GetBaseObject().GetName())
			EndIf
			Return False
		Else
			If !abSilent
				Debug.Notification(ObjRef.GetBaseObject().GetName() + " is too big for you")
			EndIf
			Return False
		EndIf
	Else
		Return true
	EndIf
EndFunction

Function ClearDurabilityCaching()
	Debug.Messagebox("This make take a while depending on how many forms have been cached. Wait for the option to turn from 'Resetting' to 'Done'")
	Int i = _MWA_DurInitializedForms.GetSize()
	If i > 0
		While i > 0
			i -= 1
			ClearCachedDurabilityData(_MWA_DurInitializedForms.GetAt(i))
		EndWhile
		_MWA_DurInitializedForms.Revert()
	EndIf
EndFunction

Function RelayArmorHit(Keyword MagicEffectKeyword)
	CombatArmor.WeaponHit(abPowerAttack = false, abHitBlocked = false, MagicKeyword = MagicEffectKeyword)
EndFunction

Function DoRapeDamage()
	If !DoRapeDamageInProg
		DoRapeDamageInProg = true
		;sslSystemConfig SexlabConfig = Game.GetFormFromFile(0x000D62, "SexLab.esm") as sslSystemConfig
		;Bool[] StripSlots = SexlabConfig.StripVictim
		
		Int i = _MWA_AggSexTempWornList.GetSize()
		Debug.Trace("_MWA_: _MWA_AggSexTempWornList.GetSize() = " + i)
		ObjectReference ObjRef
		While i > 0
			i -= 1
			ObjRef = _MWA_AggSexTempWornList.GetAt(i) as ObjectReference
			If ObjRef
				Debug.Trace("_MWA_: _MWA_AggSexTempWornList. hitting: " + ObjRef.GetBaseObject().GetName())
				;Int SlotMask = (ObjRef.GetBaseObject() as Armor).GetSlotMask()
				;Int j = StripSlots.Length
				;While j > 0
				;	j -= 1
				;	If StripSlots[j] && Math.LogicalAnd(SlotMask, Armor.GetMaskForSlot(j + 30)) == Armor.GetMaskForSlot(j + 30)
				;		Debug.MessageBox("_MWA_: _MWA_AggSexTempWornList. hitting: " + ObjRef.GetBaseObject().GetName())
						CombatArmor.ArmorHit(ObjRef, 999, false, 0, akSource = None, MagicKeyword = None, NumOfHits = Utility.RandomInt(Menu.RapeMinDamage, Menu.RapeMaxDamage), Sender = None)
				;		If PlayerRef.IsEquipped(ObjRef.GetBaseObject())
				;			PlayerRef.UnequipItem(ObjRef.GetBaseObject())
				;		EndIf
				;	EndIf
				;EndWhile
				
			EndIf
		EndWhile
		Utility.Wait(10.0)
		DoRapeDamageInProg = false
	EndIf
EndFunction

Bool Function HasNoStripKeyword(Form akBaseObject)
	If Init.IsSexlabInstalled
		If akBaseObject.HasKeyword(Init.SexlabNoStripKw)
			Return true
		EndIf
	EndIf
	Return false
EndFunction

Bool Function HasZadInvDeviceKeyword(Form akBaseObject)
	If Init.IsDdInstalled
		If akBaseObject.HasKeyword(Init.zad_InventoryDevice)
			Return true
		EndIf
	EndIf
	Return false
EndFunction

Function AddImmunity(ObjectReference akReference, Form akBaseObject, Bool AddImmunity)
	If AddImmunity
		_MWA_ImmuneList.AddForm(akBaseObject)
		JsonUtil.FormListAdd("MWA/ImmuneObjects.json", "ImmuneList", akBaseObject, allowDuplicate = false)
		JsonUtil.Save("MWA/ImmuneObjects.json")
		If akReference != None
			;Util.UnPersist(akReference, _MWA_ArmorTrack, "_MWA_ArmorTrackAliasList", Init.ArmorTrackAliasCount)
			InvUtil.ClearImmuneObjectsFromInvList(akBaseObject)
			;akReference.SetDisplayName(Util.GetDynamicName(akReference))
			RefreshInventory()
		EndIf
		Debug.Notification("Finished adding " + akBaseObject.GetName() + " to immune list")
		Debug.Messagebox("Finished adding " + akBaseObject.GetName() + " to immune list. Please exit the menu and return to the game to complete.")
		WornListRemove(akReference, "_MWA_AddImmunity: Remove", -1)
		
	Else
		_MWA_ImmuneList.RemoveAddedForm(akBaseObject)
		JsonUtil.FormListRemove("MWA/ImmuneObjects.json", "ImmuneList", akBaseObject, allInstances = true)
		JsonUtil.Save("MWA/ImmuneObjects.json")
		Debug.Notification(akBaseObject.GetName() + " removed from immune list")
		Debug.Messagebox(akBaseObject.GetName() + " removed from immune list. You will have to drop these objects from your inventory and pick them back up to register them with the mod")
		PlayerRef.UnequipItem(akBaseObject)
		;/ Dont work
		If akReference != None
			akReference.MoveTo(PlayerRef, afZOffset = -20.0)
			;PlayerRef.DropObject(akReference)
			PlayerRef.AddItem(akReference)
			PlayerRef.EquipItem(akReference)
		EndIf
		/;
	EndIf
EndFunction

Function RemoveFoodFromTarget(ObjectReference akTargetRef)
	akTargetRef.AddItem(_MWA_FoodProcToken, 1)
	Form akItem
	Int i = akTargetRef.GetNumItems()
	While i > 0
		i -= 1
		akItem = akTargetRef.GetNthForm(i)
		If akItem as Potion
			If (akItem.HasKeyword(VendorItemFood) || akItem.HasKeyword(VendorItemFoodRaw)) && !akItem.HasKeyword(MME_Milk)
				If Menu.RemoveFoodCANs >= Utility.RandomFloat(0.0, 100.0)
					akTargetRef.RemoveItem(akItem, akTargetRef.GetItemCount(akitem))
				EndIf
			EndIf
		EndIf
	EndWhile
EndFunction

Function RemoveLockpicksFromTarget(ObjectReference akTargetRef)
	akTargetRef.AddItem(_MWA_LockpickProcToken, 1)
	If Menu.RemoveLockpicks >= Utility.RandomFloat(0.0, 100.0)
		akTargetRef.RemoveItem(Lockpick, akTargetRef.GetItemCount(Lockpick))
	EndIf
EndFunction

Function SetLockpickValue()
	Lockpick.SetGoldValue(Menu.LockpickValue)
EndFunction

Bool DoRapeDamageInProg = false
Bool Property DegradeInProgress = false Auto Hidden
;Float Property TemperFloor = 1.0999999 Auto Hidden
Float Property TemperFloor = 1.1 Auto Hidden
Bool Property IsInStore = false Auto Hidden

_MWA_Mcm Property Menu Auto
_MWA_Init Property Init Auto
_MWA_ArmorDestruction Property ArmorDes Auto

Faction Property _MWA_TailorFaction Auto
Faction Property JobBlacksmithFaction Auto

Actor Property PlayerRef Auto

ObjectReference Property _MWA_DurRepairSpecificContainer Auto
ObjectReference Property _MWA_CellChangeDetectObjRef Auto
ObjectReference Property _MWA_SanctifyBarrelRef Auto

GlobalVariable Property _MWA_FixCost Auto

MiscObject Property Gold001 Auto
MiscObject Property Lockpick Auto
MiscObject Property _MWA_InvRefreshObject Auto
MiscObject Property _MWA_FoodProcToken Auto
MiscObject Property _MWA_LockpickProcToken Auto

Formlist Property _MWA_ImmuneList Auto
Formlist Property _MWA_DurInitializedForms Auto
Formlist Property _MWA_JunkObjects Auto
Formlist Property _MWA_AggSexTempWornList Auto

Message Property _MWA_RepairConfirm Auto

Keyword Property ArmorClothing Auto
Keyword Property ArmorLight Auto
Keyword Property ArmorHeavy Auto
Keyword Property ArmorShield Auto
Keyword Property DaedricArtifact Auto
Keyword Property _MWA_Broken Auto
Keyword Property _MWA_FemaleFitOnly Auto
Keyword Property _MWA_AlwaysFits Auto
Keyword Property _MWA_DummyNeverUsedKw Auto
Keyword Property _SLS_BikiniArmor Auto Hidden
Keyword Property VendorItemFood Auto
Keyword Property VendorItemFoodRaw Auto
Keyword Property MME_Milk Auto Hidden

Keyword Property ArmorMaterialDaedric Auto
Keyword Property ArmorMaterialDragonplate Auto
Keyword Property ArmorMaterialDragonscale Auto
Keyword Property ArmorMaterialEbony Auto
Keyword Property ArmorMaterialElven Auto
Keyword Property ArmorMaterialElvenGilded Auto
Keyword Property ArmorMaterialSteel Auto
Keyword Property ArmorMaterialGlass Auto
Keyword Property ArmorMaterialImperialHeavy Auto
Keyword Property ArmorMaterialImperialLight Auto
Keyword Property ArmorMaterialStormcloak Auto
Keyword Property ArmorMaterialBearStormcloak Auto
Keyword Property ArmorMaterialHide Auto
Keyword Property ArmorMaterialIron Auto
Keyword Property ArmorMaterialLeather Auto
Keyword Property ArmorMaterialOrcish Auto
Keyword Property ArmorNightingale Auto
Keyword Property ArmorMaterialScaled Auto
Keyword Property ArmorMaterialSteelPlate Auto
Keyword Property ArmorMaterialStudded Auto
Keyword Property ArmorMaterialIronBanded Auto
Keyword Property ArmorMaterialDwarven Auto
Keyword Property ArmorMaterialBlades Auto

Keyword Property DLC1ArmorMaterialDawnguard Auto Hidden
Keyword Property DLC1ArmorMaterialVampire Auto Hidden
Keyword Property DLC1ArmorMaterielFalmerHeavy Auto Hidden
Keyword Property DLC1ArmorMaterielFalmerHeavyOriginal Auto Hidden
Keyword Property DLC1ArmorMaterialFalmerHardened Auto Hidden
Keyword Property DLC2ArmorMaterialBonemoldHeavy Auto Hidden
Keyword Property DLC2ArmorMaterialChitinLight Auto Hidden
Keyword Property DLC2ArmorMaterialChitinHeavy Auto Hidden
Keyword Property DLC2ArmorMaterialNordicHeavy Auto Hidden
Keyword Property DLC2ArmorMaterialStalhrimLight Auto Hidden

Keyword Property WeapMaterialWood Auto
Keyword Property WeapMaterialIron Auto
Keyword Property WeapMaterialSteel Auto
Keyword Property WeapMaterialDwarven Auto
Keyword Property WeapMaterialElven Auto
Keyword Property WeapMaterialOrcish Auto
Keyword Property WeapMaterialGlass Auto
Keyword Property WeapMaterialEbony Auto
Keyword Property WeapMaterialDaedric Auto
Keyword Property WeapMaterialDraugr Auto
Keyword Property WeapMaterialDraugrHoned Auto
Keyword Property WeapMaterialFalmer Auto
Keyword Property WeapMaterialFalmerHoned Auto
Keyword Property WeapMaterialImperial Auto
Keyword Property WeapMaterialSilver Auto

Keyword Property DLC1WeapMaterialDragonbone Auto Hidden
Keyword Property DLC1DawnguardItem Auto Hidden
Keyword Property DLC2WeaponMaterialNordic Auto Hidden
Keyword Property DLC2WeaponMaterialStalhrim Auto Hidden

_MWA_ObjectEquipMonitor Property ObjectEquipMonitor Auto

_MWA_PlayerInventoryTrackAdded Property InvTrackAdd Auto
_MWA_PlayerInventoryTrackRemoved Property InvTrackRemove Auto
_MWA_CombatArmor Property CombatArmor Auto
_MWA_SanityChecker Property SanityChecker Auto
_MWA_PlayerInventoryUtil Property InvUtil Auto
